var labelStyle = {color: "#fff", fontWeight:300,fontFamily: 'ubuntu'};
var isTouch = 'ontouchstart' in document.documentElement;
if(!isTouch) {$('html').removeClass('touch').addClass('no-touch');}
var haveGPS = false, wiset="ms",wunit,utcdiff,favotimeout,strData,choosedDay=0,twidth,maxGraph,minGraph,compGraph,fullGraph;
var tempdata=[],precdata=[],barodata=[],dewdata=[],feeldata=[],tsdata=[],svgdata=[],windtip=[];
var compfmi=[],compyr=[],compsmhi=[],comparome=[],compmf=[],compdwd=[],compknmi=[],compgfs=[],compcmc=[],compwxsim=[];
var accloaded=false,map2;
var gridlyOptions={base:0,gutter:5,callbacks:{reordered:favoupd}};

var basepath="maps.nordicweather.net",frcfps=1000;
var wsmap,lightmap,dlines,is_phone,currid,mettableid,mStep,mTime,layerPath=defmap,windy,canvasOverlay,timer=null;
var wxLayer,wxTimeLayer,windyCache=[],isPlaying=-1,windColorDark="#333333",windColorLight="#ffffff",windColor=windColorLight;
var screenheight = $(window).height();
var screenwidth = $(window).width();
$("#mapwrapper, #map").css({height: screenheight+"px"});

var now = Date.now();
var age = 9999999;
if($.cookie("frcloc")){
  var frcloc = JSON.parse($.cookie("frcloc"));
  age = now - frcloc.time;
  if(!isTouch){$.removeCookie("frcloc");}
}
if(isTouch && age > 3600000){
  if(navigator.geolocation){
    initload = false;
    function positionSuccess(location) {
      geo={lat:location.coords.latitude,lon:location.coords.longitude,time:now};
      $.jStorage.set("frcloc", JSON.stringify(geo));
      $.jStorage.setTTL("frcloc", 3600000);
      $.cookie("frcloc", JSON.stringify(geo), { expires : 1 });
      lat=location.coords.latitude;
      lon=location.coords.longitude;
      url='//'+window.location.hostname+window.location.pathname+'?lang='+lang+'&lat='+location.coords.latitude+'&lon='+location.coords.longitude+p;
      window.location.href=url;
    }
    function positionFail(failure){}
    var options = { enableHighAccuracy: true,timeout: 10000,maximumAge: 240000};
    navigator.geolocation.getCurrentPosition(positionSuccess, positionFail,options);
  }
}

(function(){

  $('[data-toggle="tooltip"]').tooltip();
  $('[data-toggle="popover"]').popover();
  
  $("#favostar").html("<i class='fa fa-star-o favostar'></i>");
  $("#locateme").click(function(){locateme();});
  
  if($.jStorage.get("ewnwunit")){
    wiset=$.jStorage.get("ewnwunit");
    $.cookie("ewnwunit", wiset, { expires : 365 });
  }
  wunit=getWunit(wiset);
  $("#"+wiset).prop("checked", true);
  $(".wunitbox").change(function(){
    wiset=$('input[name=wunit]:checked').attr('id');
    $.jStorage.set("ewnwunit", wiset);
    $.jStorage.setTTL("ewnwunit", 32000000000);
    $.cookie("ewnwunit", wiset, { expires : 365 });
    wunit=getWunit(wiset);
    gettopbox(strData.data);
    getDaily(strData.daily);
    if($('.frcnavs[data-id="table"]').hasClass("selected")){getTable(choosedDay);}
    if($('.frcnavs[data-id="graph"]').hasClass("selected")){getGraph(choosedDay);}
    docurr();
  });
  getData();
  
  if($.jStorage.get("ewnfavo")){
    ewnfavo=$.jStorage.get("ewnfavo");
    $.cookie("ewnfavo", JSON.stringify(ewnfavo), { expires : 365 });
    getfavotable(ewnfavo,true);
  }
  
  if($.jStorage.get("frcfps")){frcfps=$.jStorage.get("frcfps");}
  
  /*##############################################################################################*/
  
  $("#favloc").on("click", function() {
    $("#favobox").toggle(250, rungridly);
  });
  
  $("#favostar .favostar").on("click", function() {
    if($(this).hasClass("fa-star-o")) {
      $("#favostar .favostar").removeClass("fa-star-o").addClass("fa-star");
      var brick="<div class='brick' data-id='"+geoid+"' data-co='"+co+"' data-na='"+name+"'>"+
        "<i class='delete fa fa-times favodel'></i><i class='fa fa-arrows-v'></i><span data-id='"+geoid+"'>"+name+"</span></div>";
      $('.gridly').append(brick);
      $("#favobarlink").show();  
    }else{
      $('.brick[data-id="'+geoid+'"]').remove();
      $("#favostar .favostar").removeClass("fa-star").addClass("fa-star-o");
    }
    favoupd();
    if($('#favobox').is(':visible')){
      rungridly();
    }
  });
  
  $(".frcnavs").on("click", function() {
    $("#frctable, #graphtable, #mapwrapper, #comptable").hide();
    $('.frcnavs').removeClass("selected");
    $(this).addClass("selected");
    fg=$(this).attr("data-id");
    if(fg=="table"){$("#frctable").show();getTable(choosedDay);}
    if(fg=="graph"){$("#graphtable").show();getGraph(choosedDay);}
    if(fg=="maps"){$("#mapwrapper").show();if(typeof wsmap === 'undefined'){loadmaps();}}
    if(fg=="accuracy"){$("#comptable").show();getComps();}
  });
  
  $("#wunitlink").on("click", function() {
    if($('#wunitbar').is(':visible')){
      $("#wunitbar").hide();
    }else{
      $("#wunitbar").show();
    }
  });
  
  /*$("#currcontent").appear(function() {
    //docurr();
  });*/
  
  /*##############################################################################################
    # SEARCH 
  */

  $('#searchflag').popover({template: '<div class="popover popover-flags"><div class="arrow"></div><div class="popover-inner"><h3 class="popover-title"></h3><div class="popover-content"><p></p></div></div></div>'});
  
  $('#searchflag').on('shown.bs.popover', function () {
    $("#flagclose").click(function(){$("#searchflag").popover("hide");});
    $(".popoverflags").click(function(){
      $("#searchflag").removeClass();
      var co = $(this).attr("data-country");
      $("#searchflag").addClass("knob");
      $("#searchflag").addClass("knob-"+co.toUpperCase());
      $("#searchflag").attr('data-co',co);
      $('#searchflag').popover('hide');
    });
  });
  
  $("#city").autocomplete({
    source: function( request, response ) {
      $.ajax({
        url: "https://euweather.eu/backend/misc/yrdb2.php",
        dataType: "jsonp",
        cache: true,
        jsonpCallback: "yrplacequery",
        data: {maxRows: 20,term: request.term,country: $("#searchflag").attr("data-co")},
        success: function( data ) {
          act='Q';
          response( $.map( data.geonames, function( item ) {
            return {label:item.name,desc:"<small>("+item.area+")</small>",value:item.name,lat:item.lat,lon:item.lon,idnum:item.idnum,fclass:item.fclass,fcode:item.fcode}
          }));
        }
      });
    },
    minLength: 2,
    select: function( event, ui ) {
      if(p!=''){
        url='//'+window.location.hostname+window.location.pathname+'?fl='+$("#searchflag").attr("data-co")+'&lang='+lang+'&geoid='+ui.item.idnum+'&city='+ui.item.value+p;
      }else{
        ci=ui.item.value.replace(", ","|");
        ci=ci.replace(" ","_");
        url='//'+window.location.hostname+window.location.pathname+'?'+lang+'|'+ui.item.idnum+'|'+$("#searchflag").attr("data-co")+'|'+ci
      }
      window.location.href=url;
    },
  }).data( "autocomplete" )._renderItem = function( ul, item ) {
    ul.css({zIndex:999999999});
    if(act=="Q"&&item.fclass=="P"){$( "<li class='q'><span class='wxsearch-administration'></span>"+txtqa+"...</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="T"){$( "<li class='q'><span class='wxsearch-mountain'></span>"+txtqb+"...</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="H"){$( "<li class='q'><span class='wxsearch-boat'></span>"+txtqc+"...</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="AIRS"){$( "<li class='q'><span class='wxsearch-aeroplane'></span>"+txtqd+"...</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="GOC"){$( "<li class='q'><span class='wxsearch-golf'></span>"+txtqe+"</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="SKI"){$( "<li class='q'><span class='wxsearch-skiing'></span>"+txtqf+"</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="BEA"){$( "<li class='q'><span class='wxsearch-person'></span>"+txtqg+"</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="ZOO"){$( "<li class='q'><span class='wxsearch-dog'></span>"+txtqh+"</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="VAR"){$( "<li class='q'><span class='wxsearch-question'></span>"+txtqv+"</li>" ).appendTo(ul);}
    if(act!=item.fclass&&item.fclass=="PAR"){$( "<li class='q'><span class='wxsearch-park'></span>"+txtqi+"</li>" ).appendTo(ul);}
    act=item.fclass;
    return $( "<li></li>" )
      .data( "item.autocomplete", item )
      .append( "<a>" + item.label + "<br>" + item.desc + "</a>" )
      .appendTo( ul );
  }
   
})(jQuery)

/*##############################################################################################
  # FORECAST 
*/

function getData(){
  var dpath = "https://euweather.eu/backend/frc/frc_2016.php?api=1&compare=1&accuracy=1&currcond=1&lat="+lat+"&lon="+lon+"&wunit="+wiset+"&lang="+lang+"&tk="+tk;
  wget([dpath], function(points) {
    strData=JSON.parse(points);
    utcdiff=strData["location"]["utcdiff"];
    twidth=$("#frctblhead").width();
    $("#loading").hide();
    $("#frcinfotop").show();
    gettopbox(strData.data);
    getMAlarm(strData.MAlarm);
    getDaily(strData.daily);
    getTable(0);
    docurr();
    geoiplat=strData["geoip"]["lat"];
    geoiplon=strData["geoip"]["lon"];
  });
}

function gettopbox(data){
  $("#frctopclock span").html(data[0].time);
  $("#frctopicon").html('<svg class="svg-ic svg-ictop" viewBox="0 0 512 512"><g>'+geticon(data[0].icon)+'</g></svg>');
  $("#frctoptemp span").html(Math.round(data[0].temp)+'&deg;').css({color:data[0].tempRoundedColor});
  $("#frctopwind").html('<i class="wi wi-wind from-'+data[0].wdir+'-deg" style="font-size:20px;top:-4px;"></i><span id="topwind">'+Math.round(fixWspd(data[0].wspd))+' '+wunit+'</span>');
  $("#toprain").html(data[0].prec+' mm');
  $("#toppop").html(fixPop(data[0].pop)+'%');
  $("#topts").html(fixTs(data[0].tsrisk)+'%');
  $("#topsnow").html(fixSnowfall(data[0].prec,data[0].temp)+' cm');
  if(data[0].temp<5){$("#frctoplight").hide();}else{$("#frctopsnow").hide();}
}

function getMAlarm(data){
  if(data.length>0){
    $.each(data, function(i, item) {
      $("#frcMAlarm").append('<div style="display:flex;padding:5px"><div id="frcMAlarmIcon'+i+'"></div><div id="frcMAlarmText'+i+'"></div></div>');
      $("#frcMAlarmIcon"+i).html('<span class="flr awt '+item["type"]+'" style="margin: 4px 8px 4px 6px;"></span>');
      $("#frcMAlarmText"+i).html(item["desc"]);
    });
  }
}

function getDaily(data){
  d=0;
  $("#dailyCarousel .touchcarousel-container").html("");
  $.each(data, function(i, item) {
    if(item.prec>0&&item.prec<1){pre="<1";}else{pre=Math.round(item.prec);}
    dco='<li class="touchcarousel-item" data-id="'+d+'">'+
      '<div class="dayname">'+item.day+'</div>'+
      '<div class="dayic"><svg class="svg-ic svg-icday" viewBox="0 0 512 512"><g>'+geticon(item.icon)+'</g></svg></div>'+
      '<div class="daytemps">'+
        '<div class="daytemp" style="color:'+item.minTempRoundedColor+'">'+Math.round(item.minTemp)+'&deg;</div>'+
        '<div class="daytemp" style="color:'+item.maxTempRoundedColor+'">'+Math.round(item.maxTemp)+'&deg;</div></div>'+
      '<div class="frcdayrest">'+
        '<i class="wi wi-raindrops" style="color:#4F94CD;font-size:30px;top:3px;left:0px"></i><span class="dayrain">'+pre+' mm</span>'+
        '<i class="wi wi-wind from-'+item.wdir+'-deg" style="font-size:20px;top:-3px;"></i><span id="daywind">'+Math.round(fixWspd(item.wspd))+' '+wunit+'</span>'+
      '</div>'+
      '</li>';
    $("#dailyCarousel .touchcarousel-container").append(dco);
    d++;
  });
  $('#dailyCarousel .touchcarousel-item[data-id="0"]').addClass("activeday");
  $("#dailyCarousel").touchCarousel({scrollbar:false});
  $("#dailyCarousel .touchcarousel-item").on("click", function() {
    $('#dailyCarousel .touchcarousel-item').removeClass("activeday");
    $(this).addClass("activeday");
    choosedDay=parseInt($(this).attr("data-id"));
    if($('.frcnavs[data-id="table"]').hasClass("selected")){ getTable(choosedDay); }
    if($('.frcnavs[data-id="graph"]').hasClass("selected")){ getGraph(choosedDay); }
  });
}

function getTable(a){
  $("#frctbl").html("");
  b=pop=ts=snow=0;
  $.each(strData.data, function(i, item) {
    if(item.day===a){
      if(b==0 && item.time=="23:00"){return true;}
      if(b%2!=0){odd=" odd";}else{odd="";}
      if(item.prec>0&&item.prec<1){pre=item.prec;}else{pre=Math.round(item.prec);} 
      if(item.snowfall>0&&item.snowfall<1){snowf=item.snowfall;}else{snowf=Math.round(item.snowfall);}
      if(twidth<=750){
        prectip=' data-toggle="tooltip" data-placement="top" title="<i class=\'wi wi-umbrella\' style=\'font-size:20px;top:0px;position: relative;margin:0 10px 0 0;\'></i>'+fixPop(item.pop)+'% <i class=\'wi wi-lightning\' style=\'color:#FFA500;font-size:20px;top:2px;position: relative;margin:0 10px;\'></i>'+fixTs(item.tsrisk)+'%"';
      }else{prectip="";}
      
      dco='<div class="frctblrow '+odd+'">'+
        '<div class="tbltime">'+item.time+'</div>'+
        '<div class="tblic"><svg class="svg-ic svg-ictbl" viewBox="0 0 512 512"><g>'+geticon(item.icon)+'</g></svg></div>'+
        '<div class="tbltemp" style="color:'+item.tempRoundedColor+'">'+Math.round(item.temp)+'&deg;</div>'+
        '<div class="tblfeel">'+Math.round(item.feels)+'&deg;</div>'+
        '<div class="tblfeel">'+getwindicon_svg(item.wspd,item.wdir,item.wgst,item.bft,wunit)+'</div>'+
        '<div class="tblfeel" data-toggle="tooltip" data-placement="top" title="'+dewtxt+': '+item.dewp+'&deg;">'+Math.round(item.rh)+'%</div>'+
        '<div class="tblfeel"'+prectip+'>'+pre+' mm</div>'+
        '<div class="tblfeel pophead">';
      if(item.pop>0 && twidth>750){
        dco+='<i class="wi wi-umbrella" style="font-size:20px;top:0px;position: relative;margin:0 10px;"></i>'+fixPop(item.pop)+'%';
        pop++;
      }
      dco+='</div><div class="tblfeel snowhead">';
      if(snowf>0 && item.temp<=1.8 && twidth>750){
        dco+='<i class="fa fa-snowflake-o" style="color:#ffffff;font-size:20px;top:2px;left:-4px;position:relative"></i>'+snowf+' cm';
        snow++;
      }
      dco+='</div><div class="tblfeel tshead">';
      if(item.tsrisk>5 && twidth>750){
        dco+='<i class="wi wi-lightning" style="color:#FFA500;font-size:20px;top:2px;position: relative;margin:0 10px;"></i>'+fixTs(item.tsrisk)+'%';
        ts++;
      }
      dco+='</div><div class="tblfeel tblbaro">'+item.prmsl+' hPa</div>'+
        '<div class="tblfeel tblcomp" data-id="comp'+b+'">'+
          '<i class="fa fa-chevron-down" style="font-size:16px;top:0px;position: relative;margin:0 10px;"></i></div>'+
      '</div>';
      $("#frctbl").append(dco);
      
      if(twidth>900){
        cco='<div id="comp'+b+'" class="tblcompdata '+odd+'" style="display:none">';
        if(typeof strData.compare[i].yr_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">MET Norway</div>'+getCompare("yr", i)+'</div>';
        }
        if(typeof strData.compare[i].fmi_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">FMI</div>'+getCompare("fmi", i)+'</div>';
        }
        if(typeof strData.compare[i].smhi_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">SMHI</div>'+getCompare("smhi", i)+'</div>';
        }
        if(typeof strData.compare[i].icon_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">DWD</div>'+getCompare("icon", i)+'</div>';
        }
        if(typeof strData.compare[i].mfarome_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">MeteoFrance Arome</div>'+getCompare("mfarome", i)+'</div>';
        }
        if(typeof strData.compare[i].mf_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">MeteoFrance Arpege</div>'+getCompare("mf", i)+'</div>';
        }
        if(typeof strData.compare[i].knmi_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">KNMI</div>'+getCompare("knmi", i)+'</div>';
        }
        if(typeof strData.compare[i].gfs_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">GFS</div>'+getCompare("gfs", i)+'</div>';
        }
        if(typeof strData.compare[i].cmc_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">CMC</div>'+getCompare("cmc", i)+'</div>';
        }
        if(typeof strData.compare[i].wxsim_temp !== 'undefined'){
          cco+='<div class="tblcomprow"><div style="flex: 2;">WXSIM</div>'+getCompare("wxsim", i)+'</div>';
        }
        cco+='</div>';
        $("#frctbl").append(cco);    
      }
      
      b++;
    }
    
  });
  
  d=0;
  $.each(strData.daily, function(i, item) {
    if(d===a){
      sm = '<div id="sunmoonday">'+item.day+'</div>';
      if(item.sunrise=="midnightsun"){
        sm+= '<div><i class="wi wi-sunrise sunicon"></i>'+txtmidnightsun+'</div>';
      }else if (item.sunrise=="polarnight"){
        sm+= '<div><i class="wi wi-sunset sunicon"></i>'+txtpolarnight+'</div>';
      }else{
        sm+= '<div><i class="wi wi-sunrise sunicon"></i>'+item.sunrise+'</div>'+
          '<div><i class="wi wi-sunset sunicon"></i>'+item.sunset+'</div>';
      }
      if(twidth>750){
        sm+= '<div><i class="wi wi-moonrise moonicon"></i>'+item.moonrise+'</div>'+
          '<div><i class="wi wi-moonset moonicon"></i>'+item.moonset+'</div>'+
          '<div><i class="wi wi-moon-'+item.moonage+' moonicon"></i></div>';
      }
      $("#sunmoon").html(sm);
    }
    d++;
  });
  
  if(pop>0){$(".pophead").show();}else{$(".pophead").hide();}
  if(ts>0){$(".tshead").show();}else{$(".tshead").hide();}
  if(snow>0){$(".snowhead").show();}else{$(".snowhead").hide();}
  $('[data-toggle="tooltip"]').tooltip({html:true});
  $(".tblcomp").unbind().on("click", function() {  
    fco=$(this).attr("data-id");
    if($("#"+fco).is(":hidden")){
      $("#"+fco).addClass("show");
      $('.tblcomp[data-id="'+fco+'"] i').removeClass("fa-chevron-down").addClass("fa-chevron-up");
    }else{
      $("#"+fco).removeClass("show");
      $('.tblcomp[data-id="'+fco+'"] i').removeClass("fa-chevron-up").addClass("fa-chevron-down");
    }
  });
    
}

function getGraph(a){
  tempdata=[],precdata=[],barodata=[],dewdata=[],feeldata=[],tsdata=[],svgdata=[],windtip=[];
  compfmi=[],compyr=[],compsmhi=[],comparome=[],compmf=[],compknmi=[],compdwd=[],compgfs=[],compcmc=[],compwxsim=[];
  day1Max = strData.data[0].timestamp+(24*3600);
  day1Min = strData.data[0].timestamp;
  $.each(strData.data, function(i, item) {
    if(a===item.day||(a==0&&item.timestamp>=day1Min&&item.timestamp<=day1Max)||fullGraph){
      tstamp=item.timestamp*1000;
      tempdata.push([tstamp, parseFloat(item.temp)]);
      feeldata.push([tstamp, parseFloat(item.feels)]);
      dewdata.push([tstamp, parseFloat(item.dewp)]);
      precdata.push([tstamp, parseFloat(item.prec)]);
      tsdata.push([tstamp, parseFloat(item.tsrisk)]);
      barodata.push([tstamp, parseFloat(item.prmsl)]);
      windtip.push([tstamp, parseFloat(fixWspd(item.wspd))]);
      if(typeof strData.compare[i].fmi_temp !== 'undefined'){compfmi.push([tstamp, parseFloat(strData.compare[i].fmi_temp)]);}
      if(typeof strData.compare[i].yr_temp !== 'undefined'){compyr.push([tstamp, parseFloat(strData.compare[i].yr_temp)]);}
      if(typeof strData.compare[i].smhi_temp !== 'undefined'){compsmhi.push([tstamp, parseFloat(strData.compare[i].smhi_temp)]);}
      if(typeof strData.compare[i].icon_temp !== 'undefined'){compdwd.push([tstamp, parseFloat(strData.compare[i].icon_temp)]);}
      if(typeof strData.compare[i].mfarome_temp !== 'undefined'){comparome.push([tstamp, parseFloat(strData.compare[i].mfarome_temp)]);}
      if(typeof strData.compare[i].mf_temp !== 'undefined'){compmf.push([tstamp, parseFloat(strData.compare[i].mf_temp)]);}
      if(typeof strData.compare[i].knmi_temp !== 'undefined'){compknmi.push([tstamp, parseFloat(strData.compare[i].knmi_temp)]);}
      if(typeof strData.compare[i].gfs_temp !== 'undefined'){compgfs.push([tstamp, parseFloat(strData.compare[i].gfs_temp)]);}
      if(typeof strData.compare[i].cmc_temp !== 'undefined'){compcmc.push([tstamp, parseFloat(strData.compare[i].cmc_temp)]);}
      if(typeof strData.compare[i].wxsim_temp !== 'undefined'){compwxsim.push([tstamp, parseFloat(strData.compare[i].wxsim_temp)]);}
      if(twidth>650){
        svgdata.push({"time":tstamp, "dir":item.wdir, "bft": item.bft, "cond": item.icon});
      }else if(typeof item.prec3h !== 'undefined'){
        svgdata.push({"time":tstamp, "dir":item.wdir, "bft": item.bft, "cond": item.icon});
      }
    }
  });
  getHC();
  if($('#graphbuttons div div[data-id="frc"]').hasClass("active")){
    chart = new Highcharts.Chart(tempoptions);
    if(!fullGraph){
      drawgraphiconswx(svgdata, "hourgraph", 20, 0);
      drawgraphiconswind(svgdata,357);
    }
  }else{
    chart = new Highcharts.Chart(compoptions);
  }
  $("#graphbuttons div div").unbind().on("click", function() {
    fgr=$(this).attr("data-id");
    if(fgr!=="fullgraph"){$("#graphbuttons div div").removeClass("active");}
    if(fullGraph){$('#graphbuttons div div[data-id="fullgraph"]').addClass("active");}
    $(this).addClass("active");
    if(fgr=="frc"){
      chart = new Highcharts.Chart(tempoptions);
      if(!fullGraph){
        drawgraphiconswx(svgdata, "hourgraph", 20, 0);
        drawgraphiconswind(svgdata,357);
      }
      compGraph=false;
    }else if(fgr=="fullgraph"){
      if(fullGraph){
        fullGraph=false;
        $('#graphbuttons div div[data-id="fullgraph"]').removeClass("active");
        getGraph(choosedDay);
      }else{
        fullGraph=true;
        $('#graphbuttons div div[data-id="fullgraph"]').addClass("active");
        getGraph(null);
      }
      if(compGraph){
        chart = new Highcharts.Chart(compoptions);
      }else{
        chart = new Highcharts.Chart(tempoptions);
        if(!fullGraph){
          drawgraphiconswx(svgdata, "hourgraph", 20, 0);
          drawgraphiconswind(svgdata,357);
        }
      }
    }else{
      chart = new Highcharts.Chart(compoptions);
      compGraph=true;
    }
  });
}

function getCompare(model, i){
  if(typeof strData.compare[i][model+'_pop'] !== 'undefined'){cpop=Math.round(strData.compare[i][model+'_pop'])+'%';}else{cpop='';}
  if(typeof strData.compare[i][model+'_ts'] !== 'undefined'){cts=Math.round(strData.compare[i][model+'_ts'])+'%';}else{cts='';}
  if(typeof strData.compare[i][model+'_rh'] !== 'undefined'){crh=Math.round(strData.compare[i][model+'_rh'])+'%';}else{crh='';}
  ct='<div style="flex: 1;">'+Math.round(strData.compare[i][model+'_temp'])+'&deg;</div>'+
  '<div style="flex: 1;"></div>'+
  '<div style="flex: 1;">'+
    '<i class="wi wi-wind from-'+Math.round(strData.compare[i][model+'_wdir'])+'-deg" '+
    'style="font-size:20px;top:3px;right:4px;position: relative;"></i>'+Math.round(fixWspd(strData.compare[i][model+'_wspd']))+' '+wunit+''+
   '</div>'+
   '<div style="flex: 1;">'+crh+'</div>'+
   '<div style="flex: 1;">'+parseFloat(strData.compare[i][model+'_prec']).toFixed(1)+' mm</div>'+
   '<div style="flex: 1;" class="pophead">'+cpop+'</div>'+
   '<div style="flex: 1;" class="snowhead"></div>'+
   '<div style="flex: 1;" class="tshead">'+cts+'</div>'+
   '<div style="flex: 1;">'+strData.compare[i][model+'_prmsl']+' hPa</div>'+
   '<div style="flex: 1;"></div>'+
   '';
  return ct;
}

function docurr(){
  d=0;
  $("#currcontent, #frccurrcond, #frcradar").css({height:"350px"});
  $("#frccurrcond .touchcarousel").css({height:"295px"});
  $("#frccurrcond .touchcarousel-container").html("");
  e=$("#frccurrcond").width();
  $("#frccurrcond .touchcarousel").css({width:e+"px"});
  if(strData.currcond == null){
    $("#frccurrcond .touchcarousel-container").html('<div id="noclose">'+noclosetxt+'</div>');
  }else{
    $.each(strData.currcond, function(i, item) {
      if(typeof item.Name !== 'undefined'){
        dco='<li class="touchcarousel-item" data-id="f'+d+'" style="width:'+e+'px;height:285px;">'+
          '<h2>'+item.Name+'</h2>'+
          '<span style="color:#888">'+item.type+' &#8226; '+disttxt+' '+item.distance.toFixed(2)+' km &#8226; '+item.timeago+' '+agotxt+'</span>'+
          '<div id="frccurrbox">'+
          '<span class="sright">'+item.temp+'&deg;</span>'+temptxt+'<br/>'+
          '<span class="sright">'+item.dewp+'&deg;</span>'+dewtxt+'<br/>';
        if(item.wspeed>=0){
          dco+='<span class="sright">'+item.wdir+' '+fixWspd(item.wspeed)+' '+wunit+'</span>'+windtxt+'<br/>';
          if(item.wgust>item.wspeed){dco+='<span class="sright">'+fixWspd(item.wgust)+' '+wunit+'</span>'+gusttxt+'<br/>';}
        }
        dco+='<span class="sright">'+Math.round(item.hum)+' %</span>'+humtxt+'<br/>';
        if(item.baro > 0){dco+='<span class="sright">'+item.baro+' hPa</span>'+barotxt+'<br/>';}
        dco+='<span class="sright">'+item.prec+' mm</span>'+prectxt+'<br/>'+
          '<span class="sright">'+item.rrate+' mm/h</span>'+rratetxt+'<br/>';
        if(item.snowd>0){
          dco+='<span class="sright">'+item.snowd+' cm</span>'+snowtxt+'<br/>';
        }
        dco+='</div><li>';
        $("#frccurrcond .touchcarousel-container").append(dco);
        d++;
      }
    });
    $("#frccurrcond").touchCarousel({scrollbar:false,directionNav:false,pagingNav:true,autoplay:true,loopItems:true,scrollToLast:true});
    $(".tc-paging-item").html("");
  }
  
  var quarter = Math.round((Date.now()-(15*60000)) / (15 * 60000)) * (15 * 60000);
  var q = new Date(quarter);
  var utc = new Date(q.getTime() + q.getTimezoneOffset() * 60000);
  var eudate = utc.format("yyyymmdd.HHMM");
  var rdate = utc.format("yyyy-mm-dd")+"T"+utc.format("HH:MM")+"Z";
  var ukdate = utc.format("yyyy-mm-dd")+"T"+utc.format("HH:MM")+":00Z";
  var centerMarker = L.icon({iconUrl:"https://euweather.eu/img/geo_marker.png",iconSize:[16,16],iconAnchor:[8,8]});
  
    // Map 2
  if(typeof map2 !== 'undefined'){return;}
  map2 = L.map("frcradar", { zoomControl:false }).setView([lat, lon], 6);
  map2.attributionControl.setPrefix("");
  map2.options.maxZoom = 8;
  map2.options.minZoom = 4;
  var mapboxgl2 = L.mapboxGL({
    accessToken: 'no-token',
    style: 'https://a.maps.nordicweather.net/vector/openmap_nex.json'
  }).addTo(map2);
  
  if(pco=="FI"){
    mapboxgl2._glMap.on('load', function () { 
      mapboxgl2._glMap.addLayer({
        "id": "radar","type": "raster","paint": {'raster-opacity': 0.55},"source": {"type": 'raster',"tiles": ['https://c.nordicweather.net/tiles/fmi/esri_fmidbz1/{z}/{x}/{y}.png'],"tileSize": 256}
      },"boundary-level-4"); 
      map2.attributionControl.setPrefix("Radar: <a href=\'http://www.fmi.fi\' target=\'_blank\'>FMI</a>");
    });
  }
  if(pco=="NL"){
    mapboxgl2._glMap.on('load', function () { 
      mapboxgl2._glMap.addLayer({
        "id": "radar","type": "raster","paint": {'raster-opacity': 0.55},"source": {"type": 'raster',"tiles": ['https://a.maps.nordicweather.net/ext_tiles/knmiradar/{z}/{x}/{y}.png'],"tileSize": 256}
      },"boundary-level-4"); 
      map2.attributionControl.setPrefix("Radar: <a href=\'http://www.knmi.nl\' target=\'_blank\'>KNMI</a>");
    });
  }
  if(pco=="DE"){
    mapboxgl2._glMap.on('load', function () { 
      mapboxgl2._glMap.addLayer({
        "id": "radar","type": "raster","paint": {'raster-opacity': 0.55},"source": {"type": 'raster',"tiles": ['https://a.maps.nordicweather.net/ext_tiles/dwd/1/{z}/{x}/{y}.png'],"tileSize": 256}
      },"boundary-level-4"); 
      map2.attributionControl.setPrefix("Radar: <a href=\'http://www.dwd.de\' target=\'_blank\'>DWD</a>");
    });
  }
  if(pco=="UK"){
    var imageUrl = "https://a.maps.nordicweather.net/ext_tiles/uk/png?TIME="+ukdate+"&key=9e00f6aa-29e1-43bb-8ea9-9a9bdad0142c";
    var imageBounds = [[48, -12], [61, 5]];
    ukmoradar = L.imageOverlay(imageUrl, imageBounds,{opacity:0.55});
  }
  if(pco=="scand"){
    var southWest = L.latLng(52.5,0),
    northEast = L.latLng(72.5,32.5),
    bounds = L.latLngBounds(southWest, northEast);
    L.tileLayer.wms("https://public-wms.met.no/verportal/verportal.map",
      {"layers":"radar_precipitation_intensity","format":"image/png","time":rdate,"transparent":true, 
      attribution: "Radar: <a href=\'http://www.yr.no\' target=\'_blank\'>YR</a>",opacity:0.55,zIndex:100,
      bounds:bounds});
  }
  L.tileLayer("https://a.nordicweather.net/tiles/botiles/{z}/{x}/{y}.png", 
  {zIndex:100,attribution: strtxt+": <a href='http://www.blitzortung.org' target='_blank'>Blitzortung</a>"}).addTo(map2);
  L.marker([lat,lon], {icon: centerMarker}).addTo(map2);
  
}

function fixWspd(val){
  if(wiset=="kmh"){return (val*3.6).toFixed(1);}
  else if(wiset=="kts"){return (val*1.94384449).toFixed(1);}
  else if(wiset=="mph"){return (val*2.23693629).toFixed(1);}
  else return (val*1).toFixed(1);
}

function getWunit(wiset){
  if(wiset=="ms"){return "m/s";}
  if(wiset=="kmh"){return "km/h";}
  return wiset;
}

function fixPop(val){
  if(val>0&&val<8){return "<10";}
  if(val>=5){return Math.round(val / 10) * 10;}
  return "0";
}

function fixTs(val){
  if(val>2&&val<8){return "<10";}
  if(val>=5&&val<90){return Math.round(val / 10) * 10;}
  if(val>=90){return 90;}
  return "0";
}

function fixSnowfall(val,valb){
  if(valb>0.1&&valb<1.8){
    if(val>0&&val<1.5){return "<1";}
    if(val>1.5&&val<2.6){return "1-2";}
    if(val>2.6&&val<4){return "2-3";}
    return Math.round(val*0.75);
  }else{
    if(val>0&&val<1){return "<1";}
    if(val>1&&val<2){return "1-2";}
    if(val>2&&val<3){return "2-3";}
    return Math.round(val);
  }
}

function getHC(){
  Highcharts.setOptions({
    colors: ["#DDDF0D", "#55BF3B", "#DF5353", "#7798BF", "#aaeeee", "#ff0066", "#eeaaee", "#ff9900", "#1F5EA8", "#B32E37"],
    lang: {weekdays: days,shortMonths: months,thousandsSep: ""},
    global : { timezoneOffset: utcdiff * 60},               
    chart: {
      defaultSeriesType: "spline",
      backgroundColor: "#2b3d4b",
      plotBorderColor: "#2b3d4b",
      marginRight: 40,
      marginLeft: 40,
      marginTop: 30,
      plotBorderWidth: 0,
      //zoomType: 'x',
      style: labelStyle,
      events: {
        redraw: function(event) {
          if (chart.xAxis && !fullGraph) {
            drawgraphiconswx(svgdata, "hourgraph", 20, 0);
            drawgraphiconswind(svgdata,357);
          }
        }
      }
    },
    title: {text: ""},
    credits: {enabled: false},
    plotOptions: {
      spline: {lineWidth: 1.8, shadow: false, marker: {enabled: false,radius:3,states: {hover: {enabled: true}}}},
      column: {lineWidth:0,pointWidth:null,pointPlacement:-0.5,groupPadding: 0,pointPadding: 0.1,borderWidth: 0,shadow: false},
      areaspline: {lineWidth: 1.5, shadow: false,marker: {enabled: false,radius:3,states: {hover: {enabled: true}}}}
    },
    tooltip: {
      shared: true,
      useHTML: true,
      crosshairs: { width: 0.5,color: "#666"},
      backgroundColor:"#3E576B",borderColor:"#162b3d",style: { "color": "#fff"},
      formatter: function () { 
        var index = this.points[0].point.index;
        var ret = '<b>' + Highcharts.dateFormat("%A %H:%M", this.x) +'</b>';
        ret += "<table>";
        Highcharts.each(this.points, function (point) {
          var series = point.series;
          ret += '<tr><td><span style="color:' + series.color + '">\u25CF</span> ' + series.name +
            ':&nbsp;&nbsp;</td><td style="white-space:nowrap">' + Highcharts.pick(point.point.value, point.y).toFixed(1) +
            series.options.tooltip.valueSuffix + '</td></tr>';
        });
        if(!compGraph){
          ret += '<tr><td style="vertical-align: top">\u25CF '+windtxt+':&nbsp;&nbsp;</td><td style="white-space:nowrap">' + 
            windtip[index][1].toFixed(1)+' '+wunit+'</td></tr>';
        }
        ret += "</table>";
        return ret;
      }
    },
    legend: {enabled: true, y:20,itemStyle: labelStyle,itemHiddenStyle: {color: '#555'},itemHoverStyle: {color: '#555'}},
    exporting: {enabled:false},
    scrollbar: {enabled:false}
  });
  
  xAxis1 = { // Bottom X axis
    type: "datetime",
    tickInterval: 3 * 36e5, // two hours
    tickLength: 0,
    lineColor: "#577a96",
    offset: 35,
    showLastLabel: true,
    labels: {format: "{value:%H}",y:16,style: labelStyle}
  };
  
  tempYAxis = [
    { // Temperature
      title: {text: null},labels: {format: "{value}°",style: labelStyle, x:-4, y:3},
      gridLineWidth: 1,gridLineColor: "#577a96",
      plotLines: [{ value: 0,color: "#577a96",width: 3,zIndex: 2}],maxPadding: 0.05,tickInterval: 1   
    },{ // precipitation axis
      title: {text: null},labels: {enabled: false},gridLineWidth: 0,min:0,minRange:5,tickLength: 0
    },{ // Air pressure 
      title: { text: null},labels:{ x:4, y:3, style:{color: "#fff", fontWeight:300,fontFamily: 'ubuntu'}},maxPadding: 0.05,
      allowDecimals: false,gridLineWidth: 0,opposite: true
    },{ // ts
      title: {text: null},labels: {enabled: false},gridLineWidth: 0,min:0,max:100,tickLength: 0
    }];
    
  if(twidth>650){ptip=true;}else{ptip=false;}
  tempoptions = {
    chart: {marginBottom: 90,renderTo: "hourgraph"},
    xAxis: [xAxis1],
    yAxis: tempYAxis,
    series: [{
      name: temptxt,data: smoothline(tempdata),tooltip: {valueSuffix: "°"},color: "#FF3333",negativeColor: "#48AFE8",lineWidth:2,zIndex:3
    },{
      name: dewtxt,data: smoothline(dewdata),tooltip: {valueSuffix: "°"},color: "#698B22",visible: false,zIndex:3
    },{
      name: feeltxt,data: smoothline(feeldata),tooltip: {valueSuffix: "°"},color: "#4F94CD",dashStyle: "shortdot",visible: false,zIndex:3
    },{
      name: barotxt,data: smoothline(barodata),tooltip: {valueSuffix: " hPa"},color: "#9ACD32",dashStyle: "shortdot",yAxis: 2,zIndex:3
    },{
      name: prectxt,data: precdata,tooltip: {valueSuffix: " mm"},color:"#4572A7",type: "column",yAxis: 1,zIndex:2,
      dataLabels: {enabled: ptip,formatter: function () {if (this.y > 0) {return this.y;}},
      style: {fontWeight:300,fontSize: "10px",color:"#fff",textShadow:"0px"}}
    },{
      name: tstxt,data:tsdata,tooltip: {valueSuffix: " %"},color:"#EE7621",type:"areaspline",yAxis: 3,zIndex:1
    }]
  };
  
  compoptions = {
    chart: {marginBottom: 90,marginRight: 10,renderTo: "hourgraph",events:{redraw: function(event){}}},
    xAxis: [xAxis1],
    yAxis: tempYAxis,
    series: [
    {name: "FMI",data: smoothline(compfmi),tooltip: {valueSuffix: "°"},visible: getGraphVis(compfmi)},
    {name: "YR",data: smoothline(compyr),tooltip: {valueSuffix: "°"},visible: getGraphVis(compyr)},
    {name: "SMHI",data: smoothline(compsmhi),tooltip: {valueSuffix: "°"},visible: getGraphVis(compsmhi)},
    {name: "DWD",data: smoothline(compdwd),tooltip: {valueSuffix: "°"},visible: getGraphVis(compdwd)},
    {name: "MF Arome",data: smoothline(comparome),tooltip: {valueSuffix: "°"},visible: getGraphVis(comparome)},
    {name: "MF Arpege",data: smoothline(compmf),tooltip: {valueSuffix: "°"},visible: getGraphVis(compmf)},
    {name: "KNMI",data: smoothline(compknmi),tooltip: {valueSuffix: "°"},visible: getGraphVis(compknmi)},
    {name: "GFS",data: smoothline(compgfs),tooltip: {valueSuffix: "°"},visible: getGraphVis(compgfs)},
    {name: "CMC",data: smoothline(compcmc),tooltip: {valueSuffix: "°"},visible: getGraphVis(compcmc)},
    {name: "WXSIM",data: smoothline(compwxsim),tooltip: {valueSuffix: "°"},visible: getGraphVis(compwxsim)},
    {name: "EWN",data: smoothline(tempdata),tooltip: {valueSuffix: "°"},color: "#00ff00",lineWidth:3}
    ]
  };
  
}

function getGraphVis(arr){
  if(arr.length>0){return true;}else{return false;}
}
  
function smoothline(data) {
  var i = data.length,sum,value;
  while (i--) {
    data[i].value = value = data[i].y; // preserve value for tooltip
    sum = (data[i - 1] || data[i]).y + value + (data[i + 1] || data[i]).y;
    data[i].y = Math.max(value - 0.5, Math.min(sum / 3, value + 0.5));
  }
  return data;
}
  
function drawgraphiconswx(svgdata, mainrec, plotleft, gs){
  var mainrect = $("#"+mainrec+" .highcharts-series-group");
  $(".gr-ic").remove();
  extremes = chart.xAxis[0].getExtremes();
  $.each(svgdata, function(index2,value2){
    $.each(chart.series[gs].points, function(index,value){
      if(value.category == value2.time && value2.time >= extremes.min && value2.time <= extremes.max) {
        var xx = value.plotX + chart.plotLeft - plotleft;
        var yy = value.plotY + chart.plotTop - 50;
        //var yy = 25;
        $(mainrect).append('<svg class="svg-ic gr-ic" height="40" width="40" viewBox="0 0 512 512" x ='+xx+' y="'+yy+'"><g>'+geticon(value2.cond)+'</g></svg>');
      }
    });
  });
}
  
function drawgraphiconswind(svgdata,wicY){
  extremes = chart.xAxis[0].getExtremes();
  $.each(svgdata, function(index2,value2){
    $.each(chart.series[2].points, function(index,value){
      var arrow, x, y,level,path;
      if(value.category == value2.time && value2.time >= extremes.min && value2.time <= extremes.max) {
        level = value2.bft;
        x = value.clientX + chart.plotLeft - 0;
        y = wicY;
        path = ['M',0,7,'L',-1.5,7,0,10,1.5,7,0,7,0,-10];
        if (level === 0) {path = [];}
        if (level === 2) {path.push('M', 0, -8, 'L', 4, -8);} 
        else if (level >= 3) {path.push(0, -10, 7, -10);}
        if (level === 4) {path.push('M', 0, -7, 'L', 4, -7);} 
        else if (level >= 5) {path.push('M', 0, -7, 'L', 7, -7);}
        if (level === 5) {path.push('M', 0, -4, 'L', 4, -4);} 
        else if (level >= 6) {path.push('M', 0, -4, 'L', 7, -4);}
        if (level === 7) {path.push('M', 0, -1, 'L', 4, -1);} 
        else if (level >= 8) {path.push('M', 0, -1, 'L', 7, -1);}
          
        if (level === 0) {arrow = chart.renderer.circle(x, y, 10).attr({fill: 'none'});}
        else {
          arrow = chart.renderer.path(path).attr({rotation: parseInt(value2.dir, 10),translateX: x,translateY: y});
        }
        arrow.attr({stroke: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'white','stroke-width': 1.5,zIndex: 5,'class':'gr-ic'})
          .add();
      }
    });
  });
}
  
function drawwindbox() {
  var xAxis = chart.xAxis[0],x,pos,max,isLong,isLast,i;
  for (pos = xAxis.min, max = xAxis.max, i = 0; pos <= max + 36e5; pos += 36e5, i ++) {
    isLast = pos === max + 36e5;
    x = Math.round(xAxis.toPixels(pos)) + (isLast ? 0.5 : -0.5);
    if (this.resolution > 36e5) {
      isLong = pos % this.resolution === 0;
    } else {
      isLong = i % 3 === 0;
    }
    isLong = 0;
    chart.renderer.path(['M', x, chart.plotTop + chart.plotHeight + (isLong ? 0 : 28),
      'L', x, chart.plotTop + chart.plotHeight + 32, 'Z'])
      .attr({'stroke': chart.options.chart.plotBorderColor,'stroke-width': 1})
      .add();
  }
}

/*##############################################################################################
  # COMPARE
*/

function getComps(){
  if(!accloaded){
    $(".accmodu").html(strData.accuracy.point.modu);
    if(typeof strData.accuracy.point.frc === 'undefined'){$("#accpointwrap").hide();}
    divs='<div class="accbox">';
    dive='</div>';
    $("#accpoint").append(divs+strData.accuracy.point.frc+'%'+dive);  
    $("#accpoint").append(divs+strData.accuracy.point.fmi+'%'+dive);
    $("#accpoint").append(divs+strData.accuracy.point.yr+'%'+dive);
    if(strData.accuracy.point.modu=="SMHI"){$("#accpoint").append(divs+strData.accuracy.point.smhi+'%'+dive);}
    else if(strData.accuracy.point.modu=="MF Arome"){$("#accpoint").append(divs+strData.accuracy.point.mfarome+'%'+dive);}
    else{$("#accpoint").append('--');}
    $("#accpoint").append(divs+strData.accuracy.point.icon+'%'+dive);
    $("#accpoint").append(divs+strData.accuracy.point.mf+'%'+dive); 
    $("#accpoint").append(divs+strData.accuracy.point.knmi+'%'+dive);
    $("#accpoint").append(divs+strData.accuracy.point.gfs+'%'+dive);
    $("#accpoint").append(divs+strData.accuracy.point.cmc+'%'+dive);
    if(strData.location.wxsim=="true"){ $("#accpoint").append(divs+strData.accuracy.point.wxsim+'%'+dive);}
    else{$(".accwxsim").hide();}
  
    $("#accpointges").append(divs+strData.accuracy.point.frc_ges+'&deg;'+dive);  
    $("#accpointges").append(divs+strData.accuracy.point.fmi_ges+'&deg;'+dive);
    $("#accpointges").append(divs+strData.accuracy.point.yr_ges+'&deg;'+dive);
    if(strData.accuracy.point.modu=="SMHI"){$("#accpointges").append(divs+strData.accuracy.point.smhi_ges+'&deg;'+dive);}
    else if(strData.accuracy.point.modu=="MF Arome"){$("#accpointges").append(divs+strData.accuracy.point.mfarome_ges+'&deg;'+dive);}
    else{$("#accpointges").append('--');}
    $("#accpointges").append(divs+strData.accuracy.point.icon_ges+'&deg;'+dive);
    $("#accpointges").append(divs+strData.accuracy.point.mf_ges+'&deg;'+dive); 
    $("#accpointges").append(divs+strData.accuracy.point.knmi_ges+'&deg;'+dive);
    $("#accpointges").append(divs+strData.accuracy.point.gfs_ges+'&deg;'+dive);
    $("#accpointges").append(divs+strData.accuracy.point.cmc_ges+'&deg;'+dive);
    if(strData.location.wxsim=="true"){ $("#accpointges").append(divs+strData.accuracy.point.wxsim_ges+'&deg;'+dive);}
    
    $("#accmodel").append(divs+strData.accuracy.model.frc+'%'+dive);  
    $("#accmodel").append(divs+strData.accuracy.model.fmi+'%'+dive);
    $("#accmodel").append(divs+strData.accuracy.model.yr+'%'+dive);
    if(strData.accuracy.point.modu=="SMHI"){$("#accmodel").append(divs+strData.accuracy.model.smhi+'%'+dive);}
    else if(strData.accuracy.point.modu=="MF Arome"){$("#accmodel").append(divs+strData.accuracy.model.mfarome+'%'+dive);}
    else{$("#accmodel").append('--');}
    $("#accmodel").append(divs+strData.accuracy.model.icon+'%'+dive);
    $("#accmodel").append(divs+strData.accuracy.model.mf+'%'+dive); 
    $("#accmodel").append(divs+strData.accuracy.model.knmi+'%'+dive);
    $("#accmodel").append(divs+strData.accuracy.model.gfs+'%'+dive);
    $("#accmodel").append(divs+strData.accuracy.model.cmc+'%'+dive);
    $("#accmodel").append(divs+strData.accuracy.model.wxsim+'%'+dive);
  
    $("#accmodelges").append(divs+strData.accuracy.model.frc_ges+'&deg;'+dive);  
    $("#accmodelges").append(divs+strData.accuracy.model.fmi_ges+'&deg;'+dive);
    $("#accmodelges").append(divs+strData.accuracy.model.yr_ges+'&deg;'+dive);
    if(strData.accuracy.point.modu=="SMHI"){$("#accmodelges").append(divs+strData.accuracy.model.smhi_ges+'&deg;'+dive);}
    else if(strData.accuracy.point.modu=="MF Arome"){$("#accmodelges").append(divs+strData.accuracy.model.mfarome_ges+'&deg;'+dive);}
    else{$("#accmodelges").append('--');}
    $("#accmodelges").append(divs+strData.accuracy.model.icon_ges+'&deg;'+dive);
    $("#accmodelges").append(divs+strData.accuracy.model.mf_ges+'&deg;'+dive); 
    $("#accmodelges").append(divs+strData.accuracy.model.knmi_ges+'&deg;'+dive);
    $("#accmodelges").append(divs+strData.accuracy.model.gfs_ges+'&deg;'+dive);
    $("#accmodelges").append(divs+strData.accuracy.model.cmc_ges+'&deg;'+dive);
    $("#accmodelges").append(divs+strData.accuracy.model.wxsim_ges+'&deg;'+dive);
    accloaded=true;
  }
  statgraph=strData.accuracy.graph;
  dayl=24*3600000;
  pstart=strData.accuracy.point.start;
  if(typeof statgraph.smhi!=='undefined'){var accsmhi=true;}else{var accsmhi=false;}
  if(typeof statgraph.mfarome!=='undefined'){var accmf=true;}else{var accmf=false;}
  if(strData.location.wxsim=="true"){var accwx=true;}else{var accwx=false;}
  stat1series = [
    {name: "EWN",data:statgraph.frc,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart,color:"#00ff00",lineWidth:3},
    {name:"DWD",data:statgraph.icon,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"FMI",data:statgraph.fmi,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"YR",data:statgraph.yr,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"SMHI",data:statgraph.smhi,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart,visible:accsmhi},
    {name:"KNMI",data:statgraph.knmi,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"MF",data:statgraph.mf,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"MF Arome",data:statgraph.mfarome,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart,visible:accmf},
    {name:"GFS",data:statgraph.gfs,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"CMC",data:statgraph.cmc,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"WXSIM",data:statgraph.wxsim,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart,visible:accwx}
   ];

  stat2series = [
    {name:"EWN",data:statgraph.frcges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart,color:"#00ff00",lineWidth:3},
    {name:"DWD",data:statgraph.iconges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"FMI",data:statgraph.fmiges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"YR",data:statgraph.yrges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"SMHI",data:statgraph.smhiges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart,visible:accsmhi},
    {name:"KNMI",data:statgraph.knmiges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"MF",data:statgraph.mfges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"MF Arome",data:statgraph.mfaromeges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart,visible:accmf},
    {name:"GFS",data:statgraph.gfsges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"CMC",data:statgraph.cmcges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"WXSIM",data:statgraph.wxsimges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart,visible:accwx}
   ];
  
  mstat1series = [
    {name:"EWN",data:statgraph.mfrc,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart,color:"#00ff00",lineWidth:3},
    {name:"DWD",data:statgraph.micon,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"FMI",data:statgraph.mfmi,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"YR",data:statgraph.myr,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"SMHI",data:statgraph.msmhi,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart,visible:accsmhi},
    {name:"KNMI",data:statgraph.mknmi,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"MF",data:statgraph.mmf,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"MF Arome",data:statgraph.mmfarome,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart,visible:accmf},
    {name:"GFS",data:statgraph.mgfs,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"CMC",data:statgraph.mcmc,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart},
    {name:"WXSIM",data:statgraph.mwxsim,tooltip:{valueSuffix:" %"},pointInterval:dayl,pointStart:pstart}
   ];
  
  mstat2series = [
    {name:"EWN",data:statgraph.mfrcges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart,color:"#00ff00",lineWidth:3},
    {name:"DWD",data:statgraph.miconges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"FMI",data:statgraph.mfmiges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"YR",data:statgraph.myrges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"SMHI",data:statgraph.msmhiges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart,visible:accsmhi},
    {name:"KNMI",data:statgraph.mknmiges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"MF",data:statgraph.mmfges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"MF Arome",data:statgraph.mmfaromeges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart,visible:accmf},
    {name:"GFS",data:statgraph.mgfsges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"CMC",data:statgraph.mcmcges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart},
    {name:"WXSIM",data:statgraph.mwxsimges,tooltip:{valueSuffix:"°"},pointInterval:dayl,pointStart:pstart}
   ];
  
  Highcharts.setOptions({
    colors: ["#DDDF0D", "#55BF3B", "#DF5353", "#7798BF", "#aaeeee", "#ff0066", "#eeaaee", "#ff9900", "#1F5EA8", "#B32E37"],             
    chart: {
      defaultSeriesType: "spline",
      backgroundColor: "#2b3d4b",
      plotBorderColor: "#2b3d4b",
      marginLeft: 40,
      marginRight: 10,
      marginTop: 30,
      plotBorderWidth: 0,
      //zoomType: 'x',
      style: labelStyle,
    },
    tooltip: {
      shared: true,
      useHTML: true,
      crosshairs: { width: 0.5,color: "#666"},
      backgroundColor:"#3E576B",borderColor:"#162b3d",style: { "color": "#fff"},
      formatter: function () { 
        var ret = '<b>' + Highcharts.dateFormat("%Y-%m-%d", this.x) +'</b>';
        ret += "<table>";
        Highcharts.each(this.points, function (point) {
          var series = point.series;
          ret += '<tr><td><span style="color:' + series.color + '">\u25CF</span> ' + series.name +
            ':&nbsp;&nbsp;</td><td style="white-space:nowrap">' + Highcharts.pick(point.point.value, point.y).toFixed(2) +
            series.options.tooltip.valueSuffix + '</td></tr>';
        });
        ret += "</table>";
        return ret;
      }
    },
    title: {text: ""},
    credits: {enabled: false},
    plotOptions: {spline: {lineWidth: 1.8, shadow: false, marker: {enabled: false,radius:3,states: {hover: {enabled: true}}}}},
    legend: {enabled: true, y:20,itemStyle: labelStyle,itemHiddenStyle: {color: '#555'},itemHoverStyle: {color: '#555'}}
  });
  
  statX = { // Bottom X axis
    type: "datetime",
    tickLength: 0,
    lineColor: "#577a96",
    offset: 0,
    showFirstLabel: true,
    showLastLabel: true,
    labels: {format: "{value:%d/%m}",y:16,style: labelStyle}
  };
            
  stat1YAxis = [{
    gridLineWidth: 0.4,max:100,showLastLabel: true,title: {text: ""},
    labels: {style: labelStyle,x:-4,y:4,format: '{value}%',align: "right"} 
  }];
    
  stat2YAxis = [{
    gridLineWidth: 0.4,min: 0,showLastLabel: true,title: {text: ""},
    labels: {style: labelStyle,x:-4,y:4,format: '{value}°',align: "right"} 
  }];
  
  stat1options = {
    chart: {marginBottom: 60,renderTo: "statgraph"},xAxis: [statX],yAxis: stat1YAxis
  };
  
  stat2options = {
    chart: {marginBottom: 60,renderTo: "statgraph"},xAxis: [statX],yAxis: stat2YAxis
  };
  
  mstat1options = {
    chart: {marginBottom: 60,renderTo: "mstatgraph"},xAxis: [statX],yAxis: stat1YAxis
  };
  
  mstat2options = {
    chart: {marginBottom: 60,renderTo: "mstatgraph"},xAxis: [statX],yAxis: stat2YAxis
  };
  
  if(typeof strData.accuracy.point.frc !== 'undefined'){
    if($('#statbuttons div div[data-id="errorPanel"]').hasClass("active")){
      stgraph2=stat1options;
      stgraph2.series=stat1series;
      chart2 = new Highcharts.Chart(stgraph2);
    }else{
      stgraph2=stat2options;
      stgraph2.series=stat2series;
      chart2 = new Highcharts.Chart(stgraph2);
    }
    $("#statbuttons div div").unbind().on("click", function() {
      fgr=$(this).attr("data-id");
      $("#statbuttons div div").removeClass("active");
      $(this).addClass("active");
      if(fgr=="errorPanel"){
        stgraph2=stat1options;
        stgraph2.series=stat1series;
        chart2 = new Highcharts.Chart(stgraph2);
      }else{
        stgraph2=stat2options;
        stgraph2.series=stat2series;
        chart2 = new Highcharts.Chart(stgraph2);
      }
    });
  }
  if($('#mstatbuttons div div[data-id="merrorPanel"]').hasClass("active")){
    mstgraph2=mstat1options;
    mstgraph2.series=mstat1series;
    chart3 = new Highcharts.Chart(mstgraph2);
  }else{
    mstgraph2=mstat2options;
    mstgraph2.series=mstat2series;
    chart3 = new Highcharts.Chart(mstgraph2);
  }
  $("#mstatbuttons div div").unbind().on("click", function() {
    fgr=$(this).attr("data-id");
    $("#mstatbuttons div div").removeClass("active");
    $(this).addClass("active");
    if(fgr=="merrorPanel"){
      mstgraph2=mstat1options;
      mstgraph2.series=mstat1series;
      chart3 = new Highcharts.Chart(mstgraph2);
    }else{
      mstgraph2=mstat2options;
      mstgraph2.series=mstat2series;
      chart3 = new Highcharts.Chart(mstgraph2);
    }
  });

}

/*##############################################################################################
  # MISC
*/

function getfavotable(ewnfavo,upd){
  if(ewnfavo.length===0){$("#favobarlink").hide();}
  for(i=0;i<ewnfavo.length;i++){
    $("#favobarlink").show();
    if(i==0&&initload){
      $("#searchflag").addClass('knob-'+ewnfavo[i].co);
      $("#searchflag").attr('data-co',ewnfavo[i].co);
      $("#city").attr('placeholder',ewnfavo[i].na);
      $("#favostar").html("<i class='fa fa-star favostar'></i>");
      url="//"+window.location.hostname+window.location.pathname+"?lang="+lang+"&geoid="+ewnfavo[i].id+p;
      window.location.href=url;
    }
    if(geoid===ewnfavo[i].id){
      $("#favostar .favostar").removeClass("fa-star-o").addClass("fa-star");
    }
    var brick="<div class='brick' data-id='"+ewnfavo[i].id+"' data-co='"+ewnfavo[i].co+"' data-na='"+ewnfavo[i].na+"'>"+
      "<i class='delete fa fa-times favodel'></i><i class='fa fa-arrows-v'></i><span data-id='"+ewnfavo[i].id+"'>"+ewnfavo[i].na+"</span></div>";
    $('.gridly').append(brick);
  }
}

function rungridly(){
  if($('#favobox').is(':visible')){
    $('.gridly').gridly(gridlyOptions);
    $(".gridly .delete").on("click touchend", function() {
      $(this).closest('.brick').remove();
      $('.gridly').gridly('layout');
      favoupd();
    }); 
    $(".gridly span").on("click touchend", function() {
      gid=$(this).attr("data-id");
      url="//"+window.location.hostname+window.location.pathname+"?lang="+lang+"&geoid="+gid+p;
      window.location.href=url;
    });
  }
}

function favoupd(){
  if(favotimeout){clearTimeout(favotimeout);}
  favotimeout = setTimeout(function(){
    favos=[];
    $(".brick").each(function( index, value ) {
      var n = $(this).css("top");
      n = n.replace("px", "");
      gid=$(this).attr("data-id");
      gco=$(this).attr("data-co");
      gna=$(this).attr("data-na");
      fav={id:gid,co:gco,na:gna,pos:parseInt(n)};
      favos.push(fav);
    });
    favos.sort(function(a,b) {return (b["pos"]<a["pos"]?-1:(b["pos"]>a["pos"]?1:0));});
    favos.reverse();
    //console.log(favos);
    ewnfavo=favos;
    if(ewnfavo.length===0){
      $("#favostar .favostar").removeClass("fa-star").addClass("fa-star-o");
      $("#favobarlink").hide();
      $("#favobox").hide();
    }
    var currloc=false;
    for(i=0;i<ewnfavo.length;i++){
      if(ewnfavo[i].id===geoid){currloc=true;}
    }
    if(currloc){
      $("#favostar .favostar").removeClass("fa-star-o").addClass("fa-star");
    }else{
      $("#favostar .favostar").removeClass("fa-star").addClass("fa-star-o");
    }
    $.jStorage.set("ewnfavo", ewnfavo);
    $.jStorage.setTTL("ewnfavo", 32000000000);
    $.cookie("ewnfavo", JSON.stringify(ewnfavo), { expires : 365 });
  },250);
}

function locateme(){
  if(navigator.geolocation){
    haveGPS = true;
    function positionSuccess(location) {
      geo={lat:location.coords.latitude,lon:location.coords.longitude,time:now};
      $.jStorage.set("frcloc", JSON.stringify(geo));
      $.jStorage.setTTL("frcloc", 3600);
      $.cookie("frcloc", JSON.stringify(geo), { expires : 1 });
      url='https://'+window.location.hostname+window.location.pathname+'?lang='+lang+'&lat='+location.coords.latitude+'&lon='+location.coords.longitude+p;
      window.location.href=url;
    }
    function positionFail(failure) {
      if(failure.message.indexOf("Only secure origins are allowed") == 0) {
        url='https://'+window.location.hostname+window.location.pathname+'?lang='+lang+'&lat='+geoiplat+'&lon='+geoiplon+p;
        window.location.href=url;
      }else{
        alert("The localization failed, try again.");
      }
    }
    var options = { enableHighAccuracy: true,timeout: 10000,maximumAge: 240000};
    navigator.geolocation.getCurrentPosition(positionSuccess, positionFail,options);
  }
}

function isNumber(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}

function wget(urls, fn) {
  var results = [],complete = 0,total = urls.length;
  urls.forEach(function(url, i) {
    var request = new XMLHttpRequest();
    request.open('GET', url, true);
    request.onload = function () {
      if (request.status < 200 && request.status > 400) return;
      results[i] = request.responseText;
      complete++;
      if (complete === total) fn.apply(null, results);
    };
    request.send();
  });
}

function getbrowser(){
    var ua= navigator.userAgent, tem, 
    M= ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
    if(/trident/i.test(M[1])){
        tem=  /\brv[ :]+(\d+)/g.exec(ua) || [];
        return {name:'IE',version:(tem[1] || '')};
    }
    if(M[1]=== 'Chrome'){
        tem= ua.match(/\b(OPR|Edge)\/(\d+)/);
        if(tem!= null) return {name:tem[1].replace('OPR', 'Opera'),version:tem[2]};
    }
    M= M[2]? [M[1], M[2]]: [navigator.appName, navigator.appVersion, '-?'];
    if((tem= ua.match(/version\/(\d+)/i))!= null) M.splice(1, 1, tem[1]);
    return {name:M[0],version:M[1]};
};

/*##############################################################################################
  # MAPS
*/

function loadmaps(){ 

    deflat=lat;
    deflon=lon;
    defzoom=defzoom+3;
    wsmap = L.map("map",{
      timeDimensionControl: true,
      timeDimensionControlOptions: {
        position: 'bottomleft',
        playerOptions: {transitionTime: frcfps,buffer:1,loop:true}
      },
      timeDimension: true,
      timeDimensionOptions: {
        period: "PT1H"
      }
    }).setView([deflat, deflon], defzoom);
    wsmap.attributionControl.setPrefix("")
    
    getmStep(defmap.split("_")[0]);
    var times = [];
    var now = Date.now();
    times.push(mTime);
    for(i=1;i<=mMax;i++){
      times.push((i*mStep)+mTime);
    }
    wsmap.timeDimension.setAvailableTimes(times, "replace");
    wsmap.timeDimension.setCurrentTime(now);
    
    if(mousewheel==0){
      wsmap.scrollWheelZoom.disable();
    }
    
    lightmap = L.tileLayer("https://a."+basepath+"/tiles/nat_g/{z}/{x}/{y}.png", {attribution: ""})
      .addTo(wsmap).setZIndex(2);
    
    var wxWMS = "https://a.maps.nordicweather.net/tiles/frcst/esri_"
    wxLayer = L.tileLayerwx.wms(wxWMS, {
      layers: defmap,
      transparent: true,
      opacity:0.85
    });
    wxTimeLayer = L.timeDimension.layer.wmswx(wxLayer, {});
    wxTimeLayer.addTo(wsmap).setZIndex(4);
    
    dlines = L.tileLayer("https://b."+basepath+"/tiles/lines_gray/{z}/{x}/{y}.png", {attribution: ""})
      .addTo(wsmap).setZIndex(6);
    $("#"+defmap).prop("checked", true);
    checkBaseLayer(defbase);
    $("#basemapDropdown li").click(function(){
      var basemap=$(this).attr("id");
      checkBaseLayer(basemap);
    });
    
    getwindy(defmap,wsmap.timeDimension.getCurrentTimeIndex());
    wsmap.timeDimension.on('timeloading', function() { 
      updwindy();
    });
    
    legendchoose();
    
    $('#windonoff').change(function() {
      if($(this).prop('checked')){
        updwindy();
      }else{
        clearWind();
      }
    });
    $('#windcolor').change(function() {
      if($(this).prop('checked')){
        windColor=windColorLight;
        redraw();
      }else{
        windColor=windColorDark;
        redraw();
      }
    });
    
    $("#models").html($("#"+defmap.split("_")[0]).text().split("-")[0]);
    $("#modelDropdown li").on("click",function(){
      var model=$(this).text().split("-")[0];
      var modelid=$(this).attr("id");
      $("#models").html(model);
      $("#mapLayers ul").remove();
      $("#maplayer").html("Choose map");
      $("#"+modelid+"Dropdown").clone().appendTo("#mapLayers");
      $('[data-hover="dropdown"]').dropdownHover();
      layerdrop();
    });
    
    $("#"+defmap.split("_")[0]+"Dropdown").clone().appendTo("#mapLayers");
    $("#maplayer").html($("#"+defmap).text());
    $('[data-hover="dropdown"]').dropdownHover();
    layerdrop();
    playerwidth();
    
  } // EOF LOADMAPS
  
  function playerwidth(){
    /*Chewing-gum for the player to show up correctly in mobile devices...*/
    var mapwidth=$("#map").width();
    if(mapwidth<650){
      $('.timecontrol-backward, .timecontrol-play, .timecontrol-forward').css({"min-width":(mapwidth*0.14)+"px"});
      $('.timecontrol-date').css({"min-width":(mapwidth*0.50)+"px"});
      $('.timecontrol-slider').css({"min-width":(mapwidth*0.55)+"px"});
      $('.timecontrol-speed').css({"min-width":(mapwidth*0.35)+"px","max-width":(mapwidth*0.35)+"px"});
    }else if(mapwidth<760){
      $('.timecontrol-backward, .timecontrol-play, .timecontrol-forward').css({"min-width":"40px"});
      $('.timecontrol-date').css({"min-width":"165px"});
      $('.timecontrol-slider').css({"min-width":(mapwidth-474)+"px","max-width":(mapwidth - 474)+"px"});
      $('.timecontrol-speed').css({"min-width":"145px","max-width":"145px"});
    }else{
      $('.timecontrol-backward, .timecontrol-play, .timecontrol-forward').css({"min-width":"40px"});
      $('.timecontrol-date').css({"min-width":"170px"});
      $('.timecontrol-slider').css({"min-width":"300px"});
      $('.timecontrol-speed').css({"min-width":"150px","max-width":"150px"});
    }
    if(mapwidth<650){
      $('#lelegend').css({"bottom":"95px"});
    }else if(mapwidth<900){
      $('#lelegend').css({"bottom":"60px"});
    } else {
      $('#lelegend').css({"bottom":"10px"});
    }
  }
  
  function legendchoose(){
    var mapwidth=$("#map").width();
    var mapheight=$("#map").height();
    var mo=layerPath.split("_")[0];
    var ty=layerPath.split("_")[1];
    if(ty=="baro"||ty=="cin"||ty=="clouds"||mapheight<430){
      $("#lelegend").animate({height: "hide", width: "hide"}, 100, "linear").html("");
    }else{
      letable = ty;
      if(ty=="psnow"||ty=="rrate"){letable="precip1";}
      if(mo=="fmi"||mo=="mf"||mo=="dwd"){ 
        $(".lesleetsnow").show();
        $(".lehail, .lelight, .lefrz").hide();
        if(mo=="dwd"){$(".lelight").show();}
      }
      if(mo=="wrf"){$(".lesleetsnow, .lehail, .lelight, .lefrz").show();}
      if(mo=="gfs"||ty=="rrate"){$(".lesleetsnow, .lehail, .lelight, .lefrz").hide();}
      $("#lelegend").animate({height: "hide", width: "hide"}, 100, "linear").html("");
      $("."+letable).clone().appendTo("#lelegend").show();
      $("#lelegend").animate({height: "show", width: "show"}, 500, "linear").css({display:"inline-block"});
    }
  }
  
  function layerdrop(){
    $("#mapLayers li").on("click",function(){
      oldPath=layerPath.split("_")[0];
      oldTy = getType();
      layerPath=$(this).attr("id");
      updStats(layerPath);
      newPath=layerPath.split("_")[0];
      newTy = getType();
      $("#maplayer").html($("#"+layerPath).text());
      getmStep(layerPath.split("_")[0]);
      var times = [];
      var now = Date.now();
      times.push(mTime);
      for(i=1;i<=mMax;i++){
        times.push((i*mStep)+mTime);
      }
      wxTimeLayer.setParams({layers:layerPath});
      if(oldPath!=newPath||oldTy!=newTy){
        wsmap.timeDimension.setAvailableTimes(times, "replace");
        wsmap.timeDimension.setCurrentTime(now);
        updwindy();
      }
      legendchoose();
    });
  }
  
  function updStats(layerPath){
    $.getJSON("https://euweather.eu/backend/frc/stats.php?callback=?",{"typ":layerPath},function(result){});
  }
  
  function getwindy(model,step){
    $.ajaxSetup({ cache: false });
    var moty = getType();
    $.getJSON(ewnpath+"ewn/ewn_proxy.php?callback=?",{"model":model,"step":step},function(result){
      canvasOverlay = L.canvasOverlay().drawing(redraw).addTo(wsmap);
      windy = new Windy({canvas: canvasOverlay.canvas(), data: result});
      context = canvasOverlay.canvas().getContext('2d');
      wsmap.on('dragstart', function() { clearWind() });
      wsmap.on('zoomstart', function() { clearWind() });
      wsmap.on('resize', function() { clearWind() });
      windyCache[model]=[];
      windyCache[model][moty]=[];
      windyCache[model][moty][step]=result;
    });
  }
  
  function updwindy(){
    if(wsmap.timeDimension._loadingTimeIndex>-1){
      var step = wsmap.timeDimension._loadingTimeIndex;
    }else{
      var step = wsmap.timeDimension.getCurrentTimeIndex();
    }
    model = layerPath;
    var moty = getType();
    if($("#windonoff").prop('checked')){
      if(wsmap.timeDimensionControl._player!==undefined&&wsmap.timeDimensionControl._player.isPlaying()){
        clearWind();
        if(isPlaying==-1){
          wsmap.on('playStopped', function() {
            if(wsmap.timeDimension._loadingTimeIndex>-1){
              var step = wsmap.timeDimension._loadingTimeIndex;
            }else{
              var step = wsmap.timeDimension.getCurrentTimeIndex();
            }
            updwindy();
          });
        }
        isPlaying=1;
      }else{
        if(windyCache[model]===undefined){windyCache[model]=[];}
        if(windyCache[model][moty]===undefined){windyCache[model][moty]=[];}
        if(windyCache[model][moty][step]===undefined){
          $.ajaxSetup({ cache: false });
          $.getJSON(ewnpath+"ewn/ewn_proxy.php?callback=?",{"model":model,"step":step},function(result){
            windy.params.data=result;
            windy.stop();
            redraw();
            windyCache[model][moty][step]=result;
          });
        }else{
          windy.params.data=windyCache[model][moty][step];
          windy.stop();
          redraw();
        }
      }
    }
  }
  
  function getType(){
    var moty = layerPath.split("_")[1];
    if(moty=="strm"){return "strm";}
    else if(moty=="wind250"){return "jet";}
    else{return "wind";}
  }

  function redraw(overlay, params) {
    if( timer ){window.clearTimeout( timer );} 
    if($("#windonoff").prop('checked')){
      timer = setTimeout(function() { 
        var bounds = wsmap.getBounds();
        var size = wsmap.getSize();
        windy.start( [[0,0],[size.x, size.y]], size.x, size.y, 
          [[bounds._southWest.lng, bounds._southWest.lat ],[bounds._northEast.lng, bounds._northEast.lat]] );
      },5);
    }
  }

  function clearWind() {
    windy.stop();
    context.clearRect(0,0,3000, 3000);
  }
 
	function checkBaseLayer(basemap){
    if(basemap=="gray"){
      lightmap.setUrl("https://a."+basepath+"/tiles/nat_g/{z}/{x}/{y}.png");
      dlines.setUrl("https://b."+basepath+"/tiles/lines_gray/{z}/{x}/{y}.png").bringToFront();
    }
    if(basemap=="normal"){
      lightmap.setUrl("https://a."+basepath+"/tiles/normday/{z}/{x}/{y}.png");
      dlines.setUrl("https://b."+basepath+"/tiles/lines_gray/{z}/{x}/{y}.png").bringToBack();
    }
    if(basemap=="sat"){
      lightmap.setUrl("https://a."+basepath+"/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}.png");
      dlines.setUrl("https://b."+basepath+"/tiles/lines_gray/{z}/{x}/{y}.png").bringToFront();
    }
    return false;
  }

  function getcuroffset() {
    var curtime = new Date().getTime();
    for (i=0; i<=maxoffset; i++) {
      if (mTime+(i*mStep) > curtime-mStep/2) {
        return i;
      }
    }
    return 0;
  }

  function savestorage(stpl){
    if($.jStorage.get("wrffrc")){boset=$.jStorage.get("wrffrc");}
    lastplaces = boset.lastplaces;
    lastplaces.unshift(stpl);
    if(lastplaces.length>12){lastplaces.pop();}
    boset.lastplaces=lastplaces;
    $.jStorage.set("wrffrc", boset);
    $.jStorage.setTTL("wrffrc", cookieage);
    return false;
  }

  function getmStep(val){
    if(val=="yr"){
      mStep=mapconf["yr"]["yrsteps"]*3600000;
      mTime = mapconf["yr"]["yrtime"];
      mMax = (mapconf["yr"]["yrlength"]/mapconf["yr"]["yrsteps"]);
      $("#attrTxt").html('Data: Norwegian Meteorological Institute, <a target="_blank" href="http://www.met.no">met.no</a>');
    }
    if(val=="fmi"){
      mStep=mapconf["fmi"]["fmisteps"]*3600000;
      mTime = mapconf["fmi"]["fmitime"];
      mMax = (mapconf["fmi"]["fmilength"]/mapconf["fmi"]["fmisteps"]);
      $("#attrTxt").html('Data: Finnish Meteorological Institute, <a target="_blank" href="http://www.fmi.fi">fmi.fi</a>');
    }
    if(val=="dwd"){
      mStep=mapconf["dwd"]["dwdsteps"]*3600000;
      mTime = mapconf["dwd"]["dwdtime"];
      mMax = (mapconf["dwd"]["dwdlength"]/mapconf["dwd"]["dwdsteps"]);
      $("#attrTxt").html('Data: Deutscher Wetterdienst, <a target="_blank" href="http://www.dwd.de">dwd.de</a>');
    }
    if(val=="wrf"){
      mStep=mapconf["wrf"]["wrfsteps"]*3600000;
      mTime = mapconf["wrf"]["wrftime"];  
      mMax = (mapconf["wrf"]["wrflength"]/mapconf["wrf"]["wrfsteps"]);
      $("#attrTxt").html('Data: EWN WRFDA, <a target="_blank" href="http://www.europeanweathernetwork.eu">European Weathernetwork</a>');
    }
    if(val=="gfs"){
      mStep=mapconf["gfs"]["gfssteps"]*3600000;
      mTime = mapconf["gfs"]["gfstime"];  
      mMax = (mapconf["gfs"]["gfslength"]/mapconf["gfs"]["gfssteps"]);
      $("#attrTxt").html('Data: Global Forecast System (GFS), <a target="_blank" href="http://www.noaa.gov/">NOAA</a>');
    }
    if(val=="gfseur"){
      mStep=mapconf["gfseur"]["gfseursteps"]*3600000;
      mTime = mapconf["gfseur"]["gfseurtime"];  
      mMax = (mapconf["gfseur"]["gfseurlength"]/mapconf["gfseur"]["gfseursteps"]);
      $("#attrTxt").html('Data: Global Forecast System (GFS), <a target="_blank" href="http://www.noaa.gov/">NOAA</a>');
    }
    if(val=="mf"){
      mStep=mapconf["mf"]["mfsteps"]*3600000;
      mTime = mapconf["mf"]["mftime"];
      mMax = (mapconf["mf"]["mflength"]/mapconf["mf"]["mfsteps"]);
      $("#attrTxt").html('Data: Meteo France, <a target="_blank" href="http://www.meteofrance.com">meteofrance.com</a>');
    }
    if(val=="test"){
      mStep=mapconf["test"]["teststeps"]*3600000;
      mTime = mapconf["test"]["testtime"];  
      mMax = (mapconf["test"]["testlength"]/mapconf["test"]["teststeps"]);
      $("#attrTxt").html('Data: GEM-GDPS, <a target="_blank" href="http://weather.gc.ca/">Canadian Meteorological Centre</a>');
    }
    return false;
  }

/*##############################################################################################
  # SVG-ICONS
*/

function getwindicon_svg(val,dir,gst,bft,wunit){
  wlimita=14;
  wlimitb=21;
  if(wunit == "km/h"){wlimita=50;wlimitb=76;}
  if(wunit == "mph"){wlimita=31;wlimitb=47;}
  if(wunit == "kts"){wlimita=27;wlimitb=41;}
  wi = Math.round(fixWspd(val));
  wcolor=wiconcolor(wi,wlimita,wlimitb);
  if (typeof gst !== 'undefined') {
    gsttip=' data-toggle="tooltip" data-placement="top" title="'+bft+' bft, '+txtgust+' '+Math.round(fixWspd(gst))+' '+wunit+'"';
  }else{
    gsttip=' data-toggle="tooltip" data-placement="top" title="'+bft+' bft"';
  }
  wline='<div style="width:50px;margin:0 auto;"'+gsttip+'><svg class="svg" viewBox="0 0 104 104" height="48" width="48"><g class="wind"><path d="M76.002,51.998c0,13.26-10.746,24.004-24.002,24.004 c-13.254,0-24.002-10.744-24.002-24.004c0-13.254,10.748-24,24.002-24C65.256,27.998,76.002,38.744,76.002,51.998z" stroke-width="6.0721" stroke="'+wcolor+'" fill="#3E576B"></path><polygon points="65.966,81.677 62.416,85.361 58.875,89.044 55.332,92.72 51.794,96.4 48.345,92.626 44.91,88.851 41.468,85.08 38.031,81.31 45.105,82.21 51.992,83.193 59.154,82.404" stroke-width="4.0721" stroke="'+wcolor+'" fill="#3E576B" transform="rotate('+dir+',52,52)"></polygon><text dy="7pt" y="49%" x="50%" style="font-family:ubuntu;font-size:20pt;" fill="#fff">'+wi+'</text></g></svg></div>';
  return wline;
}

function wiconcolor(i,wlimita,wlimitb){
  if(i<wlimita){return "#88a4ba";}
  else if (i<wlimitb){return "#F89C26";}
  else {return "#FF4040";}
}

var shapes = new Array();
shapes["cloud"]="d=\"M441.953,142.352c-4.447-68.872-61.709-123.36-131.705-123.36c-59.481,0-109.766,39.346-126.264,93.429c-9.244-3.5-19.259-5.431-29.729-5.431c-42.84,0-78.164,32.08-83.322,73.523c-0.309-0.004-0.614-0.023-0.924-0.023c-36.863,0-66.747,29.883-66.747,66.747s29.883,66.746,66.747,66.746c4.386,0,8.669-0.436,12.819-1.243c20.151,27.069,52.394,44.604,88.734,44.604c31.229,0,59.429-12.952,79.533-33.772c15.071,15.091,35.901,24.428,58.913,24.428c31.43,0,58.783-17.42,72.955-43.127c11.676,5.824,24.844,9.106,38.777,9.106c48.047,0,86.998-38.949,86.998-86.996C508.738,185.895,480.252,151.465,441.953,142.352z\"/>";
shapes["lightning"]="class=\"lightning\" fill-rule=\"evenodd\" clip-rule=\"evenodd\" d=\"m 3.4723994,8.5185577 3.0304576,-7.0710678 6.944799,0 -5.0191957,5.08233 4.1353117,0 -8.1127873,9.0913731 2.0834396,-7.1342026 z\"/>";
shapes["tornado"]="class=\"tornado\" fill-rule=\"evenodd\" d=\"M3.51795549,3.09677419 C4.55956613,1.38647295 9.11409512,0 16.017284,0 C22.9204728,0 27.3855446,1.64705965 28.5166124,3.09677419 C30.0790285,5.09935736 27.6364411,9.83203892 20.1837273,14.4516129 C13.8294775,18.3903027 9.14478347,22.2210455 12.8924519,23.7419355 C21.8177932,27.3640441 17.0588943,32 17.0588943,32 C17.0588943,32 17.0588947,28.9032253 13.934062,27.8709677 C8.65191269,26.1260613 6.64278758,24.7741935 4.55956617,22.7096774 C2.98366184,21.147923 1.2876824,16.2185972 6.64278762,11.3548387 C9.30758236,8.93454683 1.51950057,6.37819267 3.51795549,3.09677419 Z M27,4.03225806 C27,2.37540373 22.0751325,1.03225806 16,1.03225806 C9.92486745,1.03225806 5,2.37540373 5,4.03225806 C5,5.6891124 9.92486745,7.03225806 16,7.03225806 C22.0751325,7.03225806 27,5.6891124 27,4.03225806 Z M27,4.03225806\"/>";
shapes["hurricane"]="class=\"hurricane\" d=\"M 21.05263,282.71812 C 21.05263,263.14772 5.13832,247.26423 -14.46943,247.26423 C -20.99403,247.26423 -27.10709,249.01667 -32.36199,252.08515 C -25.97086,231.2175 -15.39876,214.28402 -1.84069,207.37258 C -28.92355,216.4934 -47.76995,248.20401 -50,282.68374 C -50,302.25413 -34.07718,318.17761 -14.46943,318.1776 C -8.02952,318.1776 -1.98598,316.46325 3.22446,313.46822 C -3.19061,334.0152 -13.85506,350.53308 -27.272,357.37258 C -0.62131,348.3973 18.34408,316.45182 21.05263,282.71812 z\"/>";
shapes["waterdrop"]="class=\"waterdrop\" fill-rule=\"evenodd\" clip-rule=\"evenodd\" d=\"M150.2 464.6h-.1c-15.5 0-28.1-12.7-28.1-28.2v-4c0-.3 0-.5.1-.8v-.3c1.4-11.6 9.6-22.2 16.9-31.7 5.9-7.6 10.9-14.1 10.9-19.5 0-.1.1-.1.2-.1h.1c.1 0 .1 0 .1.1 0 5.4 5.1 12 10.9 19.5 8 10.3 17 22 17 35v1.8c0 15.5-12.5 28.2-28 28.2zm25-42.9c0 .1 0 .1.1.2-.1-.1-.1-.2-.1-.2zm.4 1l.1.3-.1-.3zm.4 1l.1.4c0-.1-.1-.2-.1-.4zm.3 1.1l.2.5c-.1-.2-.1-.4-.2-.5zm.4 1l.3 1.1c-.1-.3-.2-.7-.3-1.1zm.4 1.6c.1.2.1.4.1.6l-.1-.6zm.2 1.1l.1.6c0-.2 0-.4-.1-.6zm.3 1.1l.1.6c-.1-.2-.1-.4-.1-.6zm.1 1.1c0 .2 0 .4.1.5 0-.1 0-.3-.1-.5zm.2 1.2v.5-.5zm.1 1.2v.4-.4z\"/>";
shapes["ice"]="class=\"ice\" points=\"153.317,416 173.313,457.373 194,416 \"/>";
shapes["snowflake"]="class=\"snowflake\" points=\"266.125,427.569 246.082,427.598 244.383,427.773 245.355,426.434 255.378,409.032 240.345,400.389 230.34,417.775 229.65,419.32 228.951,417.768 218.906,400.423 203.895,409.101 213.865,426.307 214.939,427.812 213.062,427.642 193.209,427.667 193.232,445.077 213.062,445.05 214.963,444.874 213.821,446.511 203.969,463.614 219.002,472.26 228.933,455.003 229.695,453.328 230.408,454.903 240.441,472.227 255.452,463.548 245.362,446.141 244.406,444.835 245.928,445.008 266.147,444.981 \"/>";
shapes["hail"]="class=\"hail\" cx=\"277.678\" cy=\"436.324\" r=\"26.895\"/>";
shapes["sun_1"]="class=\"sun_center\" d=\"M255.725,324.881c-37.958,0-68.84-30.882-68.84-68.84s30.881-68.839,68.84-68.839c37.958,0,68.839,30.881,68.839,68.839S293.683,324.881,255.725,324.881z\"/>";
shapes["sun_2"]="class=\"sun\" d=\"M128.363,195.126l11.058-19.152l34.855,20.125c-4.398,5.948-8.128,12.354-11.126,19.111L128.363,195.126z M267,115h-22v40.574c3-0.383,7.158-0.577,10.739-0.577c3.759,0,8.261,0.212,11.261,0.633V115z M196.093,174.419c5.982-4.368,12.412-8.059,19.18-11.011l-20.202-34.99l-19.152,11.058L196.093,174.419z M383.61,195.126l-11.058-19.152L337.33,196.31c4.384,5.96,8.097,12.377,11.076,19.142L383.61,195.126z M155.064,267c-0.387-4-0.583-7.198-0.583-10.8c0-3.736,0.21-7.2,0.626-11.2H115v22H155.064z M336.055,139.475l-19.153-11.058l-20.307,35.176c6.763,2.987,13.176,6.705,19.13,11.092L336.055,139.475z M316.9,383.665l19.153-11.059l-20.169-34.932c-5.949,4.399-12.354,8.132-19.109,11.131L316.9,383.665z M139.421,336.108l34.649-20.005c-4.38-5.965-8.087-12.385-11.062-19.148l-34.646,20.001L139.421,336.108z M397,267v-22h-40.659c0.415,4,0.626,7.464,0.626,11.2c0,3.602-0.196,6.8-0.583,10.8H397zM372.552,336.108l11.058-19.152l-35.062-20.243c-2.955,6.768-6.646,13.196-11.016,19.177L372.552,336.108z M195.072,383.665l20.019-34.674c-6.766-2.968-13.188-6.671-19.159-11.046l-20.012,34.661L195.072,383.665z M267,397v-40.149c-3,0.42-7.504,0.632-11.261,0.632c-3.581,0-7.739-0.193-10.739-0.577V397H267z M335.66,256.041c0-44.077-35.859-79.936-79.936-79.936c-44.077,0-79.937,35.859-79.937,79.936c0,44.077,35.859,79.937,79.937,79.937C299.801,335.978,335.66,300.118,335.66,256.041z M312.563,256.041c0,31.342-25.498,56.84-56.839,56.84c-31.342,0-56.84-25.498-56.84-56.84c0-31.341,25.498-56.839,56.84-56.839C287.065,199.202,312.563,224.7,312.563,256.041z\"/>";
shapes["moon"]="class=\"moon\" d=\"M248.082,263.932c-31.52-31.542-39.979-77.104-26.02-116.542c-15.25,5.395-29.668,13.833-41.854,26.02  c-43.751,43.75-43.751,114.667,0,158.395c43.729,43.73,114.625,43.752,158.374,0c12.229-12.186,20.646-26.604,26.021-41.854  C325.188,303.91,279.604,295.451,248.082,263.932z\"/>";
shapes["fog"]="class=\"fog\" d=\"M392,432H120v23h272V432z\"/>";
shapes["nan"]="class=\"nan\" d=\"M 273.79665,278.39483 L 176.01526,278.41797 C 176.01516,262.63035 180.66722,249.81298 184.24805,239.96582 C 187.82867,230.11898 193.15907,221.12648 200.23926,212.98828 C 207.31921,204.85046 223.22902,190.52755 247.96875,170.01953 C 261.15216,159.27758 267.74395,149.43059 267.74414,140.47852 C 267.74395,131.52696 265.0991,124.56896 259.80957,119.60449 C 254.51968,114.64058 246.50374,112.15849 235.76172,112.1582 C 224.20558,112.15849 214.64342,115.98336 207.0752,123.63281 C 199.50672,131.28282 194.6646,144.62916 192.54883,163.67188 L 97.822266,151.95313 C 101.07745,117.12268 113.73206,89.087225 135.78613,67.84668 C 157.84009,46.606799 191.65353,35.986692 237.22656,35.986328 C 272.70814,35.986692 301.35395,43.392284 323.16406,58.203125 C 352.78619,78.222978 367.59737,104.91566 367.59766,138.28125 C 367.59737,152.11613 363.7725,165.46247 356.12305,178.32031 C 348.47304,191.17859 332.84805,206.88496 309.24805,225.43945 C 291.37819,235.59876 274.96586,253.5497 274.54302,262.53489 L 273.79665,278.39483 z M 175.70313,312.35352 L 275.06836,312.35352 L 275.06836,400 L 175.70313,400 L 175.70313,312.35352 z\"/>";

function geticon(ic){
  var svg;
  switch (ic) {
    case "hurricane":
      svg='<path transform="scale(2) translate(140,-155)" '+shapes["hurricane"];
      break;
    case "tornado":
      svg='<path transform="scale(8) translate(16,18)" '+shapes["tornado"];
      break;
    case "tornadothunder":
      svg='<path transform="scale(5) translate(25,55)" '+shapes["tornado"]+'<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(18,21)" '+shapes["lightning"];
      break;
    case "heavy_thunder":
      svg='<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<path transform="scale(12) translate(18,21)" '+shapes["lightning"];
      break;
    case "rainthunder":
      svg='<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<path transform="translate(120,-50)" '+shapes["waterdrop"]+'<path transform="translate(190,-50)" '+shapes["waterdrop"];
      break;
    case "hailthunder":
      svg='<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<circle  transform="translate(0,-75)" '+shapes["hail"]+'<circle  transform="translate(70,-75)" '+shapes["hail"];
      break;
    case "snowthunder":
      svg='<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<polygon transform="translate(35,-70)" '+shapes["snowflake"]+'<polygon transform="translate(125,-70)" '+shapes["snowflake"];
      break;
    case "rainthundershower":
      svg='<path transform="scale(0.80) translate(0,-20)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(0,-20)" '+shapes["sun_2"]+'<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<path transform="translate(120,-50)" '+shapes["waterdrop"]+'<path transform="translate(190,-50)" '+shapes["waterdrop"];
      break;
    case "hailthundershower":
      svg='<path transform="scale(0.80) translate(0,-20)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(0,-20)" '+shapes["sun_2"]+'<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<circle  transform="translate(0,-75)" '+shapes["hail"]+'<circle  transform="translate(70,-75)" '+shapes["hail"];
      break;
    case "snowthundershower":
      svg='<path transform="scale(0.80) translate(0,-20)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(0,-20)" '+shapes["sun_2"]+'<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<polygon transform="translate(35,-70)" '+shapes["snowflake"]+'<polygon transform="translate(125,-70)" '+shapes["snowflake"];
      break;
    case "nt_rainthundershower":
      svg='<path transform="scale(0.85) translate(20,-50)" '+shapes["moon"]+'<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<path transform="translate(120,-50)" '+shapes["waterdrop"]+'<path transform="translate(190,-50)" '+shapes["waterdrop"];
      break;
    case "nt_hailthundershower":
      svg='<path transform="scale(0.85) translate(20,-50)" '+shapes["moon"]+'<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<circle  transform="translate(0,-75)" '+shapes["hail"]+'<circle  transform="translate(70,-75)" '+shapes["hail"];
      break;
    case "nt_snowthundershower":
      svg='<path transform="scale(0.85) translate(20,-50)" '+shapes["moon"]+'<path transform="scale(0.60) translate(170,170)" class="thundercloud" '+shapes["cloud"]+'<path transform="scale(12) translate(8,21)" '+shapes["lightning"]+'<polygon transform="translate(35,-70)" '+shapes["snowflake"]+'<polygon transform="translate(125,-70)" '+shapes["snowflake"];
      break;
    case "clear":
      svg='<path '+shapes["sun_1"]+'<path '+shapes["sun_2"];
      break;
    case "mostlyclear":
      svg='<path '+shapes["sun_1"]+'<path '+shapes["sun_2"]+'<path transform="scale(0.30) translate(760,760)" class="light_cloud" '+shapes["cloud"];
      break;
    case "partlycloudy":
      svg='<path transform="scale(0.80) translate(40,70)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(40,70)" '+shapes["sun_2"]+'<path transform="scale(0.42) translate(420,500)" class="middle_cloud" '+shapes["cloud"];
      break;
    case "mostlycloudy":
      svg='<path transform="scale(0.80) translate(20,50)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,50)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,360)" class="dark_cloud" '+shapes["cloud"];
      break;
    case "nt_clear":
      svg='<path '+shapes["moon"];
      break;
    case "nt_mostlyclear":
      svg='<path '+shapes["moon"]+'<path transform="scale(0.30) translate(760,760)" class="light_cloud" '+shapes["cloud"];
      break;
    case "nt_partlycloudy":
      svg='<path transform="scale(0.92) translate(30,10)" '+shapes["moon"]+'<path transform="scale(0.42) translate(420,500)" class="middle_cloud" '+shapes["cloud"];
      break;
    case "nt_mostlycloudy":
      svg='<path transform="scale(0.85) translate(40,40)" '+shapes["moon"]+'<path transform="scale(0.50) translate(260,360)" class="dark_cloud" '+shapes["cloud"];
      break;
    case "cloudy":
      svg='<path transform="scale(0.60) translate(160,260)" class="dark_cloud" '+shapes["cloud"];
      break;
    case "rain4":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(5,-50)" '+shapes["waterdrop"]+'<path transform="translate(75,-50)" '+shapes["waterdrop"]+'<path transform="translate(145,-50)" '+shapes["waterdrop"]+'<path transform="translate(215,-50)" '+shapes["waterdrop"];
      break;
    case "rain3":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(15,-50)" '+shapes["waterdrop"]+'<path transform="translate(110,-50)" '+shapes["waterdrop"]+'<path transform="translate(205,-50)" '+shapes["waterdrop"];
      break;
    case "rain2":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(65,-50)" '+shapes["waterdrop"]+'<path transform="translate(165,-50)" '+shapes["waterdrop"];
      break;
    case "rain1":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(115,-50)" '+shapes["waterdrop"];
      break;
    case "rainshowers":
      svg='<path transform="scale(0.80) translate(20,10)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,10)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(115,-40)" '+shapes["waterdrop"];
      break;
    case "moderaterainshowers":
      svg='<path transform="scale(0.80) translate(20,10)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,10)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(65,-40)" '+shapes["waterdrop"]+'<path transform="translate(165,-40)" '+shapes["waterdrop"];
      break;
    case "heavyrainshowers":
      svg='<path transform="scale(0.80) translate(20,10)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,10)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(40,-40)" '+shapes["waterdrop"]+'<path transform="translate(115,-40)" '+shapes["waterdrop"]+'<path transform="translate(190,-40)" '+shapes["waterdrop"];
      break;
    case "nt_rainshowers":
      svg='<path transform="scale(0.85) translate(40,10)" '+shapes["moon"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(115,-40)" '+shapes["waterdrop"];
      break;
    case "nt_moderaterainshowers":
      svg='<path transform="scale(0.85) translate(40,10)" '+shapes["moon"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(65,-40)" '+shapes["waterdrop"]+'<path transform="translate(165,-40)" '+shapes["waterdrop"];
      break;
    case "nt_heavyrainshowers":
      svg='<path transform="scale(0.85) translate(40,10)" '+shapes["moon"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(40,-40)" '+shapes["waterdrop"]+'<path transform="translate(115,-40)" '+shapes["waterdrop"]+'<path transform="translate(190,-40)" '+shapes["waterdrop"];
      break;
    case "freezingrain":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="scale(1.5) translate(-50,-185)" '+shapes["ice"]+'<path transform="translate(115,-50)" '+shapes["waterdrop"]+'<path transform="translate(205,-50)" '+shapes["waterdrop"];
      break;
    case "drizzle":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<path transform="scale(0.60) translate(85,170)" '+shapes["waterdrop"]+'<path transform="scale(0.60) translate(165,170)" '+shapes["waterdrop"]+'<path transform="scale(0.60) translate(245,170)" '+shapes["waterdrop"]+'<path transform="scale(0.60) translate(325,170)" '+shapes["waterdrop"]+'<path transform="scale(0.60) translate(405,170)" '+shapes["waterdrop"]+'<path transform="scale(0.60) translate(485,170)" '+shapes["waterdrop"];
      break;
    case "freezingdrizzle":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="scale(1.2) translate(-35,-135)" '+shapes["ice"]+'<path transform="scale(0.60) translate(215,170)" '+shapes["waterdrop"]+'<path transform="scale(0.60) translate(295,170)" '+shapes["waterdrop"]+'<path transform="scale(0.60) translate(375,170)" '+shapes["waterdrop"]+'<path transform="scale(0.60) translate(455,170)" '+shapes["waterdrop"];
      break;
    case "snow3":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-60,-60)" '+shapes["snowflake"]+'<polygon transform="translate(30,-60)" '+shapes["snowflake"]+'<polygon transform="translate(120,-60)" '+shapes["snowflake"];
      break;
    case "snow2":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-25,-60)" '+shapes["snowflake"]+'<polygon transform="translate(90,-60)" '+shapes["snowflake"];break;
    case "snow1":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(35,-60)" '+shapes["snowflake"];
      break;
    case "heavysnowshowers":
      svg='<path transform="scale(0.80) translate(20,10)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,10)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-55,-55)" '+shapes["snowflake"]+'<polygon transform="translate(35,-55)" '+shapes["snowflake"]+'<polygon transform="translate(125,-55)" '+shapes["snowflake"];
      break;
    case "moderatesnowshowers":
      svg='<path transform="scale(0.80) translate(20,10)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,10)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-25,-55)" '+shapes["snowflake"]+'<polygon transform="translate(90,-55)" '+shapes["snowflake"];
      break;
    case "snowshowers":
      svg='<path transform="scale(0.80) translate(20,10)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,10)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(35,-55)" '+shapes["snowflake"];
      break;
    case "nt_heavysnowshowers":
      svg='<path transform="scale(0.85) translate(40,10)" '+shapes["moon"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-55,-55)" '+shapes["snowflake"]+'<polygon transform="translate(35,-55)" '+shapes["snowflake"]+'<polygon transform="translate(125,-55)" '+shapes["snowflake"];
      break;
    case "nt_moderatesnowshowers":
      svg='<path transform="scale(0.85) translate(40,10)" '+shapes["moon"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-25,-55)" '+shapes["snowflake"]+'<polygon transform="translate(90,-55)" '+shapes["snowflake"];
      break;
    case "nt_snowshowers":
      svg='<path transform="scale(0.85) translate(40,10)" '+shapes["moon"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(35,-55)" '+shapes["snowflake"];
      break;
    case "heavysleet":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-55,-60)" '+shapes["snowflake"]+'<path transform="translate(115,-50)" '+shapes["waterdrop"]+'<polygon transform="translate(125,-60)" '+shapes["snowflake"];
      break;
    case "sleet":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(60,-50)" '+shapes["waterdrop"]+'<polygon transform="translate(90,-60)" '+shapes["snowflake"];
      break;
    case "heavysleetshowers":
      svg='<path transform="scale(0.80) translate(20,10)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,10)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-55,-55)" '+shapes["snowflake"]+'<path transform="translate(115,-40)" '+shapes["waterdrop"]+'<polygon transform="translate(125,-55)" '+shapes["snowflake"];
      break;
    case "sleetshowers":
      svg='<path transform="scale(0.80) translate(20,10)" '+shapes["sun_1"]+'<path transform="scale(0.80) translate(20,10)" '+shapes["sun_2"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(60,-40)" '+shapes["waterdrop"]+'<polygon transform="translate(90,-55)" '+shapes["snowflake"];
      break;
    case "nt_heavysleetshowers":
      svg='<path transform="scale(0.85) translate(40,10)" '+shapes["moon"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<polygon transform="translate(-55,-55)" '+shapes["snowflake"]+'<path transform="translate(115,-40)" '+shapes["waterdrop"]+'<polygon transform="translate(125,-55)" '+shapes["snowflake"];
      break;
    case "nt_sleetshowers":
      svg='<path transform="scale(0.85) translate(40,10)" '+shapes["moon"]+'<path transform="scale(0.50) translate(280,310)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(60,-40)" '+shapes["waterdrop"]+'<polygon transform="translate(90,-55)" '+shapes["snowflake"];
      break;
    case "hail":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<circle  transform="translate(-120,-75)" '+shapes["hail"]+'<circle  transform="translate(-50,-75)" '+shapes["hail"]+'<circle  transform="translate(20,-75)" '+shapes["hail"]+'<circle  transform="translate(90,-75)" '+shapes["hail"];
      break;
    case "fog":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(0,-75)" '+shapes["fog"]+'<path transform="translate(0,-120)" '+shapes["fog"]+'<path transform="translate(0,-165)" '+shapes["fog"]+'<path transform="translate(0,-210)" '+shapes["fog"]+'<path transform="translate(0,-255)" '+shapes["fog"]+'<path transform="translate(0,-300)" '+shapes["fog"];
      break;
    case "nt_fog":
      svg='<path transform="scale(0.60) translate(170,170)" class="dark_cloud" '+shapes["cloud"]+'<path transform="translate(0,-75)" '+shapes["fog"]+'<path transform="translate(0,-120)" '+shapes["fog"]+'<path transform="translate(0,-165)" '+shapes["fog"]+'<path transform="translate(0,-210)" '+shapes["fog"]+'<path transform="translate(0,-255)" '+shapes["fog"]+'<path transform="translate(0,-300)" '+shapes["fog"];
      break;
    default:
      svg='<path transform="scale(0.50) translate(250,300)" '+shapes["nan"];
      break;
  }
  return svg;
}

if(!dateFormat){
var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	return function (date, mask, utc) {
		var dF = dateFormat;
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) throw SyntaxError("invalid date");
		mask = String(dF.masks[mask] || mask || dF.masks["default"]);
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var	_ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function ($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: fdaynames,
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
};
}else{
dateFormat.i18n = {
	dayNames: fdaynames,
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};
}