/* v.2015.3
 */
  var cookieage=32000000000;//1yr
  var basepath="maps.nordicweather.net";
  var wiset = "m/s",mapboxgl,times = [],preload,isPlaying=false,player,lastLayer=1,a=1,speed=1,curoffset=0,maxoffset=18;
  var wsmap,is_phone,currid,mettableid,mStep,mTime,layerPath=defmap,windy,canvasOverlay,timer=null,windyCache=[],isPlaying=false,windColorDark="#333333",windColorLight="#ffffff",windColor=windColorLight;
  var nua = navigator.userAgent;
  var is_anubunturegular = ((nua.indexOf('Mozilla/5.0') > -1 && nua.indexOf('Anubunturegular ') > -1 && nua.indexOf('AppleWebKit') > -1) && !(nua.indexOf('Chrome') > -1));
  var screenheight = $(window).height();
  var screenwidth = $(window).width();
  $("#wrapper").css({height: screenheight+"px"});
  $("#map").css({height: screenheight+"px"});

  var isTouch = Modernizr.touch;
  
function dostuff(){
$(function () {

  // Fix for select's on Anubunturegular stock browser - port from Bootstrap
  if(is_anubunturegular) {
    $('select.form-control').removeClass('form-control').css('width', '100%');
  }

  if($.jStorage.get("ewnwind")){
    wiset=$.jStorage.get("ewnwind");
    $("#wspd").val(wiset);
  }
  $("#wspd").change(function() {
    wiset = $("#wspd").val();
    $.jStorage.set("ewnwind", wiset);
    $.jStorage.setTTL("ewnwind", 32000000000);
  });
  
  if($.jStorage.get("ewnfav-fi")){
    qstr = $.jStorage.get("ewnfav-fi");
    qstr = qstr.split(",");
    if(isNumber(qstr[0])){deflat=qstr[0];}
    if(isNumber(qstr[1])){deflon=qstr[1];}
  }
  
  if($.jStorage.get("ewnphone")){
    is_phone = $.jStorage.get("ewnphone");
    if(is_phone=="true"){
      $(".no_phone").hide();
    }
  }

/*######################################################*/
/* THE MAP */

  defzoom=defzoom+3;
  wsmap = L.map("map",{}).setView([deflat, deflon], defzoom);
  wsmap.attributionControl.setPrefix("");
  if(mousewheel==0){wsmap.scrollWheelZoom.disable();}
    
  var mapboxgl = L.mapboxGL({
    accessToken: 'no-token',
    style: 'https://a.maps.nordicweather.net/vector/openmap_nex.json'
  }).addTo(wsmap);
    
  getmStep(defmap.split("_")[0]);
  curoffset = getcuroffset();
  lastLayer = curoffset+1;
  var now = Date.now();
  times.push(mTime);
  for(i=1;i<=mMax;i++){
    times.push((i*mStep)+mTime);
  }
  
  mapboxgl._glMap.on('load', function () { 
    for(i=1;i<=mMax;i++){
      mapboxgl._glMap.addLayer({
        "id": "wx"+i,
        "type": "raster",
        "source": {
          "type": 'raster',
          "tiles": ['https://a.maps.nordicweather.net/tiles/frcst/esri_'+defmap+'_'+i+'/{z}/{x}/{y}.png'],
          "tileSize": 256
        },
        'layout': {'visibility': 'none'},
        "paint": {'raster-opacity': 0,'raster-opacity-transition': {"duration": 100}}
      },"boundary-level-4");
    }
    mapboxgl._glMap.setLayoutProperty('wx'+lastLayer, 'visibility', 'visible');
    mapboxgl._glMap.setPaintProperty('wx'+lastLayer, 'raster-opacity', 0.7);
    
    preload = setInterval(function(){
      mapboxgl._glMap.setLayoutProperty('wx'+a, 'visibility', 'visible');
      if(a==1){clearInterval(preload);}
      a--;
    },250);   
  });

  $("#slider").slider({
    min: 1,
    max: times.length,
    value: lastLayer,
    range: "min",
    stop: (function( event, ui ) {
      da=new Date(times[ui.value-1]);
      $("#time").html(da.format("dd mmm yyyy HH:MM"));
      newVal=(ui.value-1);  
      mapboxgl._glMap.setLayoutProperty('wx'+newVal, 'visibility', 'visible');
      mapboxgl._glMap.setPaintProperty('wx'+newVal, 'raster-opacity', 0.7);
      mapboxgl._glMap.setPaintProperty('wx'+lastLayer, 'raster-opacity', 0);
      lastLayer=newVal;
    }),
    slide: (function( event, ui ) {
      if(isPlaying){playerStop();}
      da=new Date(times[ui.value-1]);
      $("#time").html(da.format("dd mmm yyyy HH:MM"));
    })
  });
  da=new Date(times[lastLayer-1]);
  $("#time").html(da.format("dd mmm yyyy HH:MM"));
  
  $("#speedslider").slider({
    min: 0.1,
    max: 10,
    value: speed,
    step: 0.1,
    range: "min",
    stop: (function(event, ui ) {
      $("#speedval").html(ui.value.toFixed(1) + " fps");
      speed=(ui.value*1);
      save_locset();
    }),
    slide: (function(event, ui ) {   
      $("#speedval").html(ui.value.toFixed(1)+ " fps");
    })
  });
  $("#speedval").html(speed.toFixed(1)+" fps");
  
  $("#Play").on('click', function () {
    if(isPlaying){playerStop();}
    else{playerStart();}
  });
  $("#Backward").on('click', function () {
    if(isPlaying){playerStop();}
    if(lastLayer>1){
      mapboxgl._glMap.setPaintProperty('wx'+lastLayer, 'raster-opacity', 0);
      lastLayer--;
      $("#slider").slider('value',lastLayer);
      da=new Date(times[lastLayer-1]);
      $("#time").html(da.format("dd mmm yyyy HH:MM"));
      mapboxgl._glMap.setPaintProperty('wx'+lastLayer, 'raster-opacity', 0.7);
    }
  });
  $("#Forward").on('click', function () {
    if(isPlaying){playerStop();}
    if(lastLayer<=maxLayer){
      mapboxgl._glMap.setPaintProperty('wx'+lastLayer, 'raster-opacity', 0);
      lastLayer++;
      $("#slider").slider('value',lastLayer);
      da=new Date(times[lastLayer-1]);
      $("#time").html(da.format("dd mmm yyyy HH:MM"));
      mapboxgl._glMap.setPaintProperty('wx'+lastLayer, 'raster-opacity', 0.7);
    }
  });
  
  function playerStop(){   
    isPlaying=false;
    $("#Play").html('<i class="fa fa-play"></i>');
    clearInterval(player);
  }
  function playerStart(){
    isPlaying=true;
    $("#Play").html('<i class="fa fa-pause"></i>');
    player = setInterval(function(){
      mapboxgl._glMap.setPaintProperty('wx'+lastLayer, 'raster-opacity', 0);
      if(lastLayer==maxLayer){lastLayer=1;}else{lastLayer++;}
      $("#slider").slider('value',lastLayer);
      da=new Date(times[lastLayer-1]);
      $("#time").html(da.format("dd mmm yyyy HH:MM"));
      mapboxgl._glMap.setPaintProperty('wx'+lastLayer, 'raster-opacity', 0.7);
      if(a==maxLayer){clearInterval(preload);}
      a++;
    },1000/speed);
  }

    
   /* lightmap = L.tileLayer("https://a."+basepath+"/tiles/nat_g/{z}/{x}/{y}.png", {attribution: ""})
      .addTo(wsmap).setZIndex(2);
    
    var wxWMS = "https://a.maps.nordicweather.net/tiles/frcst/esri_"
    wxLayer = L.tileLayerwx.wms(wxWMS, {
      layers: defmap,
      transparent: true,
      opacity:0.85
    });
    wxTimeLayer = L.timeDimension.layer.wmswx(wxLayer, {});
    wxTimeLayer.addTo(wsmap).setZIndex(4);
    
    dlines = L.tileLayer("https://b."+basepath+"/tiles/lines_gray/{z}/{x}/{y}.png", {attribution: ""})
      .addTo(wsmap).setZIndex(6);*/
    $("#"+defmap).prop("checked", true);
   // checkBaseLayer(defbase);
    $("#basemapDropdown li").click(function(){
      var basemap=$(this).attr("id");
     // checkBaseLayer(basemap);
    });
    
   getwindy(defmap,lastLayer);
   /* wsmap.timeDimension.on('timeloading', function() { 
      updwindy();
    });*/
    
    legendchoose();
    
    $('#windonoff').change(function() {
      if($(this).prop('checked')){
        updwindy();
      }else{
        clearWind();
      }
    });
    $('#windcolor').change(function() {
      if($(this).prop('checked')){
        windColor=windColorLight;
        redraw();
      }else{
        windColor=windColorDark;
        redraw();
      }
    });
    
    $("#models").html($("#"+defmap.split("_")[0]).text().split("-")[0]);
    $("#modelDropdown li").on("click",function(){
      var model=$(this).text().split("-")[0];
      var modelid=$(this).attr("id");
      $("#models").html(model);
      $("#mapLayers ul").remove();
      $("#maplayer").html("Choose map");
      $("#"+modelid+"Dropdown").clone().appendTo("#mapLayers");
      $('[data-hover="dropdown"]').dropdownHover();
      layerdrop();
    });
    
    $("#"+defmap.split("_")[0]+"Dropdown").clone().appendTo("#mapLayers");
    $("#maplayer").html($("#"+defmap).text());
    $('[data-hover="dropdown"]').dropdownHover();
    layerdrop();
  
  
  $(window).resize(function () {
    screenheight = $(window).height();
    screenwidth = $(window).width();
    $("#wrapper").css({height: screenheight+"px"});
    $("#map").css({height: screenheight+"px"});
    legendchoose();
  });
  
  function legendchoose(){
    var mapwidth=$("#map").width();
    var mapheight=$("#map").height();
    var mo=layerPath.split("_")[0];
    var ty=layerPath.split("_")[1];
    if(ty=="baro"||ty=="cin"||ty=="clouds"||mapheight<430){
      $("#lelegend").animate({height: "hide", width: "hide"}, 100, "linear").html("");
    }else{
      letable = ty;
      if(ty=="psnow"||ty=="rrate"){letable="precip1";}
      if(mo=="fmi"||mo=="mf"||mo=="dwd"){ 
        $(".lesleetsnow").show();
        $(".lehail, .lelight, .lefrz").hide();
        if(mo=="dwd"){$(".lelight").show();}
      }
      if(mo=="wrf"){$(".lesleetsnow, .lehail, .lelight, .lefrz").show();}
      if(mo=="gfs"||ty=="rrate"){$(".lesleetsnow, .lehail, .lelight, .lefrz").hide();}
      $("#lelegend").animate({height: "hide", width: "hide"}, 100, "linear").html("");
      $("."+letable).clone().appendTo("#lelegend").show();
      $("#lelegend").animate({height: "show", width: "show"}, 500, "linear").css({display:"inline-block"});
    }
  }
  
  function layerdrop(){
    $("#mapLayers li").on("click",function(){
      oldPath=layerPath.split("_")[0];
      oldTy = getType();
      layerPath=$(this).attr("id");
      newPath=layerPath.split("_")[0];
      newTy = getType();
      $("#maplayer").html($("#"+layerPath).text());
      getmStep(layerPath.split("_")[0]);
      var times = [];
      var now = Date.now();
      times.push(mTime);
      for(i=1;i<=mMax;i++){
        times.push((i*mStep)+mTime);
      }
      wxTimeLayer.setParams({layers:layerPath});
      if(oldPath!=newPath||oldTy!=newTy){
        wsmap.timeDimension.setAvailableTimes(times, "replace");
        wsmap.timeDimension.setCurrentTime(now);
        updwindy();
      }
      legendchoose();
    });
  }
  
  function getwindy(model,step){
    $.ajaxSetup({ cache: false });
    var moty = getType();
    $.getJSON(ewnpath+"ewn/ewn_proxy.php?callback=?",{"model":model,"step":step},function(result){
      canvasOverlay = L.canvasOverlay().drawing(redraw).addTo(wsmap);
      windy = new Windy({canvas: canvasOverlay.canvas(), data: result});
      context = canvasOverlay.canvas().getContext('2d');
      wsmap.on('dragstart', function() { clearWind() });
      wsmap.on('zoomstart', function() { clearWind() });
      wsmap.on('resize', function() { clearWind() });
      windyCache[model]=[];
      windyCache[model][moty]=[];
      windyCache[model][moty][step]=result;
    });
  }
  
  function updwindy(){
    var step = lastLayer;
    model = layerPath;
    var moty = getType();
    if($("#windonoff").prop('checked')){
      if(windyCache[model]===undefined){windyCache[model]=[];}
      if(windyCache[model][moty]===undefined){windyCache[model][moty]=[];}
      if(windyCache[model][moty][step]===undefined){
        $.ajaxSetup({ cache: false });
        $.getJSON(ewnpath+"ewn/ewn_proxy.php?callback=?",{"model":model,"step":step},function(result){
          windy.params.data=result;
          windy.stop();
          redraw();
          windyCache[model][moty][step]=result;
        });
      }else{
        windy.params.data=windyCache[model][moty][step];
        windy.stop();
        redraw();
      }
    }
  }
  
  function getType(){
    var moty = layerPath.split("_")[1];
    if(moty=="strm"){return "strm";}
    else if(moty=="wind250"){return "jet";}
    else{return "wind";}
  }

  function redraw(overlay, params) {
    if( timer ){window.clearTimeout( timer );} 
    if($("#windonoff").prop('checked')){
      timer = setTimeout(function() { 
        var bounds = wsmap.getBounds();
        var size = wsmap.getSize();
        windy.start( [[0,0],[size.x, size.y]], size.x, size.y, 
          [[bounds._southWest.lng, bounds._southWest.lat ],[bounds._northEast.lng, bounds._northEast.lat]] );
      },5);
    }
  }

  function clearWind() {
    windy.stop();
    context.clearRect(0,0,3000, 3000);
  }
 
	function checkBaseLayer(basemap){
    if(basemap=="gray"){
     // lightmap.setUrl("https://a."+basepath+"/tiles/nat_g/{z}/{x}/{y}.png");
     // dlines.setUrl("https://b."+basepath+"/tiles/lines_gray/{z}/{x}/{y}.png").bringToFront();
    }
    if(basemap=="normal"){
     // lightmap.setUrl("https://a."+basepath+"/tiles/normday/{z}/{x}/{y}.png");
     // dlines.setUrl("https://b."+basepath+"/tiles/lines_gray/{z}/{x}/{y}.png").bringToBack();
    }
    if(basemap=="sat"){
     // lightmap.setUrl("https://a."+basepath+"/boxsat/{z}/{y}/{x}.png");
     // dlines.setUrl("https://b."+basepath+"/tiles/lines_gray/{z}/{x}/{y}.png").bringToBack();
    }
    return false;
  }

  function getcuroffset() {
    var curtime = new Date().getTime();
    for (i=0; i<=maxoffset; i++) {
      if (mTime+(i*mStep) > curtime-mStep/2) {
        return i;
      }
    }
    return 0;
  }

  function savestorage(stpl){
    if($.jStorage.get("wrffrc")){boset=$.jStorage.get("wrffrc");}
    lastplaces = boset.lastplaces;
    lastplaces.unshift(stpl);
    if(lastplaces.length>12){lastplaces.pop();}
    boset.lastplaces=lastplaces;
    $.jStorage.set("wrffrc", boset);
    $.jStorage.setTTL("wrffrc", cookieage);
    return false;
  }

  function getmStep(val){
    if(val=="yr"){
      mStep=mapconf["yr"]["yrsteps"]*3600000;
      mTime = mapconf["yr"]["yrtime"];
      mMax = (mapconf["yr"]["yrlength"]/mapconf["yr"]["yrsteps"]);
      $("#attrTxt").html('Data: Norwegian Meteorological Institute, <a target="_blank" href="http://www.met.no">met.no</a>');
    }
    if(val=="fmi"){
      mStep=mapconf["fmi"]["fmisteps"]*3600000;
      mTime = mapconf["fmi"]["fmitime"];
      mMax = (mapconf["fmi"]["fmilength"]/mapconf["fmi"]["fmisteps"]);
      $("#attrTxt").html('Data: Finnish Meteorological Institute, <a target="_blank" href="http://www.fmi.fi">fmi.fi</a>');
    }
    if(val=="dwd"){
      mStep=mapconf["dwd"]["dwdsteps"]*3600000;
      mTime = mapconf["dwd"]["dwdtime"];
      mMax = (mapconf["dwd"]["dwdlength"]/mapconf["dwd"]["dwdsteps"]);
      $("#attrTxt").html('Data: Deutscher Wetterdienst, <a target="_blank" href="http://www.dwd.de">dwd.de</a>');
    }
    if(val=="wrf"){
      mStep=mapconf["wrf"]["wrfsteps"]*3600000;
      mTime = mapconf["wrf"]["wrftime"];  
      mMax = (mapconf["wrf"]["wrflength"]/mapconf["wrf"]["wrfsteps"]);
      $("#attrTxt").html('Data: EWN WRFDA, <a target="_blank" href="http://www.europeanweathernetwork.eu">European Weathernetwork</a>');
    }
    if(val=="gfs"){
      mStep=mapconf["gfs"]["gfssteps"]*3600000;
      mTime = mapconf["gfs"]["gfstime"];  
      mMax = (mapconf["gfs"]["gfslength"]/mapconf["gfs"]["gfssteps"]);
      $("#attrTxt").html('Data: Global Forecast System (GFS), <a target="_blank" href="http://www.noaa.gov/">NOAA</a>');
    }
    if(val=="mf"){
      mStep=mapconf["mf"]["mfsteps"]*3600000;
      mTime = mapconf["mf"]["mftime"];
      mMax = (mapconf["mf"]["mflength"]/mapconf["mf"]["mfsteps"]);
      $("#attrTxt").html('Data: Meteo France, <a target="_blank" href="http://www.meteofrance.com">meteofrance.com</a>');
    }
    if(val=="test"){
      mStep=mapconf["test"]["teststeps"]*3600000;
      mTime = mapconf["test"]["testtime"];  
      mMax = (mapconf["test"]["testlength"]/mapconf["test"]["teststeps"]);
      $("#attrTxt").html('Data: GEM-GDPS, <a target="_blank" href="http://weather.gc.ca/">Canadian Meteorological Centre</a>');
    }
    return false;
  }

function isNumber(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}

});  //EOF DOC-READY

} // dostuff


