var yTitles = {color: "#666666", fontWeight: "bold",fontSize:"11px",fontFamily: 'ubunturegular'};
var yLabels = {fontWeight: "normal",fontSize:"11px",fontFamily: 'ubunturegular'};
var isTouch = Modernizr.touch;
var haveGPS = false;
var tempoptions,tsoptions,chart,wicY=320,sw,map4,last,gs,gloaded=false;
var stnr,type,haveUV,haveSolar,tz,tree,wtree,woutarr=[],outarr=[],staff;
s=[99,99,99,99,1.1,0.55,0.28,0.14,0.07,0.04,0.02,0.005];
d=[99,99,99,99,0.6,0.3,0.15,0.07,0.04,0.018,0.008,0.002];

$(document).ready(function(){

  $('[data-toggle="tooltip"]').tooltip();
  $('[data-toggle="popover"]').popover();
  
  if(isTouch){
    if(navigator.geolocation){
      haveGPS = true;
      function positionSuccess(location) {
        $.cookie("ewnloc", location.coords.latitude+"|"+location.coords.longitude, { expires : 1 });
        lat=location.coords.latitude;
        lon=location.coords.longitude;
      }
      function positionFail() {}
      var options = { enableHighAccuracy: true,timeout: 5000,maximumAge: 240000};
      navigator.geolocation.getCurrentPosition(positionSuccess, positionFail,options);
    }
  }
  
  /*##############################################################################################*/
  
  if($.jStorage.get("ewnwunit")){
    wiset=$.jStorage.get("ewnwunit");
    $.cookie("ewnwunit", wiset, { expires : 365 });
  }
  
  $(".favobtn").popover({template: '<div class="popover" style="min-width:250px"><div class="arrow"></div><div class="popover-inner"><h3 class="popover-title"></h3><div class="popover-content"><p></p></div></div></div>'});
  
  
  $(".favobtn").click(function(){$("#favobtn").blur();});
  $(".favobtn").on("shown.bs.popover", function () {
    $("#gearclose").click(function(){$(".favobtn").popover("hide");});
    $("#"+wiset).prop("checked", true);
    $(".wunitbox").change(function(){
      wiset=$('input[name=wunit]:checked').attr('id');
      $.jStorage.set("ewnwunit", wiset);
      $.jStorage.setTTL("ewnwunit", 32000000000);
      $.cookie("ewnwunit", wiset, { expires : 365 });
      url='https://'+window.location.hostname+req;
      window.location.href=url;
    });
    if(haveGPS){ 
      $("#gpsbtn").show();
      $("#gpsbtn").click(function(){locateme();});
    }
  });
  
  var loading = '<div style="width:126px;height:22px;margin:200px auto;"><img src="https://static.nordicweather.net/img/loading10.gif" alt="" style="z-index:100;" /></div>';
  
  $(".frcnavs").click(function () {
      $(".frcnavs").removeClass("selected");
      $(this).addClass("selected");
      var target = $(this).attr("id");
      var subtar = $(this).attr("data-id");
      if(subtar!="dummy"){target="frc1";}
      $(".frctables").hide();
      $("#"+target+"table").show();
      if(target==="frc1"){
        $("#frc1table").html(loading);
        $.getJSON("https://www.euweather.eu/"+subtar+"table.php?callback=?",{"ewnsc":1,"lang":lang,"tk":tk,"mviset":wiset},function(stuff) {
          $("#frc1table").html(stuff);
          $('[data-toggle="tooltip"]').tooltip();
        });
      }
      if(target==="frc2"){
        $("#frc2table").html(loading);
        $.getJSON("https://www.euweather.eu/toplist.php?callback=?",{"ewnsc":1,"lang":lang,"tk":tk,"mviset":wiset},function(stuff) {
          $("#frc2table").html(stuff);
          $('[data-toggle="tooltip"]').tooltip();
        });
      }
      if(target==="frc3"){
        $("#frc3table").html(loading);
        last=undefined;
        $.getJSON("https://www.euweather.eu/stations.php?backcall=?",{"lat":lat,"lon":lon,"lang":lang,"tk":tk,"mviset":wiset,"nolinks":1},function(stuff) {
          stnr=stuff.stnr,type=stuff.type,haveUV=stuff.haveUV,haveSolar=stuff.haveSolar,tz=stuff.tz;
            $("#frc3table").html(stuff.data);
            $('[data-toggle="tooltip"]').tooltip();
        });
      }
      
      return false;          
  });
  
  /*################################################################*/
  
  var screenheight = $(window).height();
  $(".tabbs").css({height:screenheight+"px"});
  
  var centerMarker = L.icon({iconUrl:"https://euweather.eu/img/geo_marker.png",iconSize:[16,16],iconAnchor:[8,8]});
  var map2 = L.map("radar", {}).setView([lat, lon], 8);
  map2.attributionControl.setPrefix("");
  map2.options.maxZoom = 11;
  map2.options.minZoom = 4;
  L.Popup.prototype.options.offset=[0,-8];
  sat = L.tileLayer("https://a.maps.nordicweather.net/boxsat/{z}/{x}/{y}.png", {attribution: ""}).addTo(map2);
  cams = L.featureGroup([]);
  tpws = L.featureGroup([]).addTo(map2);
  
  $("#tpws").prop("checked", true);
  $("#tmet").prop("checked", true);
  $("#road").prop("checked", true);
  $("#mtemp").prop("checked", true);
  bounds=map2.getBounds();
  ne=bounds._northEast;
  sw=bounds._southWest;
  tree = rbush();
  
  $.getJSON("https://www.euweather.eu/scripts/get_map2.php?callback=?",{"lang":lang,"tk":tk,"mviset":wiset,"ne_lat":ne.lat,"ne_lon":ne.lng,"sw_lat":sw.lat,"sw_lon":sw.lng},function(stuff) {
    staff=stuff;
    tree.clear();
    if($("#tpws").is(":checked")&&stuff.pws!==null){doarr(stuff.pws);}
    if($("#tmet").is(":checked")&&stuff.met!==null){doarr(stuff.met);}
    if($("#road").is(":checked")&&stuff.road!==null){doarr(stuff.road);}
    console.log("stations on map:"+ outarr.length);
    tpws.clearLayers();
    if($("#mtemp").is(":checked")){doicons(outarr,tpws,0);}
    if($("#mwind").is(":checked")){dowicons(outarr,tpws,0);}
  });
  
  map2.on("moveend", function (e) {
  	if($("#cams").is(":checked")){
  		getlocations();
  	}else{
      strTime=Date.now();
  		bounds=map2.getBounds();
  		ne=bounds._northEast;
  		sw=bounds._southWest;
  		outarr=woutarr=[];
  		$.getJSON("https://www.euweather.eu/scripts/get_map2.php?callback=?",{"lang":lang,"tk":tk,"mviset":wiset,"ne_lat":ne.lat,"ne_lon":ne.lng,"sw_lat":sw.lat,"sw_lon":sw.lng},function(stuff) { 		
        staff=stuff;
        tree.clear();
        tpws.clearLayers();
        if($("#tpws").is(":checked")&&stuff.pws!==null){doarr(stuff.pws);}
        if($("#tmet").is(":checked")&&stuff.met!==null){doarr(stuff.met);}
        if($("#road").is(":checked")&&stuff.road!==null){doarr(stuff.road);}
        console.log("stations on map:"+ outarr.length);
        if($("#mtemp").is(":checked")){doicons(outarr,tpws,0);}
        if($("#mwind").is(":checked")){dowicons(outarr,tpws,0);}
  		});
  	}
  });
  
  $("#settingsbtn").on("click", function(e){
    $("#tipbasemaps").slideToggle("slow");
  });
  $("#mapclose").click(function(){
    $("#tipbasemaps").slideToggle("slow");
  });
  
  $(".checkboxesc, .checkboxesd").change(function(){
    woutarr=outarr=[];
    tree.clear();
    tpws.clearLayers();
    if($("#tpws").is(":checked")&&staff.pws!==null){doarr(staff.pws);}
    if($("#tmet").is(":checked")&&staff.met!==null){doarr(staff.met);}
    if($("#road").is(":checked")&&staff.road!==null){doarr(staff.road);}
    console.log("stations on map:"+ outarr.length);
    if($("#mtemp").is(":checked")){doicons(outarr,tpws,0);}
    if($("#mwind").is(":checked")){dowicons(outarr,tpws,0);}
    if($("#cams").is(":checked")){
    	map2.addLayer(cams);
    	getlocations();
    }else{
    	map2.removeLayer(cams);
   	}
  });
  
  function doarr(data){
    length = data.length;
    z = map2.getZoom();
    for (i = 0; i < length; i++) {
      item=[data[i].lat-d[z],data[i].lon-s[z],data[i].lat+d[z],data[i].lon+s[z]];
      col=tree.search(item).length > 0;
      if(!col){
        tree.insert(item);
        outarr.push(data[i]);
      }
    }
  }
  
  function markercolor(t){
		var rounding = 2.5;
		t=Math.ceil(t/rounding)*rounding;
		if(t<-47.5){t=-47.5;}
		if(t>45){t=45;}
		t=t.toString();
		return t.replace(".","-");
	}
  
  function doicons(data,layer,clickable){
    length = data.length;
    for (i = 0; i < length; i++) {
      point=data[i];
      var popup = new L.Rrose({autoPan:false,closeButton:false}).setLatLng([point.lat,point.lon]).setContent(getpopup(point));
      var icon = L.divIcon({
     		className: "",
     		iconSize:null,
     		iconAnchor: [13, 31],
     		html:"<div class=\'tempmarker temp"+markercolor(point.rtemp)+"\'><span>"+Math.round(point.rtemp)+"</span></div>"
   		});
      marker=L.marker([point.lat,point.lon], {icon: icon}).bindPopup(popup);
      layer.addLayer(marker);
      if(clickable==1){
        marker.on("click", function(e){
          window.location.href="https://euweather.eu/stations.php?lat="+point.lat+"&lon="+point.lon+"&lang="+lang;
        });
      }
    };
    layer.on("mouseover", function(e) {e.layer.openPopup();setTimeout(function(){e.layer.closePopup();},2500);});
  }
  
  function dowicons(data,layer,clickable){
    length = data.length;
    for (i = 0; i < length; i++) {
      point=data[i]
      var wline="";
      wind=point.speed;wdir=point.dir;rwind=point.rspeed;
      wi = Math.round(rwind);
      wcolor=wiconcolor(wi);
      wir = Math.round(wind);
      if(wind>0){
        wline='<svg xmlns="http://www.w3.org/2000/svg" version="1.1" viewBox="0 0 104 104" height="46" width="46"><g><path style="fill:#fff;stroke:'+wcolor+';stroke-width:6.0721" d="M76.002,51.998c0,13.26-10.746,24.004-24.002,24.004 c-13.254,0-24.002-10.744-24.002-24.004c0-13.254,10.748-24,24.002-24C65.256,27.998,76.002,38.744,76.002,51.998z"></path>';
        wline+='<polygon points="65.966,81.677 62.416,85.361 58.875,89.044 55.332,92.72 51.794,96.4 48.345,92.626 44.91,88.851 41.468,85.08 38.031,81.31 45.105,82.21 51.992,83.193 59.154,82.404" stroke-width="4.0721" stroke="'+wcolor+'" fill="#fff" transform="rotate('+wdir+',52,52)"></polygon>';
        wline+='<text dy="7pt" y="49%" x="50%" style="font-size:24px;letter-spacing:-1px;text-anchor: middle;font-family:Ubuntu, Arial;font-weight:400">'+wir+'</text></g></svg>';
        var popup = new L.Rrose({autoPan:false,closeButton:false}).setLatLng([point.lat,point.lon]).setContent(getpopup(point));      
        var svgURL = "data:image/svg+xml;base64," + btoa(wline);
        var mySVGIcon = L.icon({iconUrl: svgURL,iconSize: [46, 46],iconAnchor: [23, 40]});
        marker=L.marker([point.lat,point.lon], {icon: mySVGIcon}).bindPopup(popup);
        layer.addLayer(marker);
        if(clickable==1){
          marker.on("click", function(e){
            window.location.href="https://euweather.eu/stations.php?lat="+point.lat+"&lon="+point.lon+"&lang="+lang;
          });
        }
      }
    };
    layer.on("mouseover", function(e) {e.layer.openPopup();setTimeout(function(){e.layer.closePopup();},2500);});
  }
  
  function getpopup(point){
    if(point.temp<0.1){gt = "#2779aa";}else{gt = "#F33A27";}
    
    wline="";
    wind=point.speed;wdir=point.dir;rwind=point.rspeed;
    wi = Math.round(rwind);
    wcolor=wiconcolor(wi);
    wir = Math.round(wind);
    if(wind>=0){
      wline='<svg class="svg" viewBox="0 0 104 104" height="48" width="48"><g class="wind"><path d="M76.002,51.998c0,13.26-10.746,24.004-24.002,24.004 c-13.254,0-24.002-10.744-24.002-24.004c0-13.254,10.748-24,24.002-24C65.256,27.998,76.002,38.744,76.002,51.998z" stroke-width="6.0721" stroke="'+wcolor+'" fill="#fff"></path>';
      if(wind>0){
        wline+='<polygon points="65.966,81.677 62.416,85.361 58.875,89.044 55.332,92.72 51.794,96.4 48.345,92.626 44.91,88.851 41.468,85.08 38.031,81.31 45.105,82.21 51.992,83.193 59.154,82.404" stroke-width="4.0721" stroke="'+wcolor+'" fill="#fff" transform="rotate('+wdir+',52,52)"></polygon>';
      }
      wline+='<text dy="7pt" y="49%" x="50%" style="font-size:18pt">'+wir+'</text></g></svg>';
    }
    if(point.camid>0){camdiv='<div><img style="width:155px;max-height:120px;margin-top:5px" src="https://euweather.eu/scripts/img.php?type=cam&id='+point.camid+'t='+time+'"/></div>';}
    else{camdiv="";}
    
    pop='<div class="wxpophead">'+point.name+'</div><div class="wxpopcontent">'
   // + camdiv
    + '<div class="wxpoptop">'
    + '<div><span class="tempd maptempd" style="color:'+gt+';">'+point.temp.toFixed(1)+'&deg;</span></div>'
    + '<div>'+wline+'</div></div>';
    if(point.tmax!=null){
    	pop+= '<div>'
    	+ '<i class="fa fa-arrow-circle-up" style="color:#CD2626;font-size:12px;top:0px;position:relative;"></i> '+point.tmax.toFixed(1)+'&deg;&nbsp;'
    	+ '<i class="fa fa-arrow-circle-down" style="color:#4F94CD;font-size:12px;top:0px;position:relative;"></i> '+point.tmin.toFixed(1)+'&deg;'
    	+ '</div>'
 		}
    if(point.baro>400){pop+='<span style="float:right">'+point.baro+' hPa</span>'+txtbaro+'<br/>';}
    if(point.hum>0){pop+='<span style="float:right">'+point.hum+' %</span>'+txthum+'<br/>';}
    if(point.prec!=null&&point.prec>-1){pop+='<span style="float:right">'+point.prec+' mm</span>'+txtprec+'<br/>';}
    if(point.rrate>0){pop+='<span style="float:right">'+point.rrate+' mm/h</span>'+txtrate+'<br/>';}
    if(point.solar>0){pop+='<span style="float:right">'+point.solar+' w/m&sup2;</span>'+txtsun+'<br/>';}
    if(point.uv>0){pop+='<span style="float:right">'+point.uv+'</span>UV<br/>';}
    if(point.snowd>0){pop+='<span style="float:right">'+point.snowd+' cm</span>'+txtsnow+'<br/>';}
    pop+='</div>';
    return pop;
  }
  
  function getlocations(){
    bounds = map2.getBounds();
    zoom = map2.getZoom();
      cams.clearLayers();
      $.getJSON("https://api.webcams.travel/rest",
        {"method":"wct.map.bbox", "format":"json", "devid":"5fccf3e347cabf5abed9c9e651161d9c","sw_lat":bounds._southWest.lat,
        "sw_lng":bounds._southWest.lng, "ne_lat":bounds._northEast.lat, "ne_lng":bounds._northEast.lng, "zoom": zoom},function(data) {
          $.each(data.webcams.webcam, function() {
            var divm = L.divIcon({iconAnchor: [25, 35],class:"",html:"<img class=\'img-thumbnail2\' src=\'"+this.icon_url+"\'/>"});
            var popup = new L.Rrose({autoPan:false,closeButton:false,minWidth:360,minHeight:250})
              .setLatLng([this.latitude,this.longitude])
              .setContent("<div class=\'wxpophead\'>"+this.title+"</div><img style=\'width:360px;height:224px;\'src=\'"+this.preview_url+"\'/>")
            cammrk = L.marker([this.latitude,this.longitude], {icon: divm}).bindPopup(popup);
            cams.addLayer(cammrk); 
            cams.on("mouseover", function(e) {
      				e.layer.openPopup();
      				setTimeout(function(){e.layer.closePopup();},3000);
    				});
          });
      });
      last=bounds;
  }
  
  function wiconcolor(i){
    if(i<14){return "#2A6786";}
    else if (i<25){return "#F89C26";}
    else {return "#EE0000";}
  }
  
  function tcolor(raw){
      switch (raw) {
        case 1: x = "rgb(170,246,130)";break;
        case 2: x = "rgb(175,244,116)";break;
        case 3: x = "rgb(180,242,102)";break;
        case 4: x = "rgb(190,241,88)";break;
        case 5: x = "rgb(200,240,74)";break;
        case 6: x = "rgb(210,238,60)";break;
        case 7: x = "rgb(220,236,46)";break;
        case 8: x = "rgb(230,235,32)";break;
        case 9: x = "rgb(235,232,22)";break;
        case 10: x = "rgb(244,230,11)";break;
        case 11: x = "rgb(244,217,11)";break;
        case 12: x = "rgb(244,208,11)";break;
        case 13: x = "rgb(244,200,11)";break;
        case 14: x = "rgb(244,192,11)";break;
        case 15: x = "rgb(244,184,11)";break;
        case 16: x = "rgb(244,176,11)";break;
        case 17: x = "rgb(244,168,11)";break;
        case 18: x = "rgb(244,160,11)";break;
        case 19: x = "rgb(244,152,11)";break;
        case 20: x = "rgb(244,144,11)";break;
        case 21: x = "rgb(244,122,11)";break;
        case 22: x = "rgb(240,112,11)";break;
        case 23: x = "rgb(236,102,10)";break;
        case 24: x = "rgb(232,92,10)";break;
        case 25: x = "rgb(227,82,9)";break;
        case 26: x = "rgb(223,72,9)";break;
        case 27: x = "rgb(219,62,9)";break;
        case 28: x = "rgb(215,52,8)";break;
        case 29: x = "rgb(211,42,8)";break;
        case 30: x = "rgb(207,32,7)";break;
        case 31: x = "rgb(195,28,7)";break;
        case 32: x = "rgb(199,24,18)";break;
        case 33: x = "rgb(203,21,29)";break;
        case 34: x = "rgb(207,18,40)";break;
        case 35: x = "rgb(211,15,51)";break;
        case 36: x = "rgb(215,12,62)";break;
        case 37: x = "rgb(219,9,73)";break;
        case 38: x = "rgb(223,6,84)";break;
        case 39: x = "rgb(227,3,95)";break;
        case 40: x = "rgb(231,1,106)";break;
        case 0: x = "rgb(199,228,255)";break;
        case -1: x = "rgb(181,220,255)";break;
        case -2: x = "rgb(163,212,255)";break;
        case -3: x = "rgb(154,208,255)";break;
        case -4: x = "rgb(145,204,255)";break;
        case -5: x = "rgb(127,196,255)";break;
        case -6: x = "rgb(109,188,255)";break;
        case -7: x = "rgb(91,180,255)";break;
        case -8: x = "rgb(73,172,255)";break;
        case -9: x = "rgb(37,154,255)";break;
        case -10: x = "rgb(19,146,255)";break;
        case -11: x = "rgb(0,130,239)";break;
        case -12: x = "rgb(0,114,207)";break;
        case -13: x = "rgb(0,98,175)";break;
        case -14: x = "rgb(0,82,143)";break;
        case -15: x = "rgb(0,70,127)";break;
        case -16: x = "rgb(0,60,127)";break;
        case -17: x = "rgb(0,50,127)";break;
        case -18: x = "rgb(0,40,127)";break;
        case -19: x = "rgb(0,30,127)";break;
        case -20: x = "rgb(0,24,127)";break;
        case -21: x = "rgb(0,0,127)";break;
        case -22: x = "rgb(12,0,127)";break;
        case -23: x = "rgb(25,0,127)";break;
        case -24: x = "rgb(37,0,127)";break;
        case -25: x = "rgb(50,0,127)";break;
        case -26: x = "rgb(62,0,127)";break;
        case -27: x = "rgb(75,0,127)";break;
        case -28: x = "rgb(87,0,127)";break;
        case -29: x = "rgb(100,0,127)";break;
        case -30: x = "rgb(120,4,141)";break;
        case -31: x = "rgb(135,8,152)";break;
        case -32: x = "rgb(150,12,163)";break;
        case -33: x = "rgb(165,16,174)";break;
        case -34: x = "rgb(180,20,185)";break;
        case -35: x = "rgb(182,18,160)";break;
        case -36: x = "rgb(185,16,150)";break;
        case -37: x = "rgb(188,14,140)";break;
        case -38: x = "rgb(191,13,130)";break;
        case -39: x = "rgb(194,12,120)";break;
        case -40: x = "rgb(197,10,110)";break;
        default: x = "rgb(199,228,255)";
      }
      if(raw>= 41){x = "rgb(235,0,117)";}
      if(raw<=-41){x = "rgb(200,10,100)";}
      return x;
    }
    
  function ttcolor(raw){
    if(raw<-15||raw>29){return "#fff";}
    else{return "#000";}
  }
  
  function getScripts(scripts, callback) {
    var progress = 0;
    var internalCallback = function () {
        if (++progress == scripts.length) { callback(); }
    };

    scripts.forEach(function(script) { $.getScript(script, internalCallback); });
  };
  
});

function locateme(){
  if(navigator.geolocation){
    haveGPS = true;
    function positionSuccess(location) {
      $.cookie("ewnloc", location.coords.latitude+"|"+location.coords.longitude, { expires : 1 });
      url='https://'+window.location.hostname+window.location.pathname+'?fl='+$("#searchflag").attr("data-co")+'&lang='+lang+'&lat='+location.coords.latitude+'&lon='+location.coords.longitude+p;
      window.location.href=url;
    }
    function positionFail() {}
    var options = { enableHighAccuracy: true,timeout: 5000,maximumAge: 240000};
    navigator.geolocation.getCurrentPosition(positionSuccess, positionFail,options);
  }
}

if(!dateFormat){
var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	return function (date, mask, utc) {
		var dF = dateFormat;
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) throw SyntaxError("invalid date");
		mask = String(dF.masks[mask] || mask || dF.masks["default"]);
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var	_ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function ($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: fdaynames,
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
};
}else{
dateFormat.i18n = {
	dayNames: fdaynames,
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};
}