<?
define('FULLGRAPH','All days');
define('MASL','Højde over havet');
define('TABLE','Tabel');
define('MAPS','Kort');
define('ACCURACY','Accuracy');
define('COMPAREDESC','Sammenlign vejrudsigter');
define('FRCGRAPH','Vejrudsigtsgraf');
define('FRCCOMPARE','Sammenlign');
define('HUMIDITY','Fugtighed');
define('AGO','siden');
define('NOCLOSE','Der er ingen vejrstationer i nærheden.<br/>Tilmeld din egen vejrstation til EWN <a href=\"https://euweather.eu/join.php?lang=en\" target=\"_blank\">HER</a>.');

define('GLOBALT','Global');
define('DATASET','Dataset');
define('PROVIDER','Provider');
define('COVERAGE','Coverage');

define('ALTITUDE','Altitude');
define('POSTCODE','Postcode');
define('AREA','Area');
define('PARKS','Parks');
define('AIRPORTS','Airports/fields');
define('GOLFCOURSES','Golfcourses');
define('SKICENTERS','Skicenters');
define('BEACHES','Beaches');
define('ZOO','Zoo');
define('MISC','Misc');

define('HAIL','Hagl');
define('SEVIDX','Voldsomt vejr');
define('MOREMAPS','Flere kort');
define('GOODFRC','Gode prognoser');
define('MEANERROR','Gns. fejl');
define('RMSERROR','RMS fejl');
define('DETAILEDTABLE','detaljeret');
define('DAYTABLE','dage');
define('COMPACCURACY','Nøjagtighed og sammenligning');
define('ACCURACYFOR','Nøjagtighed for');
define('COMPMODELS','Sammenlign modeller');
define('ACCURACYMODELS','Model nøjagtighed');
define('ACCURACYDESC','EWN udsætter prognosemodellerne for en rigtig test ved at måle deres nøjagtighed med de faktiske vejrforhold for det område modellen dækker, som oftes er fra det nationale meteorologiske institut. Nøjagtigheden måles for cirka 900 lokationer nord for alperne og er beregnet ved at sammenligne vejrudsigten med den faktiske temperatur hver 3. time (kl. 00, 03, 06, 09, 12, 15, 18 og 21 UTC). Den benyttede vejrudsigt for næste dag bliver lavet cirka kl. 18 UTC. Disse resultater bruges derefter til beregning af EWN vejrudsigten.
<div style="margin-top:15px">
<b>Models</b><br/>
- <b>EWN:</b>&nbsp;EWN\'s egen vejrudsigt<br/>
- <b>WRFDA:</b>&nbsp;WRF drevet af EWN<br/>
- <b>DWD:</b>&nbsp;ICON, DWD,Tyskland<br/>
- <b>MF:</b>&nbsp;ARPEGE, Meteo Frankrig<br/>
- <b>KNMI:</b>&nbsp;Hirlam, KNMI, Holland<br/>
- <b>FMI:</b>&nbsp;Hirlam, FMI, Finland<br/>
- <b>YR:</b>&nbsp;XML-files (AROME-MetCoOp, Hirlam, ECMWF), MET Norge (yr.no)<br/>
- <b>GFS:</b>&nbsp;GFS, NCEP, USA<br/>
- <b>CMC:</b>&nbsp;CMC Ensemble, CMC, Canada<br/>
- <b>WXSIM:</b>&nbsp;WXSIM-software drives af private vejrstationer (data er ikke tilgængelig for alle steder)<br/>
</div>');
define('ACCURACYMODELSDESC','Den gennemsnitlige nøjagtihed for vejr prognosemodel.');


define('FMODEL','Model');
define('FANIMATION','Animation');
define('FON','On');
define('FOFF','Off');

define('VILLAGES','Byer, landsbyer');
define('ISLANDS','Øer, bjerge');
define('LAKES','Søer, bugter');
define('SOLARWINDENERGY','Sol- og vindenergi');
define('HDD','Graddage');
define('SOLAR','Sol');
define('SOLARWINDINFO','Denne tabel er baseret på modellen fra EWN WRFDA. Solstråling: SW - kortbølge, LW - langbølge. HDD - '.HDD.'.');

define('COOP','I samarbejde med');
define('DATAPWS','Data fra hver PVS-tation');
define('WARNBX','Varsler leveres af');
define('WARNBY','for nyeste varsler, besøg det lokale meteorologiske instituts hjemmeside');
define('SCRADM','Script og administration af');
define('NORES','EWN er ikke ansvar lig for nøjagtigheden af informationerne.<br/>Undtaget hvor det er skrevet, er alt indhold på denne side under licens af');
define('SUBTITLDESC','af temperaturprognoserne de sidste 30 dge været meget gode eller gode. For mere information se <a href="frc_stats.php?'.$lang.'">statistikker');
define('SEARCHLOC','Søg lokation');
define('SUBTITLE','DE MEST PÅLIDELIGE VEJRUDSIGTER'); // Feel free to figure out something better, note it refers to forecast-accuracy
define('METPROV','Data leveret af');
define('PRIVATESTATION','Private');
define('METOFFICESTATION','Meteorologiske insitutter');
define('ROADSTATION','Vej');
define('JUSTNOW','Just nu');
define('CLOSEOBS','Observationer tæt på');
define('TONIGHT','I nat');
define('WARNANDSEVERE','Varsler og voldsomt vejr');
define('FAVORITES','Dine favorit lokationer');
define('SAVEFAVORITESETTINGS','Gem indstillinger');
define('SAVEASFAVORITE','Føj til favoritter');
define('ADDEDTOFAVO','Lokation tilføjet dine favoritter!');
define('NOFAVORITES','Du har ingen favoritter!');
define('NOWARNS','Ingen varsler');
define('RADARSTRIKES','Radar &amp; lyn');
define('SEVEREW','Voldsomt vejr');
define('SNOW','Sne');
define('LEVEL','Niveau');
define('OTHER','Andre');
define('DAY','Dag');
define('COMPFRCMODEL','Sammenlign modeller');
define('TSPROB','Storm sandsynlighed');
define('SEVERE','Voldsomt vejr');
define('SEVEREFRCTODAY','Vejrusigt for voldsomt vejr');
define('HOTCOLD','Varmeste, koldeste, mest blæsende, vådeste');
define('TENWARMEST','10 varmeste steder');
define('TENCOLDEST','10 koldeste steder');
define('WINDIEST2','Vind &gt;');
define('WETTEST2','Nedbør &gt; 4 mm/h');
define('LOCATIONS','Andre steder');
define('SELECTCOUNTRY','Vælg land');
define('SELECTLANGUAGE','Sprog');
define('SELECTWUNIT','Vindenhed');
define('LOCATEME','Min placering!');
define('LOADING','Henter...');
define('FAVORITELOCATIONS','Favorite steder');
define('HOME','Hjem');
define('FRCSTMAPS','Prognosekort');
define('FRCSTVIDEOS','Prognosevideoer');
define('FORECASTS','Vejrudsigter');
define('STORMFORECAST','Stormprognoser');
define('AURORAFORECAST','Auroraprognose');
define('RADAR','Radar');
define('PRECRADAR','Nedbørsradar');
define('FINLAND','Finland');
define('SCANDINAVIA','Skandinavien');
define('EUROPE','Europa');
define('DISABLED','Inaktiv');
define('STRLAST2MIN','Sidste 2 min.'); // Short!!
define('WEBCAMS','Webcams');
define('VHIGH','Meget højt');
define('EXTREME','Ekstremt');
define('WXSTATIONS','Vejrstationer');
define('WXSTATION','Vejrstation');
define('AVGERROR','Gennemsnits fejl');
define('ROADSTATIONS','Vej vejrstationer');
define('SUN','Sol');
define('WINDRUN','Vindløb');
define('WEBURL','Webside URL');
define('DIRECTLINK','Direkte link');
define('LOGIN','Log ind');
define('HAVEUV','Stationen har UV-sensor');
define('HAVESOLAR','Stationen har sol-sensor');
define('ORTEXT','eller');
define('USERNAME','Brugernavn');
define('FRGTPASS','Glemt adgangskode');
define('RESETPASS','Nulstil adgangskode');
define('SOLARHEATED','Solopvarmet');
define('SOLARHEATDESC','Timer når temperatursensoren er i solen - slået fra sæt til -1');
define('SOLARHEATDESC2','EWN Administrator forbeholder sig ret til at ændre solvarme indstillingen, for at sikre nøjagtige temperaturer. "Ingen afskærmning" sætter stationen til solopvarmet i dagstimerne.');
define('BOSTATIONS','Blitzortung-stationer');
define('BODESC','List dine BO-stations som skal vises på BO-statussiden (ikke klar endnu).<br/>Hvis du har flere stationer, så adskil dem med |, f.eks. 4566|6543.');
define('BONAME','BO station-navn');
define('NEWUSERNAME','NEWUSERNAME');
define('DOWNLOADNOTE','OBS! Hvis download ikke starter: Højreklik på linket og vælg "Gem som".');
define('YOULOGOUT','Du er nu logget ud');
define('CONTACT','Kontakt');
define('CLOSE','Luk');
$days = array('Søndag','Mandag','Tirsdag','Onsdag','Torsdag','Fredag','Lørdag');
$months = array('Jan','Feb','Mar','Apr','Maj','Jun','Jul','Aug','Sep','Okt','Nov','Dec');
define('cookietitle','Other');
define('cookiedescription','Settings like favorite locations use cookies. This includes also the social media plugins on the page');
define('advertisingDefaultTitle','Reklamer');
define('analyticsDefaultTitle','Analyser');
define('analyticsDefaultDescription','Vi måler anonymt din bruge af vores hjemmeside for at forbedre din oplevelse af siden.');
define('advertisingDefaultDescription','Adverts will be chosen for you, automatically based on your past behaviour and interests.');
define('notificationTitleImplicit','Vi bruger cookies for at sikre dig den bedste oplevelse på vores hjemmeside');
define('allowCookiesImplicit','OK!');
define('savePreference','Gem dine valg');
define('hideDetails','skjul deltaljer');
define('seeDetailsImplicit','ændre dine indstillinger');
$boinfo.= "<br/>Regnradarer er opdateret hver 5.-15. minut med varierende forsinkelse.<br/><br/>
<b>Blitzortung</b><br/>
  Blitzortung.org er et privat netværk af lyndetektorer med mere end 1.000 tilmeldte i Europa. De registrerer de elektromagnetiske signaler fra lyn. Dette sammenholdt med et meget præcist tidspunkt og placering kan lyn blive beregnet ud fra signalerne (TOA - time of arrival method). Du kan finde mere information på netværkets hjemmeside: <a href='http://www.blitzortung.org' target='_blank'>www.blitzortung.org</a>.<br/>
  Nøjagtigheden på Blitzortung er meget god og sædvanligvis under 1 kilometer. Dette kan direkte sammenlignes med kommericielle og meteorologiske institutters lyndetecktorer.<br/>
For at deltage, skal du have din egen (relativt billige) lyndetektor. Med denne kan du deltage i netværket og vil få adgang til alle lyndata fra netværket.";
define('WEEWXINFO','Hvis du bruger WD-plugin og uploader clientraw.txt eller customclientraw.txt (til SteelSeries Gauges), skal du ikke foretage dig yderligere. Vælg WD eller SteelSeries Gauges som software.');

# FORECAST RELATED
define('FRCWARN','Klik for at se hele varslen. Varlser leveres af');
define('EWNACC','Nøjagtigheden sammenlignes med målte temperature og vejrudsigten for cirka 500 steder nord for 52&deg;N op til Nordkap i det nordlige Norge. Et kriterie for de udvalgte steder er vejrstationernes pålidelighed (i de fleste tilfælde er det nationale meteologiske stationer). Fejlværdier er i abslutte grader, hvilket betyder, at værdierne altid er positive. Kontrollen viser data for de sidste 30 dage.');
define('LIGHTNINGMAP','Lynkort');
define('DAYLENGTH','Dagslængde');
define('MIDNIGHTSUN','Midnatssol');
define('POLARNIGHT','Polarnat');
define('QUICKLINKS','Direkte links');
define('CLOSESTWXSTATION','Nærmeste vejrstation');
define('POP','PoP');
define('RANGE','Rækkeviddee');
define('DAYFRC2','dag vejrudsigt');
define('MORE','Mere &raquo;');
define('DAILYMAP','Daglige kort');
define('FDAYS','Dag');
define('DTOMORROW','Dag 3');
define('FMAP','Kort');
define('MAXI','Højeste');
define('MINI','Laveste');
define('SEVRISK','Tordenprognose');
define('LEV3','Ekstrem volsomt');
define('LEV2','Volsomt vejr');
define('TS','Sansynlighed for torden');
define('SEVERERISK','ALVORLIGT VEJR');
define('TSRISK','Risiko for tordenbyger');
define('SUPERCELLRISK','Risiko for superceller');
define('TORNADORISK','Risiko for tornadoer');
define('HAILRISK','Risiko for hagl');

define('CLICKINFO','Klik på kortet for at se en vejrudsigt!');
define('FSLEET','Slud');
define('YOURLOCATION','Din nuværende lokation');
define('FRCACCURACY','Vejrudsigtens nøjagtighed');
define('FRCACCINFO','Vi tjekker nøjagtigheden fra nogle af de modeller vi benytter for nogle få steder ved at kontrollere 12-timers punkter i vejrudsigten.');
define('DOWNLOADED_FRC','Hentede vejrudsigter');
define('TOTDOWNLOADED_FRC','I alt hentede vejrudsigter');
define('PLACE','Sted');
define('FRCS','Vejrudsigter');
define('LATI','Breddegrad');
define('LONGI','Længdegrad');

define('TOMORROW','I morgen');
define('SUNANDMOON','Sol og måne');
define('UVFORECAST','4 dages UV-varsel');
define('LOW','Lav');
define('MED','Medium');
define('HIG','Høj');
define('LOCATIONINFO','Lokationsinfo');
define('ELEVATION','Højde over havet');
define('POPULATION','Population');
define('FEELS','Føles som');
define('GUST','Vindstød');

define('EWNFORECAST','EWN-Vejrudsigt');
define('FRCSEARCH','Søg vejrudsigt');
define('FRCSAVE','Gem sted');
define('FORECASTINFO','EVN vejrudsigten er EVN\'s helt egen genererede vejrudsigt. Det er den eneste vejrudsigt som laves i det øjeblik du anmoder den! Det betyder, at vejrudsigten altid er lavet ud fra de mest friske data.<br/>EVN vejrudsigten er tilgængelig for ca. 850.000 steder i hele Europa.');
define('FRCINFOB','The EWN Forecast use multiple free numerical models as base for the forecast. EWN are not liable for the quality and accuracy of the forecast.<br/>In addition, we do run an own run of WRFDA EMS model at 12 km resolution whats included in the data. The maps are also generated from the WRFDA EMS model.<br/><br/>
In the forecasts are content and data used from:<br/>
<a href="http://nomads.ncep.noaa.gov/" target="_blank">NCEP</a> (GFS, GEFS &amp; UV), <a href="http://weather.gc.ca" target="_blank">The Canadian Meteorological Center</a> (GEM-GDPS), <a href="http://www.met.no" target="_blank">Norwegian Meteorological Institute</a> (MET Norway), <a href="http://www.smhi.se" target="_blank">Swedish Meteorological and Hydrological Institute</a> (SMHI), <a href="http://www.fmi.fi" target="_blank">Finnish meteorological institute</a> (FMI), <a href="http://www.dwd.de" target="_blank">Deutscher Wetterdienst</a> (DWD), <a href="http://www.geonames.org" target="_blank">Geonames</a>, <a href="http://www.meteoalarm.eu" target="_blank">MeteoAlarm</a>, <span id="moresources"></span>WXSIM - near private weatherstations with the WXSIM-software.
');

define('SAVEFAVO','Standard sted');
define('SAVEQUI','Tilføj til hurtigsøg');
define('SEARCHCOUNTRY','Land');
define('PLACESEARCH','Søg');
define('QUICKSEARCH','Hurtigsøg');
define('OWNPLACES','Egen steder');

define('FORECASTFOR','Vejrudsigt for');
define('ISSUED','Udstedt');

define('SHORTFRC','Overblik');
define('HOURFRC','Time-for-time');
define('DAYFRC','dages vejrudsigt');
define('NERDFRC','Ekstra');
define('COMPFRC','Sammenlign');
define('MAPFRC','Kort');

define('FGUST','Max vindstød');
define('FRATE','Regnrate');
define('BASEMAPS','Standardkort');
define('SATELLITE','Satellit');
define('TTINFO','Torden sandsynlighed: 45-50 muligt, <br/>50-55 meget sandsyndligt, 55-60 sandsynligvis kraftig');
define('SRHINFO','150-299 mulighed for superceller, <br/> 300-500 stor sandsynlighed for superceller og tornadoer');
define('DBZINFO','20 let regn, <br/> 30 moderat regn, 50 kraftig regn, hagl');
define('KIINFO','Ca. 2 x K Index = Sandsynlighed for torden');
define('FTEMP','Temperatur');
define('FCHILL','Vindchill');
define('FDEW','Dugpunkt');
define('FWIND','Vind');
define('FPREC','Nedbør');
define('FCLOUD','Skyer');
define('FBARO','Barometer');
define('FSNOW','Sne');
define('FHAIL','Hagl');
define('FFRZ','Isslag');
define('FLIG','Torden');
define('FTHUN','Sandsynlighed for torden');
define('FCONV','Konvektiv nedbør');
define('FINSTA','Pot. instabilitet');
define('FVISIB','Sigtbarhed');
define('FFORE','Vejrudsigter');
define('FAVG','Gennemsnit');
define('FUTIMES','Opdateringstider');
define('FRESO','Opløsning');
define('FLENGTH','Længde');
define('FSTEPS','Trin');
define('FRADAR','radar');
define('FSAT','satellit');
define('SIGHAIL','Sig. haglriskiko');
define('SIGTOR','Sig. tornadorisiko');
define('SIGSUP','Sig. Supercellerisiko');
define('MCOMPRADAR','Max komp. radar');
define('SIGHAIL2','Betydelig haglrisiko');
define('SIGTOR2','Betydelig tornadorisiko');
define('SIGSUP2','Betydelig supercellerisiko');
define('MCOMPRADAR2','Max komposit radar');
define('FRCCINFO','
<b>Kort over sandsynlighed for lyn</b> - Grønne og gule farver indikere, at der er sandsynlighed for lyn indenfor 40 km. Orange, rød og violet er lignende niveauer set på estofex.org. Disse indeholder også sandsynlighed for hagl og superceller.<br/><br/>
<b>dBZ</b> - dBZ står for decibel relativ til Z. Det er en meteorologisk foranstaltning med tilsvarende refleksionsevne (Z) af et radarsignal reflekteres fra en fjern genstand
<br/><br/>
<b>Cape</b> - Convective available potential energy (CAPE), undertiden simpelthen, tilgængelig potentiel energi (APE), er den mængde energi, en parcel af luft ville have, hvis løftet en vis afstand lodret gennem atmosfæren.
<br/><br/>
<b>K Index</b> - K-Index er et mål for tordenvejr potentiale baseret på lodret temperatur bortfalder sats, fugtindholdet i den nedre atmosfære og lodrette udstrækning af den fugtige lag.
<br/><br/>
<b>TT Index</b> - Konvektiv index som bruges til at forudsige voldsomt vejr.
<br/><br/>
<b>WRF</b> - The Weather Research and Forecasting (WRF) er næste-generation er næste-generations mesocale numeriske vejrudsigtssystem designet til at betjene både operationelle prognoser og atmosfæriske forksningsbehov. WRF er et samarbejde mellem National Center for Atmospheric Research (NCAR), National Centers for Environmental Prediction (NCEP), Forecast Systems Laboratory (FSL), Air Force Weather Agency (AFWA), Naval Research Laboratory, University of Oklahoma, og Federal Aviation administration (FAA). Denne software køres på vores server.
<br/><br/>
<b>WRFDA</b> - A more advanced version of WRF<br/><br/>
<b>Arome</b> - 2,5 km Arome model. Leveres af Norges Meteologiske Institut.
<br/><br/>
<b>MET Norge</b> - De professionelle standard 4 km. meteologiske data er bedste gæt udvalg af meteologiske modeller kørt af met.no og samlet i et gængs datasæt. Leveret af det Norske Meteologiske Institut.
<br/><br/>
<b>SMHI</b> - Hirlam modellen leveres af Sveriges Meteologiske Institut.
<br/><br/>
<b>FMI</b> - Hirlam modellen leveres af Finlands Meteologiske Institut. Dækker kun Finland.
<br/><br/>
<b>GFS</b> - Det Globale Vejrudsigts System (GFS) er et globalt numerisk vejr forudsigelses computermodel som leveres af NOAA.
<br/><br/>
<b>GEM-GDPS</b> - GEM-GDPS er et globalt numerisk vejr forudsigelses model som leveres af Canadas Meteologiske Centre.
<br/><br/>
<span style="color:#888"><b>Kredit/Info:</b> Tak til Stefan Gofferje fra <a href="http://www.saakeskus.fi" target="_blank">s&auml;&auml;keskus.fi</a> for nogle af formlerne som bruges i GrADS. Info: Wikipedia.</span>');
define('SHOWADV','Sne avanceret');
define('FPRECTYP','Nedbørstype');
define('FSNOWD','Snedybde');
define('FRAIN','Regn');
define('FTMPSFC','Overflade temperatur');
define('FACCUM','Akkmuleret nedbør');
define('FHUM','Fugtighed');
define('FFEELS','Føles som');
define('FTODAY','I dag');
define('FTOMOZ','I morgen');

$days = array('Søndag','Mandag','Tirsdag','Onsdag','Torsdag','Fredag','Lørdag');
$daynames = '"Søn", "Man", "Tir", "Ons", "Tor", "Fre", "Lør","Sø", "Ma", "Ti", "On", "To", "Fr", "Lø"';

################################################

define('CURRCOND','Vejret lige nu');
define('METEXT','Met. institutter');
define('ROADEXT','Vejstationer');
define('SOUTH','Syd');
define('WEST','Vest');
define('NORTH','Nord');
define('EAST','Øst');
define('MIDDLE','Centralt');
define('YRSTATIONS','met.no stationer');
define('SYNOPSTATIONS','Synop-stationer');
define('METINFO','Met. institutter - stationer fra det lokale meteologiske institut');
define('ROADINFO','Delvist skyet = tørt');
define('ROADWX','Vej-vejr');
define('FITRAFNAME','Finsk vej administration');
define('SVTRAFNAME','Svensk vej administration');
define('PWSWX','PVS');
define('PWSSTATIONS','PVS-stationer');
define('STSTATS','Statistik');
define('STATION','Station');
define('CHOOSECOUNTRY','Skift land');
define('CHOOSESTATION','Vælg station');
define('SUBMIT','Udfør');
define('SINGLESTATION','Enkelt station');
define('COMPARE','Sammenlign');
define('EXTRAMAP','Specielle lag');
define('SNOWCOVER','Snedække');
define('ICECOVER','Isdække');
define('SEATEMP','Havtemperatur');
define('SNOWDEPTH','Snedybde');
define('TERRAIN','Terræn');
define('STRIKES','Lyn');
define('MINUTES','minutter');
define('GUSTINGTO','Vindstød op til');
define('SAVESETTINGS','Gem som standard');
define('APPARENT','Føles som');
define('STATIONDATA','Stationsdata');
define('WARNINGSIN','varsler i');
define('CLICKONWARN','Klik på områdenavnet for at vise varslet.');
define('CURREXTREMES','Nuværende ekstremer');

define('SETTINGS','Indstillinger');
define('STATS','Statistik');
define('STATSFOR','Statistik for Europæisk Vejr Netværk');
define('STSPERCOUNTRY','Stationer/Lande');
define('NORTHERNMOST','Nordligste/Sydligste mv.');
define('NEWEST','nyeste stationer');
define('MAPLOADS','Korthentninger');
define('MISC','Diverse');

define('LIGHT','Lys');
define('DARK','Mørk');
define('BASEMAP','Standard');
define('TYPE','Type');
define('DATA','Data');
define('WINRUN','Vindløb');
define('RRATE','Regnrate');

define('ACTIVEALARMS','aktive varsler');
define('ACTIVETRACKERS','lyndetektorer har registreret tordenvejr');
define('PWS','Privat');
define('SYNOP','Synop/Metar');
define('NAUTRAL','Naturlig');
define('NIGHTVIEW','Natte visning');
define('BLUEVIEW','Blå visning');
define('BWTXT','Sort / hvid');
define('SATELLITE','Satelit');
define('SEAWARN','Havvarsler');
define('MALARMWARN','Landvarsler');
define('SEAICE','Havtemperatur');
define('ICE','Is');
// Main
define('JOINUS', 'Deltag');
define('LEGEND', 'Forklaring');
define('WEATHER', 'Vejrstation');
define('WEBCAM', 'Webcam');
define('LIGHTNING', 'Lyndetektor');
define('SNOWNOTE', '<b>*OBS!</b> Ikke alle stationer måler snedybde.');
define('NOCOND', 'Ingen aktuelle vejrdata');
define('LOCALTIME', 'Lokal tid');
define('STATIONS', 'stationer');
define('CLICKFORINFO', 'Klik her for mere info om hvordan du kan komme med!');
define('TODAY', 'I dag');
define('ALLTIME', 'Alltime');
define('FORECAST', 'Progonose');
define('ROAD','Vej');
define('WX','Vejr');
define('POUTA','Ophold');
define('LPRECIP','Let nedbør');
define('MPRECIP','Moderat nedbør');
define('HPRECIP','Kraftig nedbør');
define('DRY','Tørt');
define('WET','Vådt');
define('ICY','Iset');
define('SNOWY','Sne');
define('SLIPPERY','Meget glat');
define('LAYER','Kort-lag');
define('REPSNOW','Indt.');
define('ALLCOUT','All lande');
define('SAVED','Gemt');
define('EXTREMECOLDBOX','Usædvanlig koldt ved følgende stationer');
define('EXTREMEHOTBOX','Usædvanlig varmt ved følgende stationer');

define('COORDS','Koordinater');
define('NOCAM','Station har ikke webcam');
define('SYNPRODBY','Synop/Metar-data lavet af');
define('ROADPRODBY','Vej-data lavet af');
define('REMOVEFAVO','Fjern favoritstation');
define('SAVEFAVO','Gem som favoritstation');
define('SGRAPHHEAD','Sidste 24 timer');
define('MOREGRAPH','Flere grafer');
define('MAPSETTINGS','Kortindstillinger');
define('WARMCOLD','Varmeste/koldeste');
define('DATACOUNTER','Datatæller');
define('STARTED','Startet');
define('JOINUS','Tilmeld dig');
define('MEMBERAREA','Kun for medlemmer');
define('WAIT','Henter...');
define('GRAPH','Grafer');
define('DAYS','Dage');
define('THUNDER','Torden');
define('SHOWICON','Ikoner');
define('SHOWSTATION','Stationer');

// V5
$txtcolors = array('Yellow','Orange','Red');
$txttypes = array('Vind','Sne/is','Tordenvejr','Tåge','Ekstremt varmt','Ekstremt koldt','Forhøjet vandstand','Skovbrande','Laviner','Regn');
define('DISTANCE', 'Distance');
define('YOURCLOSEST','Din nærmeste station er');
define('AWLEVEL', 'Varselsniveau');
define('VALID','Gyldig');

define('ALT', 'Højde over havet');
define('HOMEPAGE', 'Klik for hjemmeside');
define('HERE', 'her');
define('CONDITIONS', 'Forhold');
define('FCST', 'Udsigt');
define('NOTHUNDER', 'Ingen tordenvejr registreret');
define('FEATB', 'Station');
define('WINDBOX', 'Vind af stormstyrke er registereret hos følgende stationer (> 22 m/s)');
define('SUMMERFROSTBOX', 'Frost er registreret hos følgende stationer');
define('WARN', 'Varsler');

// NEW
define('SYNEXT', 'Synop-stationer');
define('ROADSTS', 'Vej');
define('TIME', 'Tid');
define('WEBCAMS', 'Webcams');
define('LIGHTNINGS', 'Lynpejlere');
define('OPTIONS', 'Indstillinger');
define('COND', 'Vejrforhold');
define('DIR', 'Retning');
define('RRADAR', 'Regnradar');
define('STATIONSS', ' stationer');
define('CALM', 'Vindstille.');
define('DEWP', 'Dugpunkt');
define('CCOVER', 'Skydække');
define('VISIB', 'Sigtbarhed');
define('NOOBS', 'Ingen vejrdata');
define('SHOW', 'Vis');

define('WCHILL', 'Vindchill');
define('HEAT', 'Hedeindex');
define('TRACA', 'Lynpejler');
define('TRACB', 'tordenvejr');
define('TRACBOX' , 'Følgende stationer observerer tordenvejr nu');

// NEW
define('STSTATS', 'Statistik');
define('TECHNIC', 'Teknik');
define('SOFTWARE', 'Program');
define('HARDWARE', 'Type');
define('NOPE', 'Nej');
define('YES', 'Ja');
define('', '');

// MISC
define('TOPMISC', 'Diverse data');
define('NORTHMST', 'Nordligste');
define('SOUTHMST', 'Sydligste');
define('WESTMST', 'Vestligste');
define('EASTMST', 'Østligste');
define('HIGHMST', 'Højeste beliggende');
define('LOWMST', 'Lavest beliggende');
define('CAMS', 'Antal webcams');
define('TRACKERS', 'Antal lyndetektorer');

// BALLOONS
define('TRACKER', 'Lyndetek.');
define('NORAIN', 'Ingen nedbør i dag');
define('RAIN', 'Nedbør');
define('SNOWD', 'Snedybde');
define('WIND', 'Vind');
define('WINDFROM', 'Vindretning');
define('HUMI', 'Fugtighed');
define('BARO', 'Baro');
define('NOFRAME', 'Din browser understøtter ikke inline rammer eller er ikke sat op til at vise dem.');
define('CURRHEAD', 'Nuværende vejrforhold hos medlemmerne af Europæisk Vejr Netværk');
define('POLARN', 'Mørketid');
define('MIDNIGHTS', 'Midnatssol');

// TABLEHEADER
define('FEAT', 'Station/<br/>Højde over havet');
define('CURHEAD', 'Nuv.<br />Forh.');
define('TEMP', 'Temp');
define('HUM', 'Fugt');
define('AVG', 'Gns. vind');
define('PRECIPS', 'Regn');
define('BAROB', 'Baro');
define('SNOB', 'Sne');

// TOPLISTS
define('TOPHEAD', 'Top 10 observationer fra Europæisk Vejr Netværk');
define('MAXTEMP', 'Max. temperatur');
define('MINTEMP', 'Min. temperatur');
define('MAXAVGW', 'Max. gns. vind');
define('PRECIP', 'Regn ');
define('MAXHUMI', 'Max. humidex');
define('MINCHILL', 'Min. vindchill');
define('MAXGUSTW', 'Max. vindstød');
define('CURRAVG', 'Nuv. gennemsnit');
define('FROMST', '* Fra 1.6.2008 ** Ikke alle stationer registrerer snedybde');
define('DAILYPREC', 'Daglig regn');
define('TOTPREC', 'Regn i alt');
define('TXTGUST', 'Vindstød');

define('NOSTORMS', 'Ingen tordenvejr registreret');
define('TRACA', 'Registrerer');
define('TRACB', 'tordenvejr');

define('WXSIMFRCST','WXSIM vejrudsigt (Stationens egen vejrudsigt)');
define('FRCST','Vejrudsigt fra yr.no');
define('HIDE','Skjul');
define('MAP','Kort');
define('TOPLISTS','Toplister');
define('TABLES','Tabeller');
define('NWN News','NWN Nyheder');
define('BALTIC','Baltiske lande');
define('Login to memberarea','Login til medlemsside');
define('Setup password (For stations joined before 01/12/2011)','Opret adgangskode (For stationer tilmeldt før 01/12/2011)');
define('You need to setup email/password before you can login to memberarea.','Du skal opsætte e-mail/adgangskode før du kan logge ind på medlemssiden.');
define('Your station','Din station');
define('Password','Adgangskode');
define('Snowpassword','Sneadgangskode');
define('YOURINFO','Dine informationer');
define('IHAVENOTWXSTATION','Jeg har ikke min egen vejrstation');
define('PICKCOORDS','Dine koordinater');
define('MOREWEATHER1','Mere vejr:');
define('PASSW','Adgangskode');
define('TYPEEXP','');


function defcountries($rawc) {
$txtcountries =  array(  
"Albania" => "Albanien",
"Andorra" => "Andorra",
"Austria" => "Østrig",
"Belgium" => "Belgien",
"Bulgaria" => "Bulgarien",
"Switzerland" => "Schweitz",
"Czech" => "Tjekket",
"Germany" => "Tyskland",
"Denmark" => "Danmark",
"Estonia" => "Estland",
"Spain" => "Spanien",
"Finland" => "Finland",
"Faroe" => "Færøerne",
"France" => "Frankrig",
"UK" => "Storbritannien",
"Greece" => "Grækenland",
"Hungary" => "Ungern",
"Croatia" => "Kroatien",
"Ireland" => "Irland",
"Iceland" => "Island",  
"Italy" => "Italien",
"Latvia" => "Letland",
"Lithuania" => "Litauen",
"Luxembourg" => "Luxemburg",
"Netherlands" => "Holland",
"Norway" => "Norge", 
"Poland" => "Polen",
"Portugal" => "Portugal",
"Sweden" => "Sverige",
"Slovakia" => "Slovakien",
"Slovenia" => "Slovenien",
"Greenland" => "Grønland",
"Macedonia" => "Makedonien",
"Serbia" => "Serbien",
"Bosnia" => "Bosnien",
"Romania" => "Romania");
if($txtcountries[$rawc]<>''){return $txtcountries[$rawc];}
else {return $rawc;}
}

function defmonths($rawf) {
$txtmon =  array(  
'January' => 'Januar',
'February' => 'Februar',
'March' => 'Marts',
'April' => 'April',
'May' => 'Maj',
'June' => 'Juni',
'July' => 'Juli',
'August' => 'August',
'September' => 'September',
'October' => 'Oktober',
'November' => 'November',
'December' => 'December'
);
$txtmonth = $txtmon[$rawf];
return $txtmonth;
}

?>