<?php
define('FULLGRAPH','Näytä koko ennustejakso');
define('MASL','mpy');
define('TABLE','Taulukko');
define('MAPS','Kartat');
define('ACCURACY','Paikkansapitävyys');
define('COMPAREDESC','Vertaile ennustemalleja');
define('FRCGRAPH','Ennustekäyrä');
define('FRCCOMPARE','Vertaile');
define('HUMIDITY','Ilmankosteus');
define('AGO','sitten');
define('NOCLOSE','Ei ole sääasemia lähistöllä.<br/>Lisää oma sääasemasi EWN:ään <a href=\"https://euweather.eu/join.php?lang=en\" target=\"_blank\">TÄSTÄ</a>.');

define('GLOBALT','Globaali');
define('DATASET','Data');
define('PROVIDER','Jukaisia');
define('COVERAGE','Kattavuus');

define('ALTITUDE','Korkeus');
define('POSTCODE','Postinumero');
define('AREA','Alue');
define('PARKS','Puistoja');
define('AIRPORTS','Lentokenttiä');
define('GOLFCOURSES','Golfkenttiä');
define('SKICENTERS','Hiihtokeskuksia');
define('BEACHES','Uimarantoja');
define('ZOO','Eläintarhoja');
define('MISC','Sekalaista');

define('HAIL','Rae-riski');
define('SEVIDX','Rajuilmaindeksi');
define('MOREMAPS','Lisää karttoja');
define('GOODFRC','Hyvät ennusteet');
define('MEANERROR','Poikkeama');
define('RMSERROR','RMS poikkeama');
define('DETAILEDTABLE','tarkka ennuste');
define('DAYTABLE','päivän taulukko');
define('COMPACCURACY','Paikkansapitävyys &amp; vertailu');
define('ACCURACYFOR','Paikkansapitävyys paikalle');
define('COMPMODELS','Vertaile säämalleja');
define('ACCURACYMODELS','Säämallien paikkansapitävyys');
define('ACCURACYDESC','EWN laittaa sääamallit testiin vertailemalla niiden paikkansapitävyyttä myös niiden "koti-alueen" ulkopuolella joka on yleensä ennusteen laatineen ilmatieteenlaitoksen kotimaa. Paikkansapitävyyttä seurataan noin 900 paikkakunnalle Alppien pohjoispuolella 3 tunnin välein klo 00, 03, 06, 09, 12, 15, 18 sekä 21 UTC. Käytetty ennuste generoidaan edellisenä päivänä noin klo 18 UTC. Näitä tuloksia käytetään myös EWN ennusteen laatimiseen.
<div style="margin-top:15px">
<b>Ennustemallit</b><br/>
- <b>EWN:</b>&nbsp;EWN:än oma ennuste<br/>
- <b>WRFDA:</b>&nbsp;EWN:än ajama WRF<br/>
- <b>DWD:</b>&nbsp;ICON, DWD, Saksa<br/>
- <b>MF:</b>&nbsp;ARPEGE, Meteo France, Ranska<br/>
- <b>KNMI:</b>&nbsp;Hirlam, KNMI, Alankomaat<br/>
- <b>FMI:</b>&nbsp;Hirlam, FMI, Suomi<br/>
- <b>YR:</b>&nbsp;XML-tiedostot (AROME-MetCoOp, Hirlam, ECMWF), MET Norway (yr.no), Norja<br/>
- <b>GFS:</b>&nbsp;GFS, NCEP, USA<br/>
- <b>CMC:</b>&nbsp;CMC Ensemble, CMC, Kanada<br/>
- <b>WXSIM:</b>&nbsp;Yksityisten sääasemien ajama WXSIM-ohjelmisto (tietoja ei löydy kaikille paikkakunnille)<br/>
</div>');
define('ACCURACYMODELSDESC','Jokaisen säämallin kokonais-keskiarvo.');

define('FMODEL','Säämalli');
define('FANIMATION','Animaatio');
define('FON','Päällä');
define('FOFF','Pois');

define('VILLAGES','Kaupunkeja, kyliä');
define('ISLANDS','Saaret, vuoristot');
define('LAKES','Järvet, lahdet');
define('SOLARWINDENERGY','Aurinko/tuuli-energia');
define('HDD','Lämmitystarve');
define('SOLAR','Aurinko');
define('SOLARWINDINFO','Tämän taulukon tiedot perustuvat EWN WRFDA-säämalliin. Auringon säteily: SW - lyhytaalto, LW - pitkäaalto. HDD - '.HDD.'.');

define('COOP','Yhteistyössä'); 
define('DATAPWS','Tiedot tuottaa yksityiset sääasemat');
define('WARNBX','Varoitukset tuottaa');
define('WARNBY','tuoreimmat varoitukset löydät aina paikalliselta ilmatieteen laitoksen sivuilta'); 
define('SCRADM','Skripti sekä admin');
define('NORES','EWN ei ole vastuussa tietojen paikkansapitävyydestä.<br/>Muutoin kun erikseen mainittu on sivu lisensoitu');
define('SUBTITLDESC','ennusteista ovat olleet paikkansapitäviä tai erittäin paikkansapitäviä. Lisätieoja löydät <a href="frc_stats.php?'.$lang.'">statistiikka-sivulta');
define('SEARCHLOC','Hae paikkakunta');
define('SUBTITLE','PARHAITEN PAIKKANSAPITÄVÄT SÄÄENNUSTEET'); // Feel free to figure out something better, note it refers to forecast-accuracy
define('METPROV','Tiedot toimittaa');
define('PRIVATESTATION','Yksityinen');
define('METOFFICESTATION','Ilmatieteen laitos');
define('ROADSTATION','Tiesääasema');
define('JUSTNOW','Juuri nyt');
define('CLOSEOBS','Lähellä olevat sääasemat');
define('TONIGHT','Tänään');
define('WARNANDSEVERE','Varoitukset sekä rajuilmat');
define('FAVORITES','Suosikki-paikkakunnat');
define('SAVEFAVORITESETTINGS','Tallenna');
define('SAVEASFAVORITE','Lisää suosikkeihin');
define('ADDEDTOFAVO','Paikkakunta lisätty suosikkeihin!');
define('NOFAVORITES','Ei suosikkeja!');
define('NOWARNS','Ei aktiivisia varoituksia');
define('RADARSTRIKES','Tutka &amp; salamat');
define('SEVEREW','Rajuilmat');
define('SNOW','Lumisade');
define('LEVEL','Taso');
define('OTHER','muu');
define('DAY','Päivä');
define('COMPFRCMODEL','Vertaile säämalleja');
define('TSPROB','Ukkosriski');
define('SEVERE','Rajuilmat');
define('SEVEREFRCTODAY','Rajuilmaennuste');
define('HOTCOLD','Lämpimin, kylmin, tuulisin, märin');
define('TENWARMEST','10 lämpimintä paikkakuntaa');
define('TENCOLDEST','10 kylmintä paikkakuntaa');
define('WINDIEST2','Tuuli &gt;');
define('WETTEST2','Sade &gt; 4 mm/h');
define('LOCATIONS','Muita paikkakuntia');
define('SELECTCOUNTRY','Valitse maa');
define('SELECTLANGUAGE','Kieli');
define('SELECTWUNIT','Tuulen yksikkö');
define('LOCATEME','Paikanna minut!');
define('LOADING','Lataa...');
define('FAVORITELOCATIONS','Suosikkipaikkakunnat');
define('HOME','Koti');
define('FRCSTMAPS','Sääennustekartat');
define('FRCSTVIDEOS','Sääennustevideot');
define('FORECASTS','Sääennusteet');
define('STORMFORECAST','Rajuilma-ennusteet');
define('AURORAFORECAST','Revontuliennuste');
define('RADAR','Tutka');
define('PRECRADAR','Sadetutka');
define('FINLAND','Suomi');
define('SCANDINAVIA','Skandinavia');
define('EUROPE','Eurooppa');
define('DISABLED','Ei käytössä');
define('STRLAST2MIN','Viim. 2 min'); // Short!!
define('WEBCAMS','Webkamerat');
define('VHIGH','Erittäin korkea');
define('EXTREME','Extreme');
define('WXSTATIONS','Sääasemat');
define('WXSTATION','Sääasema');
define('AVGERROR','Keskimääräinen virhe');
define('ROADSTATIONS','Tiesääasemat');
define('SUN','Aurinko');
define('WINDRUN','Tuulen juoksu');
define('WEBURL','Websivun URL');
define('DIRECTLINK','Suora linkki');
define('LOGIN','Kirjaudu');
define('HAVEUV','Asemalla UV-anturi');
define('HAVESOLAR','Asemalla aurinko-aunturi');
define('ORTEXT','tai');
define('USERNAME','Käyttäjänimi');
define('FRGTPASS','Salasana unhotunut');
define('RESETPASS','Resetoi salasana');
define('SOLARHEATED','Aurinkolämmitetty');
define('SOLARHEATDESC','Tunnit joilloin aurinko lämmittää lämpötila-anturia - laita -1 poistaaksesi käytöstä');
define('SOLARHEATDESC2','EWN Admin pitää oikeuden muuttaa asetusta tarvittaessa. "Ei säyeilysuojaa" laittaa aseman aurinkolämmitetyksi päiväsaikaan.');
define('BOSTATIONS','Blitzortung-asemat');
define('BODESC','Listaa BO-asemasi, mikäli sinulla on useampi asema voit erottaa ne |-merkillä, esim 4566|6543.');
define('BONAME','BO aseman nimi');
define('NEWUSERNAME','Uusi käyttäjänimi');
define('DOWNLOADNOTE','Huom! Mikäli lautaus eikäynnisty, klikkaa oikealla ja "Tallenna nimellä".');
define('YOULOGOUT','Olet kirjautunut ulos');
define('CONTACT','Ota yhteyttä');
define('CLOSE','Sulje');
$days = array('Sunnnuntai','Maanantai','Tiistai','Keskiviikko','Torstai','Perjantai','Lauantai');
$months = array('Tam','Hel','Maa','Huh','Tou','Kes','Hei','Elo','Syy','Lok','Mar','Jou');
define('cookietitle','Other');
define('cookiedescription','Settings like favorite locations use cookies. This includes also the social media plugins on the page');
define('advertisingDefaultTitle','Advertising');
define('analyticsDefaultTitle','Analytics');
define('analyticsDefaultDescription','We anonymously measure your use of this website to improve your experience.');
define('advertisingDefaultDescription','Adverts will be chosen for you, automatically based on your past behaviour and interests.');
define('notificationTitleImplicit','We use cookies to ensure you get the best experience on our website');
define('allowCookiesImplicit','Got it!');
define('savePreference','Save preference');
define('hideDetails','hide details');
define('seeDetailsImplicit','change your settings');
$boinfo.= "<br/>Sadetutkat p&auml;ivittyv&auml;t 15 minuutin v&auml;lein vaihtelevalla viiveell&auml;, FMI:n sadetutka p&auml;ivittyy 5 minuutin v&auml;lein.<br/><br/>
<b>Blitzortung</b><br/>
  Blitzortung.org on yksityinen salamapaikantimien verkko jossa mukana yli 1000 paikatinta koko Euroopassa. Paikantimet ker&auml;&auml;v&auml;t salamaniskujen aiheuttamia elektromangneettisia signaaleja. Salamaniskun tarkka aika ja paikka voidaan m&auml;&auml;ritt&auml;&auml; n&auml;ist&auml; signaaleista (TOA - time of arrival metodi). Löyd&auml;t lis&auml;&auml; informaatiota projektista t&auml;&auml;lt&auml;: <a href='http://www.blitzortung.org' target='_blank'>www.blitzortung.org</a>.<br/>
  Blitzortung:in tarkkuus on hyv&auml; ja yleisesti alle 1 km. Tarkkuudessa p&auml;&auml;st&auml;&auml;n kaupallisten toimijoiden sek&auml; ilmatieteen laitosten tasolle.<br/>
Voit halutessasi hankkia suhteellisen edullisen oman paikantimen. N&auml;in voit osallistua salamapaikanninverkon toimintaan ja saat p&auml;&auml;syn myös kattavampaan dataan";
define('WEEWXINFO','Mikäli käytät WD-pluginiä ja uppaat clientraw.txt tai customclientraw.txt SteelSeries Mittareille, sinun ei tarvitse tehdä mitään. Valitse WD tai SteelSeries Gauges ohjemistoksi.');

# FORECAST RELATED
define('FRCWARN','Klikkaa nähdääksesi koko varoituksen. Varoitukset tuottaa');
define('EWNACC','Paikkansapitävyys-testi vertaa mitattuja lämpötiloja ennusteen lämpötiloihin noin 500 paikkakunnalla 52&deg;N pohjoispuolella aina Nordkappiin asti. Yksi valintakriteeri on että paikkaunnalta löytyy luotettava sääasema (eli jos mahdollista paikallisen ilmatieteen laitoksen). Virhearvot ovat absoluutisia asteita, eli ovat aina positiivisia. Testissä näytetään viimeisen 30 päivän tiedot.');
define('LIGHTNINGMAP','Salamakartta');
define('DAYLENGTH','Päivän pituus');
define('MIDNIGHTSUN','Yötön yö');
define('POLARNIGHT','Kaamos');
define('QUICKLINKS','Suorat linkit');
define('CLOSESTWXSTATION','Lähin sääasema');
define('POP','Saderiski');
define('RANGE','Vaihteluväli');
define('DAYFRC2','vrk sääennuste');
define('MORE','Lisää &raquo;');
define('DAILYMAP','24h kartat');
define('FDAYS','Päivä');
define('DTOMORROW','Ylihuomenna');
define('FMAP','Kartta');
define('MAXI','Ylin');
define('MINI','Alin');
define('SEVRISK','Ukkosriski');
define('LEV3','Erittäin raju');
define('LEV2','Rajuilma');
define('TS','Salamointiriski');
define('SEVERERISK','RAJUILMA-RISKIT');
define('TSRISK','Riski ukkoskuuroille');
define('SUPERCELLRISK','Riski supersoluille');
define('TORNADORISK','Riski tornadoille');
define('HAILRISK','Riski rakeille');

define('CLICKINFO','Klikkaa kartasta sadaaksesi ennusteen mistä vain!');
define('FSLEET','Räntäsadetta');
define('YOURLOCATION','Ennuste sijannillesi');
define('FRCACCURACY','Ennusteen paikkansapitävyys');
define('FRCACCINFO','Seuraamme muutaman mallin paikkansapitävyyttä parille paikkakunnalle seuraamalla 12 tunnin kohtaa ennusteessa.');
define('DOWNLOADED_FRC','Ladataut ennusteet');
define('TOTDOWNLOADED_FRC','Ladatut ennusteet yhteensä');
define('PLACE','Paikkakunta');
define('FRCS','Sääennusteet');
define('LATI','Leveysaste');
define('LONGI','Pituusaste');

define('TOMORROW','Huomenna');
define('SUNANDMOON','Aurinko ja kuu');
define('UVFORECAST','4 päivän UV-ennuste');
define('LOW','Matala');
define('MED','Kohtalainen');
define('HIG','Korkea');
define('LOCATIONINFO','Paikkatieto');
define('ELEVATION','Korkeus');
define('POPULATION','Asukasluku');
define('FEELS','Tuntuu');
define('GUST','Puuska');

define('EWNFORECAST','EWN-Sääennuste');
define('FRCSEARCH','Hae ennustetta');
define('FRCSAVE','Tallenna paikka');
define('FORECASTINFO','EWN Ennuste on EWN:än oma sääennuste. Se on ainut ennuste joka laaditaan kun haet sitä! Tämä tarkoittaa sitä että siinä on aina tuoreimmat tiedot mitä on saatvailla.<br/>EWN-Ennuste on saatavilla noin 850000:lle paikkakunnalle koko Europpassa.');
define('FRCINFOB','EWN Ennuste käyttä useata vapaata ennuste-mallia lähteenä ennusteisiin. EWN ei ole vastuussa ennusteiden paikkansapitävyydestä.<br/>Tämän lisäksi ajamme omaa WRFDA EMS ennustemallia 12 km resoluutiolla. Myös kartat ovat tehty tästä WRFDA EMS mallista.<br/><br/>
Ennusteissa on sisältöä sekä käytetty dataa seuraavista lähteistä:<br/>
<a href="http://nomads.ncep.noaa.gov/" target="_blank">NCEP</a> (GFS, GEFS &amp; UV), <a href="http://weather.gc.ca" target="_blank">The Canadian Meteorological Center</a> (GEM-GDPS), <a href="http://www.met.no" target="_blank">Norwegian Meteorological Institute</a> (MET Norway), <a href="http://www.smhi.se" target="_blank">Swedish Meteorological and Hydrological Institute</a> (SMHI), <a href="http://www.fmi.fi" target="_blank">Suomen ilmatieteen laitos</a> (FMI), <a href="http://www.dwd.de" target="_blank">Deutscher Wetterdienst</a> (DWD), <a href="http://www.geonames.org" target="_blank">Geonames</a>, <a href="http://www.meteoalarm.eu" target="_blank">MeteoAlarm</a>, <span id="moresources"></span>WXSIM - lähellä yksityisiä sääasemia jolla WXSIM-ohjelmisto.
');

define('SAVEFAVO','Oletus sijanti');
define('SAVEQUI','Lisää pikahakuun');
define('SEARCHCOUNTRY','Maa');
define('PLACESEARCH','Hae');
define('QUICKSEARCH','Pikahaku');
define('OWNPLACES','Omat paikat');

define('FORECASTFOR','Sääennuste paikalle');
define('ISSUED','Laadittu');

define('SHORTFRC','Lyhyesti');
define('HOURFRC','Tunti tunnilta');
define('DAYFRC','vrk sääennuste');
define('NERDFRC','Extrat');
define('COMPFRC','Vertailu');
define('MAPFRC','Kartat');

define('FGUST','Kovin tuulenpuuska');
define('FRATE','Sateen voimakkuus');
define('BASEMAPS','Pohjakartta');
define('SATELLITE','Sateliitti');
define('TTINFO','Ukkosen mahdollisuus: 45-50 mahdollinen, <br/>50-55 todenn&auml;k&ouml;ist&auml;, 55-60 eritt&auml;in todenn&auml;k&ouml;ist&auml;');
define('SRHINFO','150-299 supersolut mahdolliset, <br/> 300-500 supersolut todenn&auml;k&ouml;isi&auml; ja tornadot mahdollisia');
define('DBZINFO','20 kevytt&auml; sadetta, <br/> 30 kohtalaista sadetta, 50 kovaa sadetta, rakeita');
define('KIINFO','noin 2 x K Index = Ukkosriski');
define('FTEMP','Lämpötila');
define('FCHILL','Hyytävyys');
define('FDEW','Kastepiste');
define('FWIND','Tuuli');
define('FPREC','Sade');
define('FCLOUD','Pilvisyys');
define('FBARO','Ilmanpaine');
define('FSNOW','Lumisade');
define('FHAIL','Rakeita');
define('FFRZ','J&auml;&auml;t&auml;v&auml;&auml;');
define('FLIG','Ukkosta');
define('FCONV','Konv. sade');
define('FVISIB','N&auml;kyvyys');
define('FTHUN','Ukkosriski');
define('FINSTA','Pot. Ep&auml;vakaisuus');
define('FFORE','Sääennusteet');
define('FAVG','Keskim.');
define('FWDIR','Tuulen suunta');
define('FUTIMES','P&auml;ivitysajat');
define('FRESO','Resoluutio');
define('FLENGTH','Pituus');
define('FSTEPS','Tiheys');
define('FRADAR','sadetutka');
define('FSAT','sateliitti');
define('SIGHAIL','Merk. Raeriski');
define('SIGTOR','Merk. Tornadoriski');
define('SIGSUP','Merk. Supersoluriski');
define('MCOMPRADAR','Maks. yhd. sadetutka');
define('SIGHAIL2','Merkitt&auml;v&auml; Raeriski');
define('SIGTOR2','Merkitt&auml;v&auml; Tornadoriski');
define('SIGSUP2','Merkitt&auml;v&auml; Supersoluriski');
define('MCOMPRADAR2','Maksimi yhdistetty sadetutka');
define('MOREMAPS','Lis&auml;&auml; karttoja');
define('FRCCINFO','
<b>Salamointiriski kartat</b> - Vihreä ja keltainen osoittaa salamointimahdollisuutta 40 km säteellä pisteestä. Oranssi, punainen sekä violetti ovat samankaltaisia tasoja mitä on estofex.orgin kartoissa ja sisältävät myös rakeet ja supersolut.<br/><br/>
<b>dBZ</b> - dBZ tarkoittaa decibeli&auml; suhteessa Z:&auml;&auml;n. On meteorologinen arvo mittamaan tutka-kaijun heijastavuutta (Z) esinett&auml;, kuten sadepisaroita, vastaan.
<br/><br/>
<b>Cape</b> - Cape (CAPE, lyhenne sanoista engl. Convective Available Potential Energy, konvektion k&auml;ytett&auml;viss&auml; oleva energia) on ilmakeh&auml;n ep&auml;vakautta kuvaava tunnusluku, joka lasketaan ilmakeh&auml;n pystysuuntaisesta l&auml;mp&ouml;tila- ja kosteusrakenteesta esimerkiksi radioluotauksen avulla. Suuret cape-arvot kertovat siit&auml; ett&auml; nousuliike voi kiihty&auml; voimakkaaksi; siksi suuri cape liittyy usein voimakkaaseen konvektioon ja suureen ukkosen todenn&auml;k&ouml;isyyteen.
<br/><br/>
<b>K Index</b> - K Index on ukkosen todenn&auml;k&ouml;isyyden kertova arvo k&auml;ytt&auml;en l&auml;mp&ouml;tilan muutosnopeutta liikkuessa yl&ouml;sp&auml;in, matalemman ilmankeh&auml;n ilmankosteutta, kostean kerroksen pystysuoraa laajuutta.
<br/><br/>
<b>TT Index</b> - Total totals -indeksi on ilmakeh&auml;n ep&auml;vakaisuutta kuvaava luku, joka lasketaan l&auml;mp&ouml;tilav&auml;hetteest&auml; ja ilman kosteudesta.
<br/><br/>
<b>WRF</b> - The Weather Research and Forecasting (WRF) on seuraavan sukupolven suurs&auml;&auml;tilan numeerinen ennustej&auml;rjestelm&auml;, jonka tarkoituksena on palvella niin normaalia s&auml;&auml;n ennustamista kuin ilmakeh&auml;n tutkimuksen tarpeita. WRF:n kehitysty&ouml; on seuraavien yritysten yhteisty&ouml;: National Center for Atmospheric Research (NCAR), National Centers for Environmental Prediction (NCEP), Forecast Systems Laboratory (FSL), Air Force Weather Agency (AFWA), Naval Research Laboratory, University of Oklahoma sek&auml; Federal Aviation Administration (FAA). T&auml;m&auml; ohjelma ajetaan meid&auml;n palvelimella.
<br/><br/>
<b>WRFDA</b> - Monipuolisempi versio WRF:stä<br/><br/>
<b>Arome</b> - 2.5 km Arome malli. Tuottaa Norjan ilmatieteen laitos.
<br/><br/>
<b>MET Norway</b> - Proff-default 4km on "paras arvio" useasta met.no:lla ajetusta meteorologisesta mallinuksesta joka on yhdistetty yhdeksi paketiksi. Toimittaa Norjan meteorologinen laitos.
<br/><br/>
<b>SMHI</b> - Hirlam malli tuottajana Ruotsin ilmatieteen laitos.
<br/><br/>
<b>FMI</b> - Hirlam malli tuottajana Suomen ilmatieteen laitos. Kattaa vain Suomen.
<br/><br/>
<b>GFS</b> - The Global Forecast System (GFS) is a global numerical weather prediction computer model run by NOAA.
<br/><br/>
<b>GEM-GDPS</b> - GEM-GDPS on Canadian Meteorological Centre:n yll&auml;pit&auml;m&auml; globaali numeerinen s&auml;&auml;malli.
<br/><br/>
<span style="color:#888"><b>Credits:</b> Suuri kiitos <a href="http://www.saakeskus.fi" target="_blank">s&auml;&auml;keskus.fi</a>:n Stefan Gofferje:lle joistakin kaavoista GrADS:lle. Infot: Wikipedia.</span>');
define('SHOWADV','Näytä enemmän');
define('FPRECTYP','Sateen olomuoto');
define('FSNOWD','Lumen syvyys');
define('FRAIN','Vesisade');
define('FTMPSFC','Maapinnan lämpötila');
define('FACCUM','Sadekertymä');
define('FHUM','Kosteus');
define('FFEELS','Tuntuu');
define('FTODAY','Tänään');
define('FTOMOZ','Huomenna');

$days = array('Sunnuntai','Maanantai','Tiistai','Keskiviikko','Torstai','Perjantai','Lauantai');
$daynames = '"Sun", "Maa", "Tii", "Kes", "Tor", "Per", "Lau","Su", "Ma", "Ti", "Ke", "To", "Pe", "La"';

################################################

define('CURRCOND','Säätila');
define('METEXT','Met. laitokset');
define('ROADEXT','Tiesää-asemat');
define('SOUTH','Etelä');
define('WEST','Länsi');
define('NORTH','Pohjois');
define('EAST','Itä');
define('MIDDLE','Keski');
define('YRSTATIONS','met.no-asemat');
define('SYNOPSTATIONS','Synop-asemat');
define('METINFO','Met. laitokset - Paikallisen ilmatieteen laitoksen asemat.');
define('ROADINFO','Puolipilvinen = Pouta.');
define('ROADWX','Tiesää');
define('FITRAFNAME','Liikennevirasto');
define('SVTRAFNAME','Ruotsin liikennevirasto');
define('PWSWX','Yksityiset');
define('PWSSTATIONS','Yksityiset asemat');
define('STSTATS','Tilastot');
define('STATION','Asema');
define('CHOOSECOUNTRY','Vaihda maata');
define('CHOOSESTATION','Valitse asema');
define('SUBMIT','Lähetä');
define('SINGLESTATION','Yksittäinen asema');
define('COMPARE','Vertaile asemia');
define('EXTRAMAP','Erikoiskarttoja');
define('SNOWCOVER','Lumitilanne');
define('ICECOVER','Jäätilanne');
define('SEATEMP','Meren pintalämpötila');
define('SNOWDEPTH','Lumensyvyys');
define('TERRAIN','Maastokartta');
define('STRIKES','Salamat');
define('MINUTES','minuuttia');
define('GUSTINGTO','Puuskissa');
define('SAVESETTINGS','Tallenna oletukseksi');
define('APPARENT','Tuntuu kuin');
define('STATIONDATA','Asemadata');
define('WARNINGSIN','varoitusta');
define('CLICKONWARN','Klikkaa haluamasi alueen nimeä nähdääksesi varoituksen.');
define('CURREXTREMES','Juuri nyt');

define('SETTINGS','Asetukset');
define('STATS','Statistiikka');
define('STATSFOR','Statistiikkaa European Weather Network:lle');
define('STSPERCOUNTRY','Asemia/Maa');
define('NORTHERNMOST','Pohjoisin/Eteläisin jne');
define('NEWEST','uusimmat asemat');
define('MAPLOADS','Karttalatausta');
define('MISC','Sekalaista');

define('LIGHT','Vaalea');
define('DARK','Tumma');
define('BASEMAP','Pohjakartta');
define('TYPE','Tyyppi');
define('DATA','Data');
define('WINRUN','Tuulenjuoksu');
define('RRATE','Voimakkuus');

define('ACTIVEALARMS','aktiivista varoitusta');
define('ACTIVETRACKERS','tutkaa havainnut ukkossoluja');
define('PWS','Yksityiset');
define('SYNOP','Synop/Metar');
define('NAUTRAL','Luonnollinen');
define('NIGHTVIEW','Yö');
define('BLUEVIEW','Sinertävä');
define('BWTXT','Musta/Valkoinen');
define('SATELLITE','Sateliitti');
define('SEAWARN','Merivaroitukset');
define('MALARMWARN','Maavaroitukset');
define('SEAICE','Meri');
define('ICE','Jää');

define('MAP','Kartta');
define('WXSIMFRCST','5 päivän WXSIM-ennuste');
define('WXSIMINFO','Ennuste on aseman oma, WXSIM-ohjelmalla tehty ennuste');
define('FRCST','48 tunnin ennuste');
define('HIDE','Piilota');
define('TOPLISTS','Toplistat');
define('TABLES','Taulukot');
define('INFO','Tietoja');
define('BALTIC','Balttia');
define('MOREWEATHER1','Lisää säätietoja');
define('IHAVENOTWXSTATION','Minulla EI ole sääasemaa');
define('YOURINFO','Tietosi');
define('PICKCOORDS','Valitse kordinaatit kartalta');
define('PASSW','Salasana');
define('DEFLOC','Oletussijanti');
define('SAVE','Tallenna');
define('STATIONLESS','Manuaaliset');
define('SAVED','Tallennettu');
define('SAVED','Tallennettu');
define('EXTREMECOLDBOX','Seuraavilla asemilla on epätavallisen kylmää');
define('EXTREMEHOTBOX','Seuraavilla asemilla on epätavallisen lämmintä');

// Main
define('JOINUS','Liity mukaan');
define('LEGEND', 'Selitys');
define('WEATHER', 'Sää');
define('WEBCAM', 'Webkamera');
define('LIGHTNING', 'Salamat');
define('SNOWNOTE', '<b>*Huom!</b> Kaikki asemat eivät raportoi lumensyvyyttä.');
define('NOCOND', 'Ei ajantasaista tietoa');
define('LOCALTIME', 'Paikallinen aika');
define('STATIONS', 'asemaa');
define('CLICKFORINFO', 'Klikkaa saadaksesi lisäinfoa miten liittyä!');
define('TODAY', 'Tänään');
define('ALLTIME', 'Alltime');
define('FORECAST', 'Sääennuste');
define('ROAD','Tie');
define('WX','Sää');
define('POUTA','Pouta');
define('LPRECIP','Heikko sade');
define('MPRECIP','Koht. sade');
define('HPRECIP','Voim. sade');
define('DRY','Kuiva');
define('WET','Märkä');
define('ICY','Jäinen');
define('SNOWY','Luminen');
define('SLIPPERY','Mahd. liukas');
define('LAYER','Layer');
define('REPSNOW','Ilm.');
define('ALLCOUT','Kaikki maat');

define('COORDS','Koordinaatit');
define('NOCAM','Asemalla ei ole kameraa');
define('SYNPRODBY','Synop/Metar-tiedot tuottaa');
define('ROADPRODBY','Tiesää-tiedot tuottaa');
define('REMOVEFAVO','Poista suosikkiasema');
define('SAVEFAVO','Tallenna suosikkiasemaksi');
define('SGRAPHHEAD','Viime 24 tuntia');
define('MOREGRAPH','Lisää käyriä');
define('MAPSETTINGS','Kartan asetukset');
define('WARMCOLD','Lämpimin/Kylmin');
define('DATACOUNTER','Datalaskuri');
define('STARTED','Käynnistetty');
define('JOINUS','Liity mukaan');
define('MEMBERAREA','Jäsenalue');
define('WAIT','Ladataan...');
define('GRAPH','Käyrät');
define('DAYS','Päivää');
define('THUNDER','Ukkonen');
define('SHOWICON','Ikonit');
define('SHOWSTATION','Asemat');

// V5
$txtcolors = array('Keltainen','Oranssi','Punainen');
$txttypes = array('Tuuli','Lumi/Jää','Ukkonen','Sumu','Korkea lämpötila','Matala lämpötila','Rannikkoalueen vaara','Metsäpalo','Lumivyöry','sade');
define('DISTANCE', 'Etäisyys');
define('YOURCLOSEST','Lähin sääasema on');
define('AWLEVEL', 'Varoitustaso');
define('VALID','Voimassa');

define('ALT', 'Korkeus');
define('HOMEPAGE', 'Kotisivu');
define('HERE', 'Täällä');
define('CONDITIONS', 'Säätila');
define('FCST', 'Ennuste');
define('NOTHUNDER', 'Ei havaittuja ukkossoluja');
define('FEATB', 'Asema');
define('WINDBOX', 'Seuraavilla asemilla mitataan myrskytuulia (yli 22 m/s)');
define('SUMMERFROSTBOX', 'Seuraavilla asemilla mitataan pakkasta');
define('WARN', 'Varoitukset');

// NEW
define('SYNEXT', 'Synop-asemat');
define('ROADSTS', 'Tiesää');
define('TIME', 'Aika');
define('WEBCAMS', 'Webkamerat');
define('LIGHTNINGS', 'Ukkostutkat');
define('OPTIONS', 'Asetukset');
define('COND', 'Säätila');
define('DIR', 'Tuulen suunta');
define('RRADAR', 'Sadetutka');
define('STATIONSS', '-asemat');
define('CALM', 'Tyyntä');
define('DEWP', 'Kastepiste');
define('CCOVER', 'Pilvisyys');
define('VISIB', 'Näkyvyys');
define('NOOBS', 'Ei havaintoa');
define('SHOW', 'Näytä');

define('WCHILL', 'Hyytävyys');
define('HEAT', 'Tukaluus');
define('TRACA', 'Seuraa');
define('TRACB', 'ukkossolua');
define('TRACBOX' , 'Seuraavien asemien ukkostutkat seuraavat ukkossoluja tällä hetkellä');

// MISC

define('TOPMISC', 'Nippelitietoja');
define('NORTHMST', 'Pohjoisin asema');
define('SOUTHMST', 'Eteläisin asema');
define('WESTMST', 'Läntisin asema');
define('EASTMST', 'Itäisin asema');
define('HIGHMST', 'Korkein asema');
define('LOWMST', 'Matalin asema');
define('CAMS', 'Webkameroita');
define('TRACKERS', 'Ukkostutkia');

// BALLOONS
define('TRACKER', 'Ukkostutka');
define('NORAIN', 'Ei sadetta tänään');
define('RAIN', 'Sade');
define('SNOWD', 'Lumen syvyys');
define('WIND', 'Tuuli');
define('WINDFROM', 'Tuuli');
define('HUMI', 'Kosteus');
define('BARO', 'Ilmanpaine');
define('NOFRAME', 'Your browser does not support inline frames or is currently configured not to display inline frames.');
define('CURRHEAD', 'Säätila European Weather Network:in jäsenasemilla juuri nyt');
define('POLARN', 'Kaamos-aika');
define('MIDNIGHTS', 'Yötön yö');
define('SUNRISE', 'Auringonnousu');
define('SUNSET', 'Auringonlasku');
define('TIME', 'Aika');

// NEW
define('STSTATS', 'Tilastot');
define('TECHNIC', 'Tekniikka');
define('SOFTWARE', 'Ohjelmisto');
define('HARDWARE', 'Tyyppi');
define('NOPE', 'Ei');
define('YES', 'Kyllä');
define('', '');

// TABLEHEADER
define('FEAT', 'Asema');
define('CURHEAD', 'Sää');
define('TEMP', 'Lämpötila');
define('HUM', 'Ilmank.');
define('AVG', 'Tuuli');
define('PRECIPS', 'Sade');
define('BAROB', 'Ilmanp.');
define('SNOB', 'Lumi');
define('TXTGUST', 'Puuska');

// TOPLISTS
define('TOPHEAD', 'Top 10 havaintoa European Weather Network:in jäsenasemilta');
define('MAXTEMP', 'Ylin lämpötila');
define('MINTEMP', 'Alin lämpötila');
define('MAXAVGW', 'Kovin keskituuli');
define('PRECIP', 'Sade');
define('MAXHUMI', 'Ylin tukaluus');
define('MINCHILL', 'Alin hyytävyys');
define('MAXGUSTW', 'Kovin puuskatuuli');
define('CURRAVG', 'Keskiarvot juuri nyt');
define('DAILYPREC', 'Päivittäinen sade');
define('TOTPREC', 'Sade yhteensä');

define('NOSTORMS', 'Ei ukkosalueita');
define('TRACA', 'Seurataan');
define('TRACB', 'ukkosaluetta');

function defcountries($rawc) {

$txtcountries =  array(  
"Albania" => "Albania",
"Andorra" => "Andorra",
"Austria" => "Itävalta",
"Belgium" => "Belgia",
"Bulgaria" => "Bulgaria",
"Switzerland" => "Sveitsi",
"Czech" => "Tsekki",
"Germany" => "Saksa",
"Denmark" => "Tanska",
"Estonia" => "Viro",
"Spain" => "Espanja",
"Finland" => "Suomi",
"Faroe" => "Fäärsaaret",
"France" => "Ranska",
"UK" => "Iso-Britannia",
"Greece" => "Kreikka",
"Hungary" => "Unkari",
"Croatia" => "Kroatia",
"Ireland" => "Irlanti",
"Iceland" => "Islanti",  
"Italy" => "Italia",
"Latvia" => "Latvia",
"Lithuania" => "Liettua",
"Luxembourg" => "Luxemburg",
"Netherlands" => "Alankomaat",
"Norway" => "Norja", 
"Poland" => "Puola",
"Portugal" => "Portugali",
"Sweden" => "Ruotsi",
"Slovakia" => "Slovakia",
"Slovenia" => "Slovenia",
"Greenland" => "Grönlanti",
"Macedonia" => "Makedonia",
"Serbia" => "Serbia",
"Bosnia" => "Bosnia",
"Romania" => "Romania",
// New
"Aland Islands" => "Ahvenanmaa",
"Belarus" => "Valko-Venäjä",
"Cyprus" => "Kypros",
"Czech Republic" => "Tsekki",
"Faroe Islands" => "Fäärsaaret",
"Russia" => "Venäjä",
"Vatican" => "Vatikaani",
"United Kingdom" => "Iso-Britannia"
);
if($txtcountries[$rawc]<>''){return $txtcountries[$rawc];}
else {return $rawc;}
}


function defmonths($rawf) {
$txtmon =  array(  
'January' => 'Tammikuu',
'February' => 'Helmikuu',
'March' => 'Maaliskuu',
'April' => 'Huhtikuu',
'May' => 'Toukokuu',
'June' => 'Kesäkuu',
'July' => 'Heinäkuu',
'August' => 'Elokuu',
'September' => 'Syyskuu',
'October' => 'Lokakuu',
'November' => 'Marraskuu',
'December' => 'Joulukuu'
);
$txtmonth = $txtmon["$rawf"];
return $txtmonth;
}

?>