<?php
define('FULLGRAPH','All days');
define('MASL','masl');
define('TABLE','Table');
define('MAPS','Maps');
define('ACCURACY','Accuracy');
define('COMPAREDESC','Compare forecastmodels');
define('FRCGRAPH','Forecastgraph');
define('FRCCOMPARE','Compare');
define('HUMIDITY','Humidity');
define('AGO','ago');
define('NOCLOSE','There are no weatherstations nearby.<br/>Add your own weatherstation to EWN <a href=\"https://euweather.eu/join.php?lang=en\" target=\"_blank\">HERE</a>.');

define('GLOBALT','Global');
define('DATASET','Dataset');
define('PROVIDER','Provider');
define('COVERAGE','Coverage');

define('HAIL','Grêle');
define('SEVIDX','Severe Index');
define('MOREMAPS','Plus de cartes');
define('GOODFRC','Bonnes prévisions');
define('MEANERROR','Moyenne erreur');
define('RMSERROR','RMS erreur');
define('DETAILEDTABLE','détaillées');
define('DAYTABLE','Tableau journalier');
define('COMPACCURACY','Précision &amp; comparaison');
define('ACCURACYFOR','Précision pour');
define('COMPMODELS','Comparer les modèles');
define('ACCURACYMODELS','Précision des modèles');
define('ACCURACYDESC','EWN met les modèles de prévision dans une véritable situation de test en surveillant leur précision aussi en dehors de leur "zone locale" qui est généralement le pays de l\'institut météorologique d\'émission. La précision est surveillée depuis 900 endroits environ au nord des Alpes et est calculée en comparant les prévisions avec la température observée toutes les 3 heures à 00, 03, 06, 09, 12, 15, 18 and 21 UTC. Les prévisions utilisées pour le lendemain sont générées à 18 UTC environ. Ces résultats sont ensuite utilisés pour calculer les prévisions EWN.
<div style="margin-top:15px">
<b>Modèles</b><br/>
- <b>EWN :</b>&nbsp;EWN\'s own forecast<br/>
- <b>WRFDA :</b>&nbsp;WRF runned by EWN<br/>
- <b>DWD :</b>&nbsp;ICON, DWD, Germany<br/>
- <b>MF :</b>&nbsp;ARPEGE, Meteo France<br/>
- <b>KNMI :</b>&nbsp;Hirlam, KNMI, The Netherlands<br/>
- <b>FMI :</b>&nbsp;Hirlam, FMI, Finland<br/>
- <b>YR :</b>&nbsp;XML-files (AROME-MetCoOp, Hirlam, ECMWF), MET Norway (yr.no)<br/>
- <b>GFS :</b>&nbsp;GFS, NCEP, USA<br/>
- <b>CMC :</b>&nbsp;CMC Ensemble, CMC, Canada<br/>
- <b>WXSIM :</b>&nbsp;WXSIM-software runned by private weatherstations (data not available for all locations)<br/>
</div>');
define('ACCURACYMODELSDESC','La précision totale moyenne pour chaque modèle de prévisions.');

define('FMODEL','Modèle ');
define('FANIMATION','Animation');
define('FON','On');
define('FOFF','Off');

define('VILLAGES','Citys, villages');
define('ISLANDS','Islands, mountains');
define('LAKES','Lakes, bays');
define('SOLARWINDENERGY','Énergie éolienne/solaire');
define('HDD','Degrés-jour de chauffage');
define('SOLAR','Solaire');
define('SOLARWINDINFO','Ce tableau est basé sur EWN WRFDA-model. Radiation solaire : SW - onde courte, LW - onde longue. HDD - '.HDD.'.');

define('COOP','En coopération avec'); 
define('DATAPWS','Données par chaque station PWS');
define('WARNBX','Avertissements par');
define('WARNBY','pour des vigilances plus récentes visitez le site officiel de votre région'); 
define('SCRADM','Script et admin de');
define('NORES','EWN is not responsible for the accuracy of the information.<br/>Except where otherwise noted, content on this page is licensed under a');
define('SUBTITLDESC','of the temperature forecasts have last 30 days been very good or good. For more info see the <a href="frc_stats.php?'.$lang.'">statistics');
define('SEARCHLOC','Rechercher une localisation');
define('SUBTITLE','THE MOST ACCURATE WEATHERFORECASTS'); // Feel free to figure out something better, note it refers to forecast-accuracy
define('METPROV','Données fournies par');
define('PRIVATESTATION','Private');
define('METOFFICESTATION','Metoffice');
define('ROADSTATION','Route');
define('JUSTNOW','A l\'intant');
define('CLOSEOBS','Observations les plus proches');
define('TONIGHT','Ce soir');
define('WARNANDSEVERE','Vigilance et phénomènes météorologiques violents');
define('FAVORITES','Vos localités préférées');
define('SAVEFAVORITESETTINGS','Enregistrer les paramètres');
define('SAVEASFAVORITE','Ajouter aux favoris');
define('ADDEDTOFAVO','Localité ajoutée aux favoris !');
define('NOFAVORITES','Aucuns favoris enregistrés !');
define('NOWARNS','Aucunes alertes actives');
define('RADARSTRIKES','Radar &amp; foudre');
define('SNOW','Neige');
define('LEVEL','Niveau');
define('OTHER','Autre');
define('DAY','Jour');
define('COMPFRCMODEL','Comparer les modèles');
define('TSPROB','Prob. de tempête');
define('SEVERE','Intempéries');
define('SEVEREFRCTODAY','Prévisions d\'intempéries');
define('HOTCOLD','Warmest, coldest, windiest, wettest');
define('TENWARMEST','Les 10 localités les plus chaudes');
define('TENCOLDEST','Les 10 localités les plus froides');
define('WINDIEST2','Vent &gt;');
define('WETTEST2','Précip. &gt; 4 mm/h');
define('LOCATIONS','Autres localités');
define('SELECTCOUNTRY','Choisissez le pays');
define('SELECTLANGUAGE','Langue');
define('SELECTWUNIT','Unité du Vent');
define('LOCATEME','Me localiser !');
define('LOADING','Lecture...');
define('FAVORITELOCATIONS','Localités préférées');
define('HOME','Accueil');
define('FRCSTMAPS','Cartes des prévisions');
define('FRCSTVIDEOS','Vidéos des prévisions');
define('FORECASTS','Prévisions');
define('STORMFORECAST','Prévisions de tempêtes');
define('AURORAFORECAST','Prévisions d\'aurores');
define('RADAR','Radar');
define('PRECRADAR','Radar des précipitations');
define('FINLAND','Finlande');
define('SCANDINAVIA','Scandinavie');
define('EUROPE','Europe');
define('DISABLED','Désactivé');
define('STRLAST2MIN','2 dern. min.'); // Short!!
define('WEBCAMS','Webcams');
define('VHIGH','Très élevé');
define('EXTREME','Extrême');
define('WXSTATIONS','Stations météo');
define('WXSTATION','Station météo');
define('AVGERROR','Average error');
define('ROADSTATIONS','Roadweatherstations');
define('SUN','Soleil');
define('WINDRUN','Windrun');
define('WEBURL','URL du site WEB');
define('DIRECTLINK','Lien direct');
define('LOGIN','S\'identifier');
define('HAVEUV','La station a un capteur UV');
define('HAVESOLAR','La station a un capteur solaire');
define('ORTEXT','ou');
define('USERNAME','Nom d\'utilisateur');
define('FRGTPASS','Mot de passe oublié');
define('RESETPASS','Réinitialiser le mot de passe');
define('SOLARHEATED','Solarheated');
define('SOLARHEATDESC','Hours when temperature are solarheated - For disabled set -1');
define('SOLARHEATDESC2','EWN Admin keeps the right to change the solarheat-setting if needed for accuracy of the temperatures. "No shield" sets station to solarheated at daytime.');
define('BOSTATIONS','Blitzortung-stations');
define('BODESC','List your BO-stations to be visible on the BO-statuspage (no ready yet).<br/>If you have multiple stations, separate them with |, like 4566|6543.');
define('BONAME','BO station-name');
define('NEWUSERNAME','NEWUSERNAME');
define('DOWNLOADNOTE','Note! If downloads not start, right-click on the link and choose "Save as".');
define('YOULOGOUT','Vous avez été déconnecté');
define('CONTACT','Contacter');
define('CLOSE','Fermer');
$days = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
$months = array('Janv.','Févr.','Mars','Avr.','Mai','Juin','Juil.','août','Sept.','Oct.','Nov.','Déc.');
define('cookietitle','Autre');
define('cookiedescription','Settings like favorite locations use cookies. This includes also the social media plugins on the page');
define('advertisingDefaultTitle','Publicité');
define('analyticsDefaultTitle','Analytics');
define('analyticsDefaultDescription','We anonymously measure your use of this website to improve your experience.');
define('advertisingDefaultDescription','Adverts will be chosen for you, automatically based on your past behaviour and interests.');
define('notificationTitleImplicit','We use cookies to ensure you get the best experience on our website');
define('allowCookiesImplicit','Got it!');
define('savePreference','Save preference');
define('hideDetails','hide details');
define('seeDetailsImplicit','change your settings');
$boinfo.= "<br/>Rainradars are updated every 5-15 minutes with varying delay.<br/><br/>
<b>Blitzortung</b><br/>
  Blitzortung.org is a private network of lightning tracker stations with more than 1000 trackers in Europe. They catch the electromagnetic signals of strikes. Together with the time stamp the position of a strike can be calculated out of the signals (TOA - time of arrival method). You will find more information on the main site of the project: <a href='http://www.blitzortung.org' target='_blank'>www.blitzortung.org</a>.<br/>
  Accuracy of Blitzortung is quite good and is usually lower than 1 kilometer. This is equal to commercial strike detection companies and metoffices.<br/>
To participate you have to get your own relatively inexpensive receiver. With that, you can participate in the network and you will get access to all strike data";
define('WEEWXINFO','If you are using WD-plugin and upload clientraw.txt or customclientraw.txt for SteelSeries Gauges, no additional configuration is required. Choose WD or SteelSeries Gauges as software.');

# FORECAST RELATED
define('FRCWARN','Click to show the whole warning. Warnings by');
define('EWNACC','The accuracy-check compares measured temperature to the forecasted temperature for ca 500 places north of 52&deg;N up to Nordkapp in North Norway. One criteria for the choosed locations is need of a realible weatherstation (in most cases met office stations). Error-values are in absolute degrees, what means the values are allways positive. The check shows data for last 30 days.');
define('LIGHTNINGMAP','Lightningmap');
define('DAYLENGTH','Durée du jour');
define('MIDNIGHTSUN','Soleil de minuit');
define('POLARNIGHT','Nuit polaire');
define('QUICKLINKS','liens directs');
define('CLOSESTWXSTATION','Station météo la plus proche');
define('POP','PoP');
define('RANGE','Plage');
define('DAYFRC2','day weatherforecast');
define('MORE','Plus &raquo;');
define('DAILYMAP','Cartes journalières');
define('FDAYS','Jour');
define('DTOMORROW','3 jours');
define('FMAP','Carte ');
define('MAXI','Maxima');
define('MINI','Minima');
define('SEVRISK','Probabilité d\'orages');
define('LEV3','Extrêmement sévère');
define('LEV2','Intempéries');
define('TS','Risque de foudre');
define('SEVERERISK','INTEMPERIES');
define('TSRISK','Risque d\'orages');
define('SUPERCELLRISK','Risque de supercellule');
define('TORNADORISK','Risque de tornades');
define('HAILRISK','Risque de grêle');

define('CLICKINFO','Cliquez sur la carte pour obtenir les données à partir de n\'importe où !');
define('FSLEET','Grêle');
define('YOURLOCATION','Votre position actuelle');
define('FRCACCURACY','Précision de la prévision');
define('FRCACCINFO','We check the accuracy for some of the used models for a few places by checking the 12h point in the forecast.');
define('DOWNLOADED_FRC','Loaded forecasts');
define('TOTDOWNLOADED_FRC','Total loaded forecasts');
define('PLACE','Place');
define('FRCS','Prévisions');
define('LATI','Latitude');
define('LONGI','Longitude');

define('TOMORROW','Demain');
define('SUNANDMOON','Soleil et Lune');
define('UVFORECAST','Prévisions UV à 4 jours');
define('LOW','Bas');
define('MED','Moyen');
define('HIG','Elevé');
define('LOCATIONINFO','Infos sur la localité');
define('ELEVATION','Élévation');
define('POPULATION','Population');
define('FEELS','Ressentie');
define('GUST','Rafale');

define('EWNFORECAST','Prévisions EWN');
define('FRCSEARCH','Search forecast');
define('FRCSAVE','Save location');
define('FORECASTINFO','The EWN-Forecast is EWN\'s own in-house generated forecast. Its the only forecast whats generated on demand, when you query it! This means you get allways the most recent data available.<br/>The EWN-Forecast is available for ca 850000 locations trought whole Europe.');
define('FRCINFOB','The EWN Forecast use multiple free numerical models as base for the forecast. EWN are not liable for the quality and accuracy of the forecast.<br/>In addition, we do run an own run of WRFDA EMS model at 12 km resolution whats included in the data. The maps are also generated from the WRFDA EMS model.<br/><br/>
In the forecasts are content and data used from:<br/>
<a href="http://nomads.ncep.noaa.gov/" target="_blank">NCEP</a> (GFS, GEFS &amp; UV), <a href="http://weather.gc.ca" target="_blank">The Canadian Meteorological Center</a> (GEM-GDPS), <a href="http://www.met.no" target="_blank">Norwegian Meteorological Institute</a> (MET Norway), <a href="http://www.smhi.se" target="_blank">Swedish Meteorological and Hydrological Institute</a> (SMHI), <a href="http://www.fmi.fi" target="_blank">Finnish meteorological institute</a> (FMI), <a href="http://www.dwd.de" target="_blank">Deutscher Wetterdienst</a> (DWD), <a href="http://www.geonames.org" target="_blank">Geonames</a>, <a href="http://www.meteoalarm.eu" target="_blank">MeteoAlarm</a>, <span id="moresources"></span>WXSIM - near private weatherstations with the WXSIM-software.
');

define('SAVEFAVO','Position par défaut');
define('SAVEQUI','Ajouter à la recherche rapide');
define('SEARCHCOUNTRY','Pays');
define('PLACESEARCH','Recherche');
define('QUICKSEARCH','Recherche rapide');
define('OWNPLACES','Own places');

define('FORECASTFOR','Prévision pour');
define('ISSUED','Publié par');

define('SHORTFRC','Sommaire');
define('HOURFRC','Heure par heure');
define('DAYFRC','jours de prévision');
define('NERDFRC','Extras');
define('COMPFRC','Comparer');
define('MAPFRC','Cartes');

define('FGUST','Rafale de vent maxi');
define('FRATE','Taux de pluie');
define('BASEMAPS','Base carte');
define('SATELLITE','Satellite');
define('TTINFO','TS Probality: 45-50 possible, <br/>50-55 more likely, 55-60 severe likely');
define('SRHINFO','150-299 supercells possible, <br/> 300-500 supercells likely and tornados possible');
define('DBZINFO','20 light rain, <br/> 30 moderate rain, 50 heavy rain, hail');
define('KIINFO','ca 2 x K Index = Thunder probability');
define('FTEMP','Température');
define('FCHILL','Refroidissement éolien');
define('FDEW','Point de rosée');
define('FWIND','Vent');
define('FPREC','Précipitations');
define('FCLOUD','Nuages');
define('FBARO','Pression');
define('FSNOW','Neige');
define('FHAIL','Grêle');
define('FFRZ','Gel');
define('FLIG','Orage/Tonnerre');
define('FTHUN','Probabilité d\'orage');
define('FCONV','Précip. convective');
define('FINSTA','Instabilité pot.');
define('FVISIB','Visibilité');
define('FFORE','Prévisions');
define('FAVG','Moyenne');
define('FUTIMES','Heures de mise à jour');
define('FRESO','Résolution');
define('FLENGTH','Durée');
define('FSTEPS','Pas');
define('FRADAR','radar');
define('FSAT','satellite');
define('SIGHAIL','Risque de grêle');
define('SIGTOR','Risque de tornade');
define('SIGSUP','Risque de supercellule');
define('MCOMPRADAR','Radar comp. maxi');
define('SIGHAIL2','Risque important de grêle');
define('SIGTOR2','Risque important de tornade');
define('SIGSUP2','Risque important de supercellule');
define('MCOMPRADAR2','Radar composite maxi');
define('FRCCINFO','
<b>Lightning probability maps</b> - Green and yellow colors indicates lightning probability within 40 km of a point. Orange, red and violet are similar levels seen on estofex.org including also probablity for hails and supercells.<br/><br/>
<b>dBZ</b> - dBZ stands for decibels relative to Z. It is a meteorological measure of equivalent reflectivity (Z) of a radar signal reflected off a remote object
<br/><br/>
<b>Cape</b> - Convective available potential energy (CAPE), sometimes, simply, available potential energy (APE), is the amount of energy a parcel of air would have if lifted a certain distance vertically through the atmosphere.
<br/><br/>
<b>K Index</b> - K-Index is a measure of the thunderstorm potential based on vertical temperature lapse rate, moisture content of the lower atmosphere, and the vertical extent of the moist layer.
<br/><br/>
<b>TT Index</b> - Convective index used for forecasting severe weather.
<br/><br/>
<b>WRF</b> - The Weather Research and Forecasting (WRF) is a next-generation mesocale numerical weather prediction system designed to serve both operational forecasting and atmospheric research needs. WRF is a cooperation between National Center for Atmospheric Research (NCAR), National Centers for Environmental Prediction (NCEP), Forecast Systems Laboratory (FSL), Air Force Weather Agency (AFWA), Naval Research Laboratory, University of Oklahoma, and the Federal Aviation Administration (FAA). This software are runned on our server.
<br/><br/>
<b>WRFDA</b> - A more advanced version of WRF<br/><br/>
<b>Arome</b> - The 2.5 km Arome model. Provided by Norwegian Meteorological Institute.
<br/><br/>
<b>MET Norway</b> - The proff-default 4km meteorological data is a best-guess selection of meteorological models run at met.no and joined/interpolated into a common dataset. Provided by Norwegian Meteorological Institute.
<br/><br/>
<b>SMHI</b> - The Hirlam model provided by Swedish meteorological institute.
<br/><br/>
<b>FMI</b> - The Hirlam model provided by Finnish meteorological institute. Covering only Finland.
<br/><br/>
<b>GFS</b> - The Global Forecast System (GFS) is a global numerical weather prediction computer model run by NOAA.
<br/><br/>
<b>GEM-GDPS</b> - The GEM-GDPS is a global numerical weather prediction computer model run by the  Canadian Meteorological Centre.
<br/><br/>
<span style="color:#888"><b>Credits/Info:</b> Thanks to Stefan Gofferje at <a href="http://www.saakeskus.fi" target="_blank">s&auml;&auml;keskus.fi</a> for some of the formulas for GrADS. Infos: Wikipedia.</span>');
define('SHOWADV','Show advanced');
define('FPRECTYP','Type de précipitations');
define('FSNOWD','Hauteur de neige');
define('FRAIN','Pluie');
define('FTMPSFC','Température de surface');
define('FACCUM','Cumul des précipitations');
define('FHUM','Humidité');
define('FFEELS','Ressentie');
define('FTODAY','Aujourd\'hui');
define('FTOMOZ','Demain');

$days = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
$daynames = '"Dim", "Lun", "Mar", "Mer", "Jeu", "Ven", "Sam","Di", "Lu", "Ma", "Me", "Je", "Ve", "Sa"';

################################################

define('CURRCOND','Conditions actuelles');
define('METEXT','Met. Institutes');
define('ROADEXT','Road-stations');
define('SOUTH','Sud');
define('WEST','Ouest');
define('NORTH','Nord');
define('EAST','Est');
define('MIDDLE','Central');
define('YRSTATIONS','met.no stations');
define('SYNOPSTATIONS','Synop-stations');
define('METINFO','Met. Institutes - The local meteorologic institutes stations.');
define('ROADINFO','Partly cloudy = Dry weather.');
define('ROADWX','Roadweather');
define('FITRAFNAME','Finnish Road Administration');
define('SVTRAFNAME','Swedish Road Administration');
define('PWSWX','PWS');
define('PWSSTATIONS','stations PWS');
define('STSTATS','Statistiques');
define('STATION','Station');
define('CHOOSECOUNTRY','Changer de pays');
define('CHOOSESTATION','Choisir une station');
define('SUBMIT','Valider');
define('SINGLESTATION','Station simple');
define('COMPARE','Comparer');
define('EXTRAMAP','Special layers');
define('SNOWCOVER','Snowcover');
define('ICECOVER','Icecover');
define('SEATEMP','Seatemperature');
define('SNOWDEPTH','Snowdepth');
define('TERRAIN','Terrain');
define('STRIKES','Foudre');
define('MINUTES','minutes');
define('GUSTINGTO','Gusting to');
define('SAVESETTINGS','Save as default');
define('APPARENT','Feels like');
define('STATIONDATA','Stationdata');
define('WARNINGSIN','warnings in');
define('CLICKONWARN','Click on the areaname to show the warning.');
define('CURREXTREMES','Current extremes');

define('SETTINGS','Paramètres');
define('STATS','Statistiques');
define('STATSFOR','Statistiques de European Weather Network');
define('STSPERCOUNTRY','Stations/Pays');
define('NORTHERNMOST','Northernmost/Southernmost etc');
define('NEWEST','newest stations');
define('MAPLOADS','Maploads');
define('MISC','Divers');

define('LIGHT','Clair');
define('DARK','Foncé');
define('BASEMAP','Base carte');
define('TYPE','Type');
define('DATA','Données');
define('WINRUN','Parcours du vent');
define('RRATE','Taux de pluie');

define('ACTIVEALARMS','avertissements actifs');
define('ACTIVETRACKERS','les traqueurs ont détecté des tempêtes');
define('PWS','Private');
define('SYNOP','Synop/Metar');
define('NAUTRAL','Naturel');
define('NIGHTVIEW','Nightview');
define('BLUEVIEW','Blueview');
define('BWTXT','Blank & white');
define('SATELLITE','Satellite');
define('SEAWARN','Seawarnings');
define('MALARMWARN','Landwarnings');
define('SEAICE','Seadata');
define('ICE','Ice');

define('MAP','Carte');
define('WXSIMFRCST','Prévisions WXSIM à 5 jours');
define('WXSIMINFO','Stations own forecast made with WXSIM-software');
define('FRCST','Prévisions à 48 heures');
define('HIDE','Cacher');
define('TOPLISTS','Top Listes');
define('TABLES','Tableaux');
define('INFO','Info');
define('BALTIC','Baltic');
define('MOREWEATHER1','Plus d\'infos météo');
define('IHAVENOTWXSTATION','Je n\'ai pas de station météo');
define('YOURINFO','Vos infos');
define('PICKCOORDS','Trouver les coordonnées sur la carte');
define('PASSW','Mot de passe');
define('DEFLOC','Emplacement par défaut');
define('SAVE','Sauvegarder');
define('STATIONLESS','Manuelle');
define('SAVED','Sauvergardé');
define('EXTREMECOLDBOX','Il fait exceptionnellement froid sur les stations suivantes');
define('EXTREMEHOTBOX','Il fait exceptionnellement chaud sur les stations suivante');

// Main
define('LEGEND', 'Légende');
define('WEATHER', 'Météo');
define('WEBCAM', 'Webcam');
define('LIGHTNING', 'Lightning');
define('SNOWNOTE', '<b>*A Noter !</b> Toutes les stations ne signalent pas les hauteurs de neige.');
define('NOCOND', 'Aucun rapport actuel des conditions');
define('LOCALTIME', 'Heure locale');
define('STATIONS', 'Stations');
define('CLICKFORINFO', 'Cliquez pour plus d\'infos sur comment nous rejoindre !');
define('TODAY', 'Aujourd\'hui');
define('ALLTIME', 'Tout le temps');
define('FORECAST', 'Prévisions');
define('ROAD','Route');
define('WX','Wx');
define('POUTA','Dry');
define('LPRECIP','Précip. légère');
define('MPRECIP','Précip. modérée');
define('HPRECIP','Précip. forte');
define('DRY','Dry');
define('WET','Wet');
define('ICY','Icy');
define('SNOWY','Snowy');
define('SLIPPERY','Poss. slippery');
define('LAYER','Couche');
define('REPSNOW','Rep.');
define('ALLCOUT','Tous les pays');

define('COORDS','Coordonnées');
define('NOCAM','La station n\'a pas de caméra');
define('SYNPRODBY','Synop/Metar-data produit par');
define('ROADPRODBY','Tiesää-data produit par');
define('SGRAPHHEAD','Dernières 24 heures');
define('MOREGRAPH','Plus de graphiques');
define('MAPSETTINGS','Mapsettings');
define('WARMCOLD','Plus chaud/Plus froid');
define('DATACOUNTER','Datacounter');
define('STARTED','Started');
define('JOINUS','Rejoignez-nous');
define('MEMBERAREA','Espace membre');
define('WAIT','Lecture...');
define('GRAPH','Graphiques');
define('DAYS','Jours');
define('THUNDER','Tonnerre/Orage');
define('SHOWICON','Icônes');
define('SHOWSTATION','Stations');

// V5
$txtcolors = array('Jaune','Orange','Rouge');
$txttypes = array('Wind','Snow/Ice','Thunderstorms','Fog','Extreme high temperature','Extreme low temperature','Coastal Event','Forestfire','Avalanches','Rain');
define('DISTANCE', 'Distance');
define('AWLEVEL', 'Niveau d\'alerte');
define('VALID','Validé');
define('NWNDISCL','<br/>EWN n\'est pas responsable de l\'exactitude de l\'information.');


define('ALT', 'Alt');
define('HOMEPAGE', 'Homepage');
define('HERE', 'here');
define('CONDITIONS', 'Conditions');
define('FCST', 'Prévision');
define('NOTHUNDER', 'No thunderstorms detected');
define('FEATB', 'Station');
define('WINDBOX', 'Gale force winds are detected at following stations (> 22 m/s)');
define('SUMMERFROSTBOX', 'Frost are detected on following stations');
define('WARN', 'Warnings');

// NEW
define('SYNEXT', 'Synop-stations');
define('ROADSTS', 'Roadwx');
define('TIME', 'Time');
define('WEBCAMS', 'Webcams');
define('LIGHTNINGS', 'Détecteur de foudre');
define('OPTIONS', 'Options');
define('COND', 'Conditions');
define('DIR', 'Direction');
define('RRADAR', 'Radar de pluie');
define('STATIONSS', ' stations');
define('CALM', 'Calme');
define('DEWP', 'Point de rosée');
define('CCOVER', 'Couverture nuageuse');
define('VISIB', 'Visibilité');
define('NOOBS', 'Aucune observation');
define('SHOW', 'Afficher');

define('WCHILL', 'Refroidissement éolien');
define('HEAT', 'Indice de chaleur');
define('TRACA', 'Détection');
define('TRACB', 'orages');
define('TRACBOX' , 'Following stations stormtrackers track thunderstorms at the moment');
define('BOXPRTB', '');

// NEW
define('NOPE', 'Non');
define('YES', 'Oui');
define('', '');

// MISC

define('TOPMISC', 'Données diverses');
define('NORTHMST', 'Northernmost');
define('SOUTHMST', 'Southernmost');
define('WESTMST', 'Westernmost');
define('EASTMST', 'Easternmost');
define('HIGHMST', 'Highest');
define('LOWMST', 'Lowest');
define('CAMS', 'Webcams');
define('TRACKERS', 'Stormtrackers');


// BALLOONS
define('TRACKER', 'Stormtracker');
define('NORAIN', 'Pas de précip. aujourd\'hui');
define('RAIN', 'Précip.');
define('SNOWD', 'Snowdepth');
define('WIND', 'Vent');
define('WINDFROM', 'Vent de');
define('HUMI', 'Humidité');
define('BARO', 'Pression');
define('NOFRAME', 'Your browser does not support inline frames or is currently configured not to display inline frames.');
define('CURRHEAD', 'Current conditions at member stations of the European Weather Network');
define('POLARN', 'Nuit polaire');
define('MIDNIGHTS', 'Soleil de minuit');

// TABLEHEADER
define('FEAT', 'Station/<br/>Altitude');
define('CURHEAD', 'Cond.<br />Act.');
define('TEMP', 'Température');
define('HUM', 'Humidité');
define('AVG', 'Vent moy.');
define('PRECIPS', 'Précip.');
define('BAROB', 'Pression');
define('SNOB', 'Neige');
define('TXTGUST', 'Rafale');

// TOPLISTS
define('TOPHEAD', 'Top 10 des observations de European Weather Network');
define('MAXTEMP', 'Température maxi');
define('MINTEMP', 'Température mini');
define('MAXAVGW', 'Vent moy. maxi');
define('PRECIP', 'Précipitation');
define('MAXHUMI', 'Humidex maxi');
define('MINCHILL', 'Ressenti mini');
define('MAXGUSTW', 'Rafale maxi');
define('CURRAVG', 'Moyennes actuelles');
define('DAILYPREC', 'Précipitations journalières');
define('TOTPREC', 'Total des précipitations');
define('TXTGUST', 'Rafale');

define('NOSTORMS', 'Aucun orages détectés');
define('TRACA', 'Détection');
define('TRACB', 'orages');


function defcountries($rawc) {
return $rawc;
}

function defmonths($rawf) {
$txtmon =  array(  
'January' => 'Janvier',
'February' => 'Février',
'March' => 'Mars',
'April' => 'Avril',
'May' => 'Mai',
'June' => 'Juin',
'July' => 'Juillet',
'August' => 'Août',
'September' => 'Septembre',
'October' => 'Octobre',
'November' => 'Novembre',
'December' => 'Décembre'
);
$txtmonth = $txtmon[$rawf];
return $txtmonth;
}

?>